/* user.c generated by valac 0.56.14, the Vala compiler
 * generated from user.vala, do not modify */

/* Copyright (C) 2013, 2014 Canonical Ltd.
 * Author: Colin Watson <cjwatson@ubuntu.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/* Registry of user-installed Click packages.
 * 
 * Click packages are installed into per-package/version directories, so it
 * is quite feasible for more than one version of a given package to be
 * installed at once, allowing per-user installations; for instance, one
 * user of a tablet may be uncomfortable with granting some new permission
 * to an app, but another may be just fine with it.  To make this useful, we
 * also need a registry of which users have which versions of each package
 * installed.
 * 
 * We might have chosen to use a proper database.  However, a major goal of
 * Click packages is extreme resilience; we must never get into a situation
 * where some previous error in package installation or removal makes it
 * hard for the user to install or remove other packages.  Furthermore, the
 * simpler application execution can be the better.  So, instead, we use
 * just about the simplest "database" format imaginable: a directory of
 * symlinks per user.
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include "click.h"
#include <glib/gstdio.h>
#include <errno.h>
#include <sys/types.h>
#include <unistd.h>
#include <pwd.h>
#include <gee.h>
#include <sys/stat.h>
#include <json-glib/json-glib.h>

#define CLICK_ALL_USERS "@all"
#define CLICK_GC_IN_USE_USER "@gcinuse"
#define CLICK_HIDDEN_VERSION "@hidden"

#define CLICK_TYPE_LOGIND_USER (click_logind_user_get_type ())
typedef struct _ClickLogindUser ClickLogindUser;
#define _g_free0(var) (var = (g_free (var), NULL))

#define CLICK_TYPE_LOGIND_MANAGER (click_logind_manager_get_type ())
#define CLICK_LOGIND_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CLICK_TYPE_LOGIND_MANAGER, ClickLogindManager))
#define CLICK_IS_LOGIND_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CLICK_TYPE_LOGIND_MANAGER))
#define CLICK_LOGIND_MANAGER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), CLICK_TYPE_LOGIND_MANAGER, ClickLogindManagerIface))

typedef struct _ClickLogindManager ClickLogindManager;
typedef struct _ClickLogindManagerIface ClickLogindManagerIface;

#define CLICK_TYPE_LOGIND_MANAGER_PROXY (click_logind_manager_proxy_get_type ())
typedef GDBusProxy ClickLogindManagerProxy;
typedef GDBusProxyClass ClickLogindManagerProxyClass;

#define CLICK_TYPE_AS_USER (click_as_user_get_type ())
#define CLICK_AS_USER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CLICK_TYPE_AS_USER, ClickASUser))
#define CLICK_IS_AS_USER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CLICK_TYPE_AS_USER))
#define CLICK_AS_USER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), CLICK_TYPE_AS_USER, ClickASUserIface))

typedef struct _ClickASUser ClickASUser;
typedef struct _ClickASUserIface ClickASUserIface;

#define CLICK_TYPE_AS_USER_PROXY (click_as_user_proxy_get_type ())
typedef GDBusProxy ClickASUserProxy;
typedef GDBusProxyClass ClickASUserProxyClass;

#define CLICK_TYPE_CACHED_PASSWD (click_cached_passwd_get_type ())
#define CLICK_CACHED_PASSWD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CLICK_TYPE_CACHED_PASSWD, ClickCachedPasswd))
#define CLICK_CACHED_PASSWD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CLICK_TYPE_CACHED_PASSWD, ClickCachedPasswdClass))
#define CLICK_IS_CACHED_PASSWD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CLICK_TYPE_CACHED_PASSWD))
#define CLICK_IS_CACHED_PASSWD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CLICK_TYPE_CACHED_PASSWD))
#define CLICK_CACHED_PASSWD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CLICK_TYPE_CACHED_PASSWD, ClickCachedPasswdClass))

typedef struct _ClickCachedPasswd ClickCachedPasswd;
typedef struct _ClickCachedPasswdClass ClickCachedPasswdClass;
typedef struct _ClickCachedPasswdPrivate ClickCachedPasswdPrivate;
enum  {
	CLICK_CACHED_PASSWD_0_PROPERTY,
	CLICK_CACHED_PASSWD_NUM_PROPERTIES
};
static GParamSpec* click_cached_passwd_properties[CLICK_CACHED_PASSWD_NUM_PROPERTIES];
enum  {
	CLICK_USERS_0_PROPERTY,
	CLICK_USERS_DB_PROPERTY,
	CLICK_USERS_NUM_PROPERTIES
};
static GParamSpec* click_users_properties[CLICK_USERS_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define CLICK_DIR_TYPE_ITERATOR (click_dir_iterator_get_type ())
#define CLICK_DIR_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CLICK_DIR_TYPE_ITERATOR, ClickDirIterator))
#define CLICK_DIR_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CLICK_DIR_TYPE_ITERATOR, ClickDirIteratorClass))
#define CLICK_DIR_IS_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CLICK_DIR_TYPE_ITERATOR))
#define CLICK_DIR_IS_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CLICK_DIR_TYPE_ITERATOR))
#define CLICK_DIR_ITERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CLICK_DIR_TYPE_ITERATOR, ClickDirIteratorClass))

typedef struct _ClickDirIterator ClickDirIterator;
typedef struct _ClickDirIteratorClass ClickDirIteratorClass;
enum  {
	CLICK_USER_0_PROPERTY,
	CLICK_USER_DB_PROPERTY,
	CLICK_USER_NAME_PROPERTY,
	CLICK_USER_IS_PSEUDO_USER_PROPERTY,
	CLICK_USER_IS_GC_IN_USE_PROPERTY,
	CLICK_USER_NUM_PROPERTIES
};
static GParamSpec* click_user_properties[CLICK_USER_NUM_PROPERTIES];
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))
#define _json_array_unref0(var) ((var == NULL) ? NULL : (var = (json_array_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ClickLogindUser {
	guint32 uid;
	gchar* name;
	gchar* ObjectPath;
};

struct _ClickLogindManagerIface {
	GTypeInterface parent_iface;
	ClickLogindUser* (*ListUsers) (ClickLogindManager* self, gint* result_length1, GError** error);
};

struct _ClickASUserIface {
	GTypeInterface parent_iface;
	gboolean (*get_system_account) (ClickASUser* self);
};

struct _ClickCachedPasswd {
	GObject parent_instance;
	ClickCachedPasswdPrivate * priv;
	uid_t uid;
	gid_t gid;
};

struct _ClickCachedPasswdClass {
	GObjectClass parent_class;
};

struct _ClickUsersPrivate {
	ClickDB* _db;
	ClickCachedPasswd* click_pw;
};

struct _ClickUserPrivate {
	ClickDB* _db;
	gchar* _name;
	ClickUsers* users;
	ClickCachedPasswd* user_pw;
	gint dropped_privileges_count;
	mode_t* old_umask;
};

static gpointer click_cached_passwd_parent_class = NULL;
static gint ClickUsers_private_offset;
static gpointer click_users_parent_class = NULL;
static gint ClickUser_private_offset;
static gpointer click_user_parent_class = NULL;

VALA_EXTERN GType click_logind_user_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ClickLogindUser* click_logind_user_dup (const ClickLogindUser* self);
VALA_EXTERN void click_logind_user_free (ClickLogindUser* self);
VALA_EXTERN void click_logind_user_copy (const ClickLogindUser* self,
                             ClickLogindUser* dest);
VALA_EXTERN void click_logind_user_destroy (ClickLogindUser* self);
VALA_EXTERN GType click_logind_manager_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint click_logind_manager_register_object (void* object,
                                            GDBusConnection* connection,
                                            const gchar* path,
                                            GError** error);
VALA_EXTERN GType click_logind_manager_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ClickLogindUser* click_logind_manager_ListUsers (ClickLogindManager* self,
                                                 gint* result_length1,
                                                 GError** error);
static GType click_logind_manager_get_type_once (void);
static void click_logind_manager_proxy_g_signal (GDBusProxy* proxy,
                                          const gchar* sender_name,
                                          const gchar* signal_name,
                                          GVariant* parameters);
static ClickLogindUser* click_logind_manager_proxy_ListUsers (ClickLogindManager* self,
                                                       gint* result_length1,
                                                       GError** error);
static void click_logind_manager_proxy_click_logind_manager_interface_init (ClickLogindManagerIface* iface);
static void _vala_ClickLogindUser_array_free (ClickLogindUser * array,
                                       gssize array_length);
static void _dbus_click_logind_manager_ListUsers (ClickLogindManager* self,
                                           GVariant* _parameters_,
                                           GDBusMethodInvocation* invocation);
static void click_logind_manager_dbus_interface_method_call (GDBusConnection* connection,
                                                      const gchar* sender,
                                                      const gchar* object_path,
                                                      const gchar* interface_name,
                                                      const gchar* method_name,
                                                      GVariant* parameters,
                                                      GDBusMethodInvocation* invocation,
                                                      gpointer user_data);
static GVariant* click_logind_manager_dbus_interface_get_property (GDBusConnection* connection,
                                                            const gchar* sender,
                                                            const gchar* object_path,
                                                            const gchar* interface_name,
                                                            const gchar* property_name,
                                                            GError** error,
                                                            gpointer user_data);
static gboolean click_logind_manager_dbus_interface_set_property (GDBusConnection* connection,
                                                           const gchar* sender,
                                                           const gchar* object_path,
                                                           const gchar* interface_name,
                                                           const gchar* property_name,
                                                           GVariant* value,
                                                           GError** error,
                                                           gpointer user_data);
static void _click_logind_manager_unregister_object (gpointer user_data);
VALA_EXTERN GType click_as_user_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType click_as_user_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint click_as_user_register_object (void* object,
                                     GDBusConnection* connection,
                                     const gchar* path,
                                     GError** error);
VALA_EXTERN gboolean click_as_user_get_system_account (ClickASUser* self);
static GType click_as_user_get_type_once (void);
static void click_as_user_proxy_g_signal (GDBusProxy* proxy,
                                   const gchar* sender_name,
                                   const gchar* signal_name,
                                   GVariant* parameters);
static gboolean click_as_user_dbus_proxy_get_system_account (ClickASUser* self);
static void click_as_user_proxy_click_as_user_interface_init (ClickASUserIface* iface);
static void click_as_user_dbus_interface_method_call (GDBusConnection* connection,
                                               const gchar* sender,
                                               const gchar* object_path,
                                               const gchar* interface_name,
                                               const gchar* method_name,
                                               GVariant* parameters,
                                               GDBusMethodInvocation* invocation,
                                               gpointer user_data);
static GVariant* click_as_user_dbus_interface_get_property (GDBusConnection* connection,
                                                     const gchar* sender,
                                                     const gchar* object_path,
                                                     const gchar* interface_name,
                                                     const gchar* property_name,
                                                     GError** error,
                                                     gpointer user_data);
static GVariant* _dbus_click_as_user_get_system_account (ClickASUser* self);
static gboolean click_as_user_dbus_interface_set_property (GDBusConnection* connection,
                                                    const gchar* sender,
                                                    const gchar* object_path,
                                                    const gchar* interface_name,
                                                    const gchar* property_name,
                                                    GVariant* value,
                                                    GError** error,
                                                    gpointer user_data);
static void _click_as_user_unregister_object (gpointer user_data);
VALA_EXTERN gchar* click_db_top (const gchar* root);
VALA_EXTERN gchar* click_db_for_user (const gchar* root,
                          const gchar* user);
VALA_EXTERN void click_try_create (const gchar* path,
                       GError** error);
VALA_EXTERN GType click_cached_passwd_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ClickCachedPasswd* click_cached_passwd_new (uid_t uid,
                                            gid_t gid);
VALA_EXTERN ClickCachedPasswd* click_cached_passwd_construct (GType object_type,
                                                  uid_t uid,
                                                  gid_t gid);
static void click_cached_passwd_finalize (GObject * obj);
static GType click_cached_passwd_get_type_once (void);
VALA_EXTERN void click_try_chown (const gchar* path,
                      ClickCachedPasswd* pw,
                      GError** error);
static ClickCachedPasswd* click_users_get_click_pw (ClickUsers* self,
                                             GError** error);
VALA_EXTERN void click_users_ensure_db (ClickUsers* self,
                            GError** error);
static ClickDB* click_users_get_db (ClickUsers* self);
VALA_EXTERN gboolean click_exists (const gchar* path);
static void _g_free0_ (gpointer var);
static inline void _g_list_free__g_free0_ (GList* self);
VALA_EXTERN GType click_dir_iterator_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ClickDirIterator* click_dir_iterator (ClickDir* self);
VALA_EXTERN const gchar* click_dir_iterator_next_value (ClickDirIterator* self);
VALA_EXTERN gboolean click_is_dir (const gchar* path);
static void click_users_finalize (GObject * obj);
static GType click_users_get_type_once (void);
static void _vala_click_users_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_click_users_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static ClickUser* click_user_new (ClickDB* db,
                           const gchar* name,
                           GError** error);
static ClickUser* click_user_construct (GType object_type,
                                 ClickDB* db,
                                 const gchar* name,
                                 GError** error);
static ClickCachedPasswd* click_user_get_user_pw (ClickUser* self,
                                           GError** error);
static const gchar* click_user_get_name (ClickUser* self);
static ClickDB* click_user_get_db (ClickUser* self);
static void click_user_ensure_db (ClickUser* self,
                           GError** error);
static void click_user_priv_drop_failure (ClickUser* self,
                                   const gchar* name,
                                   GError** error);
VALA_EXTERN void click_user_drop_privileges (ClickUser* self,
                                 GError** error);
static mode_t* _mode_t_dup (mode_t* self);
static void click_user_priv_regain_failure (ClickUser* self,
                                     const gchar* name);
VALA_EXTERN void click_user_regain_privileges (ClickUser* self);
static gboolean click_user_is_valid_link (ClickUser* self,
                                   const gchar* path);
VALA_EXTERN gboolean click_is_symlink (const gchar* path);
static GList* click_user_get_package_names_dropped (ClickUser* self,
                                             GError** error);
VALA_EXTERN void click_user_raw_set_version (ClickUser* self,
                                 const gchar* package,
                                 const gchar* version,
                                 GError** error);
static void click_user_run_user_install_hooks_for_all_logged_in_users (ClickUser* self,
                                                                const gchar* package,
                                                                const gchar* old_version,
                                                                const gchar* version,
                                                                GError** error);
static gchar** click_user_get_logged_in_users (ClickUser* self,
                                        gint* result_length1);
static void _vala_array_add12 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void click_user_run_user_remove_hooks_for_all_logged_in_users (ClickUser* self,
                                                               const gchar* package,
                                                               const gchar* old_version,
                                                               GError** error);
static gchar* click_user_get_dbus_session_bus_env_for_current_user (ClickUser* self);
static gboolean click_user_stop_single_app (ClickUser* self,
                                     const gchar* app_id);
static void _vala_array_add13 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static gboolean click_user_stop_running_apps_for_package (ClickUser* self,
                                                   const gchar* package,
                                                   const gchar* version);
static void click_user_package_remove_user_cache (ClickUser* self,
                                           const gchar* package,
                                           GError** error);
static void _vala_JsonNode_free (JsonNode* self);
static void click_user_finalize (GObject * obj);
static GType click_user_get_type_once (void);
static void _vala_click_user_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);
static void _vala_click_user_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static const GDBusArgInfo _click_logind_manager_dbus_arg_info_ListUsers_result = {-1, "result", "a(uss)", NULL};
static const GDBusArgInfo * const _click_logind_manager_dbus_arg_info_ListUsers_in[] = {NULL};
static const GDBusArgInfo * const _click_logind_manager_dbus_arg_info_ListUsers_out[] = {&_click_logind_manager_dbus_arg_info_ListUsers_result, NULL};
static const GDBusMethodInfo _click_logind_manager_dbus_method_info_ListUsers = {-1, "ListUsers", (GDBusArgInfo **) (&_click_logind_manager_dbus_arg_info_ListUsers_in), (GDBusArgInfo **) (&_click_logind_manager_dbus_arg_info_ListUsers_out), NULL};
static const GDBusMethodInfo * const _click_logind_manager_dbus_method_info[] = {&_click_logind_manager_dbus_method_info_ListUsers, NULL};
static const GDBusSignalInfo * const _click_logind_manager_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo * const _click_logind_manager_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _click_logind_manager_dbus_interface_info = {-1, "org.freedesktop.login1.Manager", (GDBusMethodInfo **) (&_click_logind_manager_dbus_method_info), (GDBusSignalInfo **) (&_click_logind_manager_dbus_signal_info), (GDBusPropertyInfo **) (&_click_logind_manager_dbus_property_info), NULL};
static const GDBusInterfaceVTable _click_logind_manager_dbus_interface_vtable = {click_logind_manager_dbus_interface_method_call, click_logind_manager_dbus_interface_get_property, click_logind_manager_dbus_interface_set_property};
static const GDBusMethodInfo * const _click_as_user_dbus_method_info[] = {NULL};
static const GDBusSignalInfo * const _click_as_user_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo _click_as_user_dbus_property_info_system_account = {-1, "SystemAccount", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo * const _click_as_user_dbus_property_info[] = {&_click_as_user_dbus_property_info_system_account, NULL};
static const GDBusInterfaceInfo _click_as_user_dbus_interface_info = {-1, "org.freedesktop.Accounts.User", (GDBusMethodInfo **) (&_click_as_user_dbus_method_info), (GDBusSignalInfo **) (&_click_as_user_dbus_signal_info), (GDBusPropertyInfo **) (&_click_as_user_dbus_property_info), NULL};
static const GDBusInterfaceVTable _click_as_user_dbus_interface_vtable = {click_as_user_dbus_interface_method_call, click_as_user_dbus_interface_get_property, click_as_user_dbus_interface_set_property};

void
click_logind_user_copy (const ClickLogindUser* self,
                        ClickLogindUser* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
#line 39 "user.vala"
	(*dest).uid = (*self).uid;
#line 39 "user.vala"
	_tmp0_ = (*self).name;
#line 39 "user.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 39 "user.vala"
	_g_free0 ((*dest).name);
#line 39 "user.vala"
	(*dest).name = _tmp1_;
#line 39 "user.vala"
	_tmp2_ = (*self).ObjectPath;
#line 39 "user.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 39 "user.vala"
	_g_free0 ((*dest).ObjectPath);
#line 39 "user.vala"
	(*dest).ObjectPath = _tmp3_;
#line 433 "user.c"
}

void
click_logind_user_destroy (ClickLogindUser* self)
{
#line 41 "user.vala"
	_g_free0 ((*self).name);
#line 42 "user.vala"
	_g_free0 ((*self).ObjectPath);
#line 443 "user.c"
}

ClickLogindUser*
click_logind_user_dup (const ClickLogindUser* self)
{
	ClickLogindUser* dup;
#line 39 "user.vala"
	dup = g_new0 (ClickLogindUser, 1);
#line 39 "user.vala"
	click_logind_user_copy (self, dup);
#line 39 "user.vala"
	return dup;
#line 456 "user.c"
}

void
click_logind_user_free (ClickLogindUser* self)
{
#line 39 "user.vala"
	click_logind_user_destroy (self);
#line 39 "user.vala"
	g_free (self);
#line 466 "user.c"
}

static GType
click_logind_user_get_type_once (void)
{
	GType click_logind_user_type_id;
	click_logind_user_type_id = g_boxed_type_register_static ("ClickLogindUser", (GBoxedCopyFunc) click_logind_user_dup, (GBoxedFreeFunc) click_logind_user_free);
	return click_logind_user_type_id;
}

GType
click_logind_user_get_type (void)
{
	static volatile gsize click_logind_user_type_id__once = 0;
	if (g_once_init_enter (&click_logind_user_type_id__once)) {
		GType click_logind_user_type_id;
		click_logind_user_type_id = click_logind_user_get_type_once ();
		g_once_init_leave (&click_logind_user_type_id__once, click_logind_user_type_id);
	}
	return click_logind_user_type_id__once;
}

ClickLogindUser*
click_logind_manager_ListUsers (ClickLogindManager* self,
                                gint* result_length1,
                                GError** error)
{
	ClickLogindManagerIface* _iface_;
#line 48 "user.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 48 "user.vala"
	_iface_ = CLICK_LOGIND_MANAGER_GET_INTERFACE (self);
#line 48 "user.vala"
	if (_iface_->ListUsers) {
#line 48 "user.vala"
		return _iface_->ListUsers (self, result_length1, error);
#line 503 "user.c"
	}
#line 48 "user.vala"
	return NULL;
#line 507 "user.c"
}

static void
click_logind_manager_default_init (ClickLogindManagerIface * iface,
                                   gpointer iface_data)
{
}

static GType
click_logind_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ClickLogindManagerIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) click_logind_manager_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType click_logind_manager_type_id;
	click_logind_manager_type_id = g_type_register_static (G_TYPE_INTERFACE, "ClickLogindManager", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (click_logind_manager_type_id, G_TYPE_OBJECT);
	g_type_set_qdata (click_logind_manager_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) click_logind_manager_proxy_get_type);
	g_type_set_qdata (click_logind_manager_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.freedesktop.login1.Manager");
	g_type_set_qdata (click_logind_manager_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_click_logind_manager_dbus_interface_info));
	g_type_set_qdata (click_logind_manager_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) click_logind_manager_register_object);
	return click_logind_manager_type_id;
}

GType
click_logind_manager_get_type (void)
{
	static volatile gsize click_logind_manager_type_id__once = 0;
	if (g_once_init_enter (&click_logind_manager_type_id__once)) {
		GType click_logind_manager_type_id;
		click_logind_manager_type_id = click_logind_manager_get_type_once ();
		g_once_init_leave (&click_logind_manager_type_id__once, click_logind_manager_type_id);
	}
	return click_logind_manager_type_id__once;
}

G_DEFINE_TYPE_EXTENDED (ClickLogindManagerProxy, click_logind_manager_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (CLICK_TYPE_LOGIND_MANAGER, click_logind_manager_proxy_click_logind_manager_interface_init) )
static void
click_logind_manager_proxy_class_init (ClickLogindManagerProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = click_logind_manager_proxy_g_signal;
}

static void
click_logind_manager_proxy_g_signal (GDBusProxy* proxy,
                                     const gchar* sender_name,
                                     const gchar* signal_name,
                                     GVariant* parameters)
{
}

static void
click_logind_manager_proxy_init (ClickLogindManagerProxy* self)
{
	g_dbus_proxy_set_interface_info (G_DBUS_PROXY (self), (GDBusInterfaceInfo *) (&_click_logind_manager_dbus_interface_info));
}

static ClickLogindUser*
click_logind_manager_proxy_ListUsers (ClickLogindManager* self,
                                      gint* result_length1,
                                      GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	ClickLogindUser* _result = NULL;
	gint _result_length1;
	GVariant* _tmp0_;
	ClickLogindUser* _tmp1_;
	gint _tmp1__length;
	gint _tmp1__size;
	gint _tmp1__length1;
	GVariantIter _tmp2_;
	GVariant* _tmp3_;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.freedesktop.login1.Manager", "ListUsers");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_result_length1 = 0;
	_tmp0_ = g_variant_iter_next_value (&_reply_iter);
	_tmp1_ = g_new (ClickLogindUser, 5);
	_tmp1__length = 0;
	_tmp1__size = 4;
	_tmp1__length1 = 0;
	g_variant_iter_init (&_tmp2_, _tmp0_);
	for (; (_tmp3_ = g_variant_iter_next_value (&_tmp2_)) != NULL; _tmp1__length1++) {
		ClickLogindUser _tmp4_;
		GVariantIter _tmp5_;
		GVariant* _tmp6_;
		GVariant* _tmp7_;
		GVariant* _tmp8_;
		if (_tmp1__size == _tmp1__length) {
			_tmp1__size = 2 * _tmp1__size;
			_tmp1_ = g_renew (ClickLogindUser, _tmp1_, _tmp1__size + 1);
		}
		g_variant_iter_init (&_tmp5_, _tmp3_);
		_tmp6_ = g_variant_iter_next_value (&_tmp5_);
		_tmp4_.uid = g_variant_get_uint32 (_tmp6_);
		g_variant_unref (_tmp6_);
		_tmp7_ = g_variant_iter_next_value (&_tmp5_);
		_tmp4_.name = g_variant_dup_string (_tmp7_, NULL);
		g_variant_unref (_tmp7_);
		_tmp8_ = g_variant_iter_next_value (&_tmp5_);
		_tmp4_.ObjectPath = g_variant_dup_string (_tmp8_, NULL);
		g_variant_unref (_tmp8_);
		_tmp1_[_tmp1__length++] = _tmp4_;
		g_variant_unref (_tmp3_);
	}
	_result_length1 = _tmp1__length1;
	_result = _tmp1_;
	g_variant_unref (_tmp0_);
	*result_length1 = _result_length1;
	g_object_unref (_reply_message);
	return _result;
}

static void
click_logind_manager_proxy_click_logind_manager_interface_init (ClickLogindManagerIface* iface)
{
	iface->ListUsers = click_logind_manager_proxy_ListUsers;
}

static void
_vala_ClickLogindUser_array_free (ClickLogindUser * array,
                                  gssize array_length)
{
	if (array != NULL) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			click_logind_user_destroy (&array[i]);
		}
	}
	g_free (array);
}

static void
_dbus_click_logind_manager_ListUsers (ClickLogindManager* self,
                                      GVariant* _parameters_,
                                      GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	ClickLogindUser* result;
	gint result_length1 = 0;
	ClickLogindUser* _tmp9_;
	GVariantBuilder _tmp10_;
	gint _tmp11_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	result = click_logind_manager_ListUsers (self, &result_length1, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp9_ = result;
	g_variant_builder_init (&_tmp10_, G_VARIANT_TYPE ("a(uss)"));
	for (_tmp11_ = 0; _tmp11_ < result_length1; _tmp11_++) {
		GVariantBuilder _tmp12_;
		g_variant_builder_init (&_tmp12_, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_tmp12_, g_variant_new_uint32 ((*_tmp9_).uid));
		g_variant_builder_add_value (&_tmp12_, g_variant_new_string ((*_tmp9_).name));
		g_variant_builder_add_value (&_tmp12_, g_variant_new_string ((*_tmp9_).ObjectPath));
		g_variant_builder_add_value (&_tmp10_, g_variant_builder_end (&_tmp12_));
		_tmp9_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp10_));
	result = (_vala_ClickLogindUser_array_free (result, result_length1), NULL);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
click_logind_manager_dbus_interface_method_call (GDBusConnection* connection,
                                                 const gchar* sender,
                                                 const gchar* object_path,
                                                 const gchar* interface_name,
                                                 const gchar* method_name,
                                                 GVariant* parameters,
                                                 GDBusMethodInvocation* invocation,
                                                 gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "ListUsers") == 0) {
		_dbus_click_logind_manager_ListUsers (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
click_logind_manager_dbus_interface_get_property (GDBusConnection* connection,
                                                  const gchar* sender,
                                                  const gchar* object_path,
                                                  const gchar* interface_name,
                                                  const gchar* property_name,
                                                  GError** error,
                                                  gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}

static gboolean
click_logind_manager_dbus_interface_set_property (GDBusConnection* connection,
                                                  const gchar* sender,
                                                  const gchar* object_path,
                                                  const gchar* interface_name,
                                                  const gchar* property_name,
                                                  GVariant* value,
                                                  GError** error,
                                                  gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

guint
click_logind_manager_register_object (gpointer object,
                                      GDBusConnection* connection,
                                      const gchar* path,
                                      GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_click_logind_manager_dbus_interface_info), &_click_logind_manager_dbus_interface_vtable, data, _click_logind_manager_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}

static void
_click_logind_manager_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

gboolean
click_as_user_get_system_account (ClickASUser* self)
{
	ClickASUserIface* _iface_;
#line 53 "user.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 53 "user.vala"
	_iface_ = CLICK_AS_USER_GET_INTERFACE (self);
#line 53 "user.vala"
	if (_iface_->get_system_account) {
#line 53 "user.vala"
		return _iface_->get_system_account (self);
#line 795 "user.c"
	}
#line 53 "user.vala"
	return FALSE;
#line 799 "user.c"
}

static void
click_as_user_default_init (ClickASUserIface * iface,
                            gpointer iface_data)
{
}

static GType
click_as_user_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ClickASUserIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) click_as_user_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType click_as_user_type_id;
	click_as_user_type_id = g_type_register_static (G_TYPE_INTERFACE, "ClickASUser", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (click_as_user_type_id, G_TYPE_OBJECT);
	g_type_set_qdata (click_as_user_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) click_as_user_proxy_get_type);
	g_type_set_qdata (click_as_user_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.freedesktop.Accounts.User");
	g_type_set_qdata (click_as_user_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_click_as_user_dbus_interface_info));
	g_type_set_qdata (click_as_user_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) click_as_user_register_object);
	return click_as_user_type_id;
}

GType
click_as_user_get_type (void)
{
	static volatile gsize click_as_user_type_id__once = 0;
	if (g_once_init_enter (&click_as_user_type_id__once)) {
		GType click_as_user_type_id;
		click_as_user_type_id = click_as_user_get_type_once ();
		g_once_init_leave (&click_as_user_type_id__once, click_as_user_type_id);
	}
	return click_as_user_type_id__once;
}

G_DEFINE_TYPE_EXTENDED (ClickASUserProxy, click_as_user_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (CLICK_TYPE_AS_USER, click_as_user_proxy_click_as_user_interface_init) )
static void
click_as_user_proxy_class_init (ClickASUserProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = click_as_user_proxy_g_signal;
}

static void
click_as_user_proxy_g_signal (GDBusProxy* proxy,
                              const gchar* sender_name,
                              const gchar* signal_name,
                              GVariant* parameters)
{
}

static void
click_as_user_proxy_init (ClickASUserProxy* self)
{
	g_dbus_proxy_set_interface_info (G_DBUS_PROXY (self), (GDBusInterfaceInfo *) (&_click_as_user_dbus_interface_info));
}

static gboolean
click_as_user_dbus_proxy_get_system_account (ClickASUser* self)
{
	GVariant *_inner_reply;
	gboolean _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "SystemAccount");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.Accounts.User"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("SystemAccount"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gboolean _tmp13_ = FALSE;
			return _tmp13_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_boolean (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static void
click_as_user_proxy_click_as_user_interface_init (ClickASUserIface* iface)
{
	iface->get_system_account = click_as_user_dbus_proxy_get_system_account;
}

static void
click_as_user_dbus_interface_method_call (GDBusConnection* connection,
                                          const gchar* sender,
                                          const gchar* object_path,
                                          const gchar* interface_name,
                                          const gchar* method_name,
                                          GVariant* parameters,
                                          GDBusMethodInvocation* invocation,
                                          gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	g_object_unref (invocation);
}

static GVariant*
_dbus_click_as_user_get_system_account (ClickASUser* self)
{
	gboolean result;
	GVariant* _reply;
	result = click_as_user_get_system_account (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
click_as_user_dbus_interface_get_property (GDBusConnection* connection,
                                           const gchar* sender,
                                           const gchar* object_path,
                                           const gchar* interface_name,
                                           const gchar* property_name,
                                           GError** error,
                                           gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "SystemAccount") == 0) {
		return _dbus_click_as_user_get_system_account (object);
	}
	return NULL;
}

static gboolean
click_as_user_dbus_interface_set_property (GDBusConnection* connection,
                                           const gchar* sender,
                                           const gchar* object_path,
                                           const gchar* interface_name,
                                           const gchar* property_name,
                                           GVariant* value,
                                           GError** error,
                                           gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

guint
click_as_user_register_object (gpointer object,
                               GDBusConnection* connection,
                               const gchar* path,
                               GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_click_as_user_dbus_interface_info), &_click_as_user_dbus_interface_vtable, data, _click_as_user_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}

static void
_click_as_user_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

GQuark
click_user_error_quark (void)
{
	return g_quark_from_static_string ("click-user-error-quark");
}

static GType
click_user_error_get_type_once (void)
{
	static const GEnumValue values[] = {{CLICK_USER_ERROR_GETPWNAM, "CLICK_USER_ERROR_GETPWNAM", "getpwnam"}, {CLICK_USER_ERROR_CREATE_DB, "CLICK_USER_ERROR_CREATE_DB", "create-db"}, {CLICK_USER_ERROR_CHOWN_DB, "CLICK_USER_ERROR_CHOWN_DB", "chown-db"}, {CLICK_USER_ERROR_NO_SUCH_USER, "CLICK_USER_ERROR_NO_SUCH_USER", "no-such-user"}, {CLICK_USER_ERROR_DROP_PRIVS, "CLICK_USER_ERROR_DROP_PRIVS", "drop-privs"}, {CLICK_USER_ERROR_REGAIN_PRIVS, "CLICK_USER_ERROR_REGAIN_PRIVS", "regain-privs"}, {CLICK_USER_ERROR_HIDDEN_PACKAGE, "CLICK_USER_ERROR_HIDDEN_PACKAGE", "hidden-package"}, {CLICK_USER_ERROR_NO_SUCH_PACKAGE, "CLICK_USER_ERROR_NO_SUCH_PACKAGE", "no-such-package"}, {CLICK_USER_ERROR_RENAME, "CLICK_USER_ERROR_RENAME", "rename"}, {0, NULL, NULL}};
	GType click_user_error_type_id;
	click_user_error_type_id = g_enum_register_static ("ClickUserError", values);
	return click_user_error_type_id;
}

GType
click_user_error_get_type (void)
{
	static volatile gsize click_user_error_type_id__once = 0;
	if (g_once_init_enter (&click_user_error_type_id__once)) {
		GType click_user_error_type_id;
		click_user_error_type_id = click_user_error_get_type_once ();
		g_once_init_leave (&click_user_error_type_id__once, click_user_error_type_id);
	}
	return click_user_error_type_id__once;
}

gchar*
click_db_top (const gchar* root)
{
	gchar* _tmp0_;
	gchar* result;
#line 107 "user.vala"
	g_return_val_if_fail (root != NULL, NULL);
#line 113 "user.vala"
	_tmp0_ = g_build_filename (root, ".click", "users", NULL);
#line 113 "user.vala"
	result = _tmp0_;
#line 113 "user.vala"
	return result;
#line 1021 "user.c"
}

gchar*
click_db_for_user (const gchar* root,
                   const gchar* user)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
#line 116 "user.vala"
	g_return_val_if_fail (root != NULL, NULL);
#line 116 "user.vala"
	g_return_val_if_fail (user != NULL, NULL);
#line 119 "user.vala"
	_tmp0_ = click_db_top (root);
#line 119 "user.vala"
	_tmp1_ = _tmp0_;
#line 119 "user.vala"
	_tmp2_ = g_build_filename (_tmp1_, user, NULL);
#line 119 "user.vala"
	_tmp3_ = _tmp2_;
#line 119 "user.vala"
	_g_free0 (_tmp1_);
#line 119 "user.vala"
	result = _tmp3_;
#line 119 "user.vala"
	return result;
#line 1051 "user.c"
}

void
click_try_create (const gchar* path,
                  GError** error)
{
	GError* _inner_error0_ = NULL;
#line 122 "user.vala"
	g_return_if_fail (path != NULL);
#line 125 "user.vala"
	if (g_mkdir (path, 0777) < 0) {
#line 1063 "user.c"
		const gchar* _tmp0_;
		GError* _tmp1_;
#line 126 "user.vala"
		_tmp0_ = g_strerror (errno);
#line 126 "user.vala"
		_tmp1_ = g_error_new (CLICK_USER_ERROR, CLICK_USER_ERROR_CREATE_DB, "Cannot create database directory %s: %s", path, _tmp0_);
#line 126 "user.vala"
		_inner_error0_ = _tmp1_;
#line 126 "user.vala"
		if (_inner_error0_->domain == CLICK_USER_ERROR) {
#line 126 "user.vala"
			g_propagate_error (error, _inner_error0_);
#line 126 "user.vala"
			return;
#line 1078 "user.c"
		} else {
#line 126 "user.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 126 "user.vala"
			g_clear_error (&_inner_error0_);
#line 126 "user.vala"
			return;
#line 1086 "user.c"
		}
	}
}

ClickCachedPasswd*
click_cached_passwd_construct (GType object_type,
                               uid_t uid,
                               gid_t gid)
{
	ClickCachedPasswd * self = NULL;
#line 135 "user.vala"
	self = (ClickCachedPasswd*) g_object_new (object_type, NULL);
#line 138 "user.vala"
	self->uid = uid;
#line 139 "user.vala"
	self->gid = gid;
#line 135 "user.vala"
	return self;
#line 1105 "user.c"
}

ClickCachedPasswd*
click_cached_passwd_new (uid_t uid,
                         gid_t gid)
{
#line 135 "user.vala"
	return click_cached_passwd_construct (CLICK_TYPE_CACHED_PASSWD, uid, gid);
#line 1114 "user.c"
}

static void
click_cached_passwd_class_init (ClickCachedPasswdClass * klass,
                                gpointer klass_data)
{
#line 131 "user.vala"
	click_cached_passwd_parent_class = g_type_class_peek_parent (klass);
#line 131 "user.vala"
	G_OBJECT_CLASS (klass)->finalize = click_cached_passwd_finalize;
#line 1125 "user.c"
}

static void
click_cached_passwd_instance_init (ClickCachedPasswd * self,
                                   gpointer klass)
{
}

static void
click_cached_passwd_finalize (GObject * obj)
{
	ClickCachedPasswd * self;
#line 131 "user.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CLICK_TYPE_CACHED_PASSWD, ClickCachedPasswd);
#line 131 "user.vala"
	G_OBJECT_CLASS (click_cached_passwd_parent_class)->finalize (obj);
#line 1142 "user.c"
}

static GType
click_cached_passwd_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ClickCachedPasswdClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) click_cached_passwd_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ClickCachedPasswd), 0, (GInstanceInitFunc) click_cached_passwd_instance_init, NULL };
	GType click_cached_passwd_type_id;
	click_cached_passwd_type_id = g_type_register_static (G_TYPE_OBJECT, "ClickCachedPasswd", &g_define_type_info, 0);
	return click_cached_passwd_type_id;
}

GType
click_cached_passwd_get_type (void)
{
	static volatile gsize click_cached_passwd_type_id__once = 0;
	if (g_once_init_enter (&click_cached_passwd_type_id__once)) {
		GType click_cached_passwd_type_id;
		click_cached_passwd_type_id = click_cached_passwd_get_type_once ();
		g_once_init_leave (&click_cached_passwd_type_id__once, click_cached_passwd_type_id);
	}
	return click_cached_passwd_type_id__once;
}

void
click_try_chown (const gchar* path,
                 ClickCachedPasswd* pw,
                 GError** error)
{
	GError* _inner_error0_ = NULL;
#line 143 "user.vala"
	g_return_if_fail (path != NULL);
#line 143 "user.vala"
	g_return_if_fail (pw != NULL);
#line 146 "user.vala"
	if (chown (path, pw->uid, pw->gid) < 0) {
#line 1178 "user.c"
		const gchar* _tmp0_;
		GError* _tmp1_;
#line 147 "user.vala"
		_tmp0_ = g_strerror (errno);
#line 147 "user.vala"
		_tmp1_ = g_error_new (CLICK_USER_ERROR, CLICK_USER_ERROR_CHOWN_DB, "Cannot set ownership of database directory %s: %s", path, _tmp0_);
#line 147 "user.vala"
		_inner_error0_ = _tmp1_;
#line 147 "user.vala"
		if (_inner_error0_->domain == CLICK_USER_ERROR) {
#line 147 "user.vala"
			g_propagate_error (error, _inner_error0_);
#line 147 "user.vala"
			return;
#line 1193 "user.c"
		} else {
#line 147 "user.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 147 "user.vala"
			g_clear_error (&_inner_error0_);
#line 147 "user.vala"
			return;
#line 1201 "user.c"
		}
	}
}

static inline gpointer
click_users_get_instance_private (ClickUsers* self)
{
	return G_STRUCT_MEMBER_P (self, ClickUsers_private_offset);
}

ClickUsers*
click_users_construct (GType object_type,
                       ClickDB* db)
{
	ClickUsers * self = NULL;
#line 156 "user.vala"
	g_return_val_if_fail (db != NULL, NULL);
#line 158 "user.vala"
	self = (ClickUsers*) g_object_new (object_type, "db", db, NULL);
#line 159 "user.vala"
	_g_object_unref0 (self->priv->click_pw);
#line 159 "user.vala"
	self->priv->click_pw = NULL;
#line 156 "user.vala"
	return self;
#line 1227 "user.c"
}

ClickUsers*
click_users_new (ClickDB* db)
{
#line 156 "user.vala"
	return click_users_construct (CLICK_TYPE_USERS, db);
#line 1235 "user.c"
}

/**
 * get_click_pw:
 *
 * Returns: The password file entry for the `clickpkg` user.
 */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 179 "user.vala"
	return self ? g_object_ref (self) : NULL;
#line 1248 "user.c"
}

static ClickCachedPasswd*
click_users_get_click_pw (ClickUsers* self,
                          GError** error)
{
	ClickCachedPasswd* _tmp0_;
	ClickCachedPasswd* _tmp8_;
	ClickCachedPasswd* _tmp9_;
	GError* _inner_error0_ = NULL;
	ClickCachedPasswd* result;
#line 167 "user.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 170 "user.vala"
	_tmp0_ = self->priv->click_pw;
#line 170 "user.vala"
	if (_tmp0_ == NULL) {
#line 1266 "user.c"
		struct passwd* pw = NULL;
		struct passwd* _tmp1_;
		struct passwd* _tmp2_;
		struct passwd* _tmp5_;
		struct passwd* _tmp6_;
		ClickCachedPasswd* _tmp7_;
#line 171 "user.vala"
		errno = 0;
#line 172 "user.vala"
		_tmp1_ = getpwnam ("clickpkg");
#line 172 "user.vala"
		pw = _tmp1_;
#line 173 "user.vala"
		_tmp2_ = pw;
#line 173 "user.vala"
		if (_tmp2_ == NULL) {
#line 1283 "user.c"
			const gchar* _tmp3_;
			GError* _tmp4_;
#line 174 "user.vala"
			_tmp3_ = g_strerror (errno);
#line 174 "user.vala"
			_tmp4_ = g_error_new (CLICK_USER_ERROR, CLICK_USER_ERROR_GETPWNAM, "Cannot get password file entry " "for clickpkg: %s", _tmp3_);
#line 174 "user.vala"
			_inner_error0_ = _tmp4_;
#line 174 "user.vala"
			if (_inner_error0_->domain == CLICK_USER_ERROR) {
#line 174 "user.vala"
				g_propagate_error (error, _inner_error0_);
#line 174 "user.vala"
				return NULL;
#line 1298 "user.c"
			} else {
#line 174 "user.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 174 "user.vala"
				g_clear_error (&_inner_error0_);
#line 174 "user.vala"
				return NULL;
#line 1306 "user.c"
			}
		}
#line 177 "user.vala"
		_tmp5_ = pw;
#line 177 "user.vala"
		_tmp6_ = pw;
#line 177 "user.vala"
		_tmp7_ = click_cached_passwd_new (_tmp5_->pw_uid, _tmp6_->pw_gid);
#line 177 "user.vala"
		_g_object_unref0 (self->priv->click_pw);
#line 177 "user.vala"
		self->priv->click_pw = _tmp7_;
#line 1319 "user.c"
	}
#line 179 "user.vala"
	_tmp8_ = self->priv->click_pw;
#line 179 "user.vala"
	_tmp9_ = _g_object_ref0 (_tmp8_);
#line 179 "user.vala"
	result = _tmp9_;
#line 179 "user.vala"
	return result;
#line 1329 "user.c"
}

static void
_g_free0_ (gpointer var)
{
#line 195 "user.vala"
	var = (g_free (var), NULL);
#line 1337 "user.c"
}

static inline void
_g_list_free__g_free0_ (GList* self)
{
#line 195 "user.vala"
	g_list_free_full (self, (GDestroyNotify) _g_free0_);
#line 1345 "user.c"
}

void
click_users_ensure_db (ClickUsers* self,
                       GError** error)
{
	GList* create = NULL;
	gchar* try_path = NULL;
	ClickDB* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	GList* _tmp9_;
	GError* _inner_error0_ = NULL;
#line 182 "user.vala"
	g_return_if_fail (self != NULL);
#line 185 "user.vala"
	create = NULL;
#line 188 "user.vala"
	_tmp0_ = self->priv->_db;
#line 188 "user.vala"
	_tmp1_ = click_db_get_overlay (_tmp0_);
#line 188 "user.vala"
	_tmp2_ = _tmp1_;
#line 188 "user.vala"
	_tmp3_ = click_db_top (_tmp2_);
#line 188 "user.vala"
	try_path = _tmp3_;
#line 189 "user.vala"
	while (TRUE) {
#line 1376 "user.c"
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 189 "user.vala"
		_tmp4_ = try_path;
#line 189 "user.vala"
		if (!(!click_exists (_tmp4_))) {
#line 189 "user.vala"
			break;
#line 1388 "user.c"
		}
#line 190 "user.vala"
		_tmp5_ = try_path;
#line 190 "user.vala"
		_tmp6_ = g_strdup (_tmp5_);
#line 190 "user.vala"
		create = g_list_prepend (create, _tmp6_);
#line 191 "user.vala"
		_tmp7_ = try_path;
#line 191 "user.vala"
		_tmp8_ = g_path_get_dirname (_tmp7_);
#line 191 "user.vala"
		_g_free0 (try_path);
#line 191 "user.vala"
		try_path = _tmp8_;
#line 1404 "user.c"
	}
#line 194 "user.vala"
	_tmp9_ = create;
#line 1408 "user.c"
	{
		GList* path_collection = NULL;
		GList* path_it = NULL;
#line 194 "user.vala"
		path_collection = _tmp9_;
#line 194 "user.vala"
		for (path_it = path_collection; path_it != NULL; path_it = path_it->next) {
#line 1416 "user.c"
			gchar* _tmp10_;
			gchar* path = NULL;
#line 194 "user.vala"
			_tmp10_ = g_strdup ((const gchar*) path_it->data);
#line 194 "user.vala"
			path = _tmp10_;
#line 1423 "user.c"
			{
				const gchar* _tmp11_;
#line 195 "user.vala"
				_tmp11_ = path;
#line 195 "user.vala"
				click_try_create (_tmp11_, &_inner_error0_);
#line 195 "user.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 195 "user.vala"
					if (_inner_error0_->domain == CLICK_USER_ERROR) {
#line 195 "user.vala"
						g_propagate_error (error, _inner_error0_);
#line 195 "user.vala"
						_g_free0 (path);
#line 195 "user.vala"
						_g_free0 (try_path);
#line 195 "user.vala"
						(create == NULL) ? NULL : (create = (_g_list_free__g_free0_ (create), NULL));
#line 195 "user.vala"
						return;
#line 1444 "user.c"
					} else {
#line 195 "user.vala"
						_g_free0 (path);
#line 195 "user.vala"
						_g_free0 (try_path);
#line 195 "user.vala"
						(create == NULL) ? NULL : (create = (_g_list_free__g_free0_ (create), NULL));
#line 195 "user.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 195 "user.vala"
						g_clear_error (&_inner_error0_);
#line 195 "user.vala"
						return;
#line 1458 "user.c"
					}
				}
#line 196 "user.vala"
				if (geteuid () == ((uid_t) 0)) {
#line 1463 "user.c"
					ClickCachedPasswd* _tmp12_ = NULL;
					ClickCachedPasswd* _tmp13_;
					const gchar* _tmp14_;
#line 197 "user.vala"
					_tmp13_ = click_users_get_click_pw (self, &_inner_error0_);
#line 197 "user.vala"
					_tmp12_ = _tmp13_;
#line 197 "user.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 197 "user.vala"
						if (_inner_error0_->domain == CLICK_USER_ERROR) {
#line 197 "user.vala"
							g_propagate_error (error, _inner_error0_);
#line 197 "user.vala"
							_g_free0 (path);
#line 197 "user.vala"
							_g_free0 (try_path);
#line 197 "user.vala"
							(create == NULL) ? NULL : (create = (_g_list_free__g_free0_ (create), NULL));
#line 197 "user.vala"
							return;
#line 1485 "user.c"
						} else {
#line 197 "user.vala"
							_g_free0 (path);
#line 197 "user.vala"
							_g_free0 (try_path);
#line 197 "user.vala"
							(create == NULL) ? NULL : (create = (_g_list_free__g_free0_ (create), NULL));
#line 197 "user.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 197 "user.vala"
							g_clear_error (&_inner_error0_);
#line 197 "user.vala"
							return;
#line 1499 "user.c"
						}
					}
#line 197 "user.vala"
					_tmp14_ = path;
#line 197 "user.vala"
					click_try_chown (_tmp14_, _tmp12_, &_inner_error0_);
#line 197 "user.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 197 "user.vala"
						if (_inner_error0_->domain == CLICK_USER_ERROR) {
#line 197 "user.vala"
							g_propagate_error (error, _inner_error0_);
#line 197 "user.vala"
							_g_object_unref0 (_tmp12_);
#line 197 "user.vala"
							_g_free0 (path);
#line 197 "user.vala"
							_g_free0 (try_path);
#line 197 "user.vala"
							(create == NULL) ? NULL : (create = (_g_list_free__g_free0_ (create), NULL));
#line 197 "user.vala"
							return;
#line 1522 "user.c"
						} else {
#line 197 "user.vala"
							_g_object_unref0 (_tmp12_);
#line 197 "user.vala"
							_g_free0 (path);
#line 197 "user.vala"
							_g_free0 (try_path);
#line 197 "user.vala"
							(create == NULL) ? NULL : (create = (_g_list_free__g_free0_ (create), NULL));
#line 197 "user.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 197 "user.vala"
							g_clear_error (&_inner_error0_);
#line 197 "user.vala"
							return;
#line 1538 "user.c"
						}
					}
#line 196 "user.vala"
					_g_object_unref0 (_tmp12_);
#line 1543 "user.c"
				}
#line 194 "user.vala"
				_g_free0 (path);
#line 1547 "user.c"
			}
		}
	}
#line 182 "user.vala"
	_g_free0 (try_path);
#line 182 "user.vala"
	(create == NULL) ? NULL : (create = (_g_list_free__g_free0_ (create), NULL));
#line 1555 "user.c"
}

/**
 * get_user_names:
 *
 * Returns: A list of user names with registrations.
 */
GList*
click_users_get_user_names (ClickUsers* self,
                            GError** error)
{
	GList* entries = NULL;
	GeeHashSet* seen = NULL;
	GeeHashSet* _tmp0_;
	GError* _inner_error0_ = NULL;
	GList* result;
#line 206 "user.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 209 "user.vala"
	entries = NULL;
#line 210 "user.vala"
	_tmp0_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 210 "user.vala"
	seen = _tmp0_;
#line 1580 "user.c"
	{
		ClickDB* _single_db_list = NULL;
		ClickDB* _tmp1_;
		gint _single_db_size = 0;
		ClickDB* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _single_db_index = 0;
#line 211 "user.vala"
		_tmp1_ = self->priv->_db;
#line 211 "user.vala"
		_single_db_list = _tmp1_;
#line 211 "user.vala"
		_tmp2_ = _single_db_list;
#line 211 "user.vala"
		_tmp3_ = click_db_get_size (_tmp2_);
#line 211 "user.vala"
		_tmp4_ = _tmp3_;
#line 211 "user.vala"
		_single_db_size = _tmp4_;
#line 211 "user.vala"
		_single_db_index = -1;
#line 211 "user.vala"
		while (TRUE) {
#line 1605 "user.c"
			gint _tmp5_;
			gint _tmp6_;
			ClickSingleDB* single_db = NULL;
			ClickDB* _tmp7_;
			ClickSingleDB* _tmp8_;
			gchar* users_db = NULL;
			ClickSingleDB* _tmp9_;
			const gchar* _tmp10_;
			const gchar* _tmp11_;
			gchar* _tmp12_;
			ClickDir* _tmp13_ = NULL;
			const gchar* _tmp14_;
			ClickDir* _tmp15_;
#line 211 "user.vala"
			_single_db_index = _single_db_index + 1;
#line 211 "user.vala"
			_tmp5_ = _single_db_index;
#line 211 "user.vala"
			_tmp6_ = _single_db_size;
#line 211 "user.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 211 "user.vala"
				break;
#line 1629 "user.c"
			}
#line 211 "user.vala"
			_tmp7_ = _single_db_list;
#line 211 "user.vala"
			_tmp8_ = click_db_get (_tmp7_, _single_db_index, &_inner_error0_);
#line 211 "user.vala"
			single_db = _tmp8_;
#line 211 "user.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 211 "user.vala"
				g_propagate_error (error, _inner_error0_);
#line 211 "user.vala"
				_g_object_unref0 (seen);
#line 211 "user.vala"
				(entries == NULL) ? NULL : (entries = (_g_list_free__g_free0_ (entries), NULL));
#line 211 "user.vala"
				return NULL;
#line 1647 "user.c"
			}
#line 212 "user.vala"
			_tmp9_ = single_db;
#line 212 "user.vala"
			_tmp10_ = click_single_db_get_root (_tmp9_);
#line 212 "user.vala"
			_tmp11_ = _tmp10_;
#line 212 "user.vala"
			_tmp12_ = click_db_top (_tmp11_);
#line 212 "user.vala"
			users_db = _tmp12_;
#line 213 "user.vala"
			_tmp14_ = users_db;
#line 213 "user.vala"
			_tmp15_ = click_dir_open (_tmp14_, (guint) 0, &_inner_error0_);
#line 213 "user.vala"
			_tmp13_ = _tmp15_;
#line 213 "user.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 213 "user.vala"
				g_propagate_error (error, _inner_error0_);
#line 213 "user.vala"
				_g_free0 (users_db);
#line 213 "user.vala"
				_g_object_unref0 (single_db);
#line 213 "user.vala"
				_g_object_unref0 (seen);
#line 213 "user.vala"
				(entries == NULL) ? NULL : (entries = (_g_list_free__g_free0_ (entries), NULL));
#line 213 "user.vala"
				return NULL;
#line 1679 "user.c"
			}
			{
				ClickDirIterator* _entry_it = NULL;
				ClickDirIterator* _tmp16_;
				const gchar* entry = NULL;
#line 213 "user.vala"
				_tmp16_ = click_dir_iterator (_tmp13_);
#line 213 "user.vala"
				_entry_it = _tmp16_;
#line 213 "user.vala"
				while (TRUE) {
#line 1691 "user.c"
					ClickDirIterator* _tmp17_;
					const gchar* _tmp18_;
					const gchar* _tmp19_;
					GeeHashSet* _tmp20_;
					const gchar* _tmp21_;
					gboolean _tmp22_ = FALSE;
					const gchar* _tmp23_;
					gchar* path = NULL;
					const gchar* _tmp26_;
					const gchar* _tmp27_;
					gchar* _tmp28_;
					const gchar* _tmp29_;
#line 213 "user.vala"
					_tmp17_ = _entry_it;
#line 213 "user.vala"
					_tmp18_ = click_dir_iterator_next_value (_tmp17_);
#line 213 "user.vala"
					entry = _tmp18_;
#line 213 "user.vala"
					_tmp19_ = entry;
#line 213 "user.vala"
					if (!(_tmp19_ != NULL)) {
#line 213 "user.vala"
						break;
#line 1716 "user.c"
					}
#line 214 "user.vala"
					_tmp20_ = seen;
#line 214 "user.vala"
					_tmp21_ = entry;
#line 214 "user.vala"
					if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp20_, _tmp21_)) {
#line 215 "user.vala"
						continue;
#line 1726 "user.c"
					}
#line 217 "user.vala"
					_tmp23_ = entry;
#line 217 "user.vala"
					if (!g_str_has_prefix (_tmp23_, "@")) {
#line 1732 "user.c"
						const gchar* _tmp24_;
						struct passwd* _tmp25_;
#line 218 "user.vala"
						_tmp24_ = entry;
#line 218 "user.vala"
						_tmp25_ = getpwnam (_tmp24_);
#line 218 "user.vala"
						_tmp22_ = _tmp25_ == NULL;
#line 1741 "user.c"
					} else {
#line 217 "user.vala"
						_tmp22_ = FALSE;
#line 1745 "user.c"
					}
#line 217 "user.vala"
					if (_tmp22_) {
#line 219 "user.vala"
						continue;
#line 1751 "user.c"
					}
#line 220 "user.vala"
					_tmp26_ = users_db;
#line 220 "user.vala"
					_tmp27_ = entry;
#line 220 "user.vala"
					_tmp28_ = g_build_filename (_tmp26_, _tmp27_, NULL);
#line 220 "user.vala"
					path = _tmp28_;
#line 222 "user.vala"
					_tmp29_ = path;
#line 222 "user.vala"
					if (click_is_dir (_tmp29_)) {
#line 1765 "user.c"
						GeeHashSet* _tmp30_;
						const gchar* _tmp31_;
						gchar* _tmp32_;
						gchar* _tmp33_;
						const gchar* _tmp34_;
						gchar* _tmp35_;
#line 223 "user.vala"
						_tmp30_ = seen;
#line 223 "user.vala"
						_tmp31_ = entry;
#line 223 "user.vala"
						_tmp32_ = g_strdup (_tmp31_);
#line 223 "user.vala"
						_tmp33_ = _tmp32_;
#line 223 "user.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp30_, _tmp33_);
#line 223 "user.vala"
						_g_free0 (_tmp33_);
#line 224 "user.vala"
						_tmp34_ = entry;
#line 224 "user.vala"
						_tmp35_ = g_strdup (_tmp34_);
#line 224 "user.vala"
						entries = g_list_prepend (entries, _tmp35_);
#line 1790 "user.c"
					}
#line 213 "user.vala"
					_g_free0 (path);
#line 1794 "user.c"
				}
#line 213 "user.vala"
				_g_object_unref0 (_entry_it);
#line 1798 "user.c"
			}
#line 211 "user.vala"
			_g_object_unref0 (_tmp13_);
#line 211 "user.vala"
			_g_free0 (users_db);
#line 211 "user.vala"
			_g_object_unref0 (single_db);
#line 1806 "user.c"
		}
	}
#line 228 "user.vala"
	entries = g_list_reverse (entries);
#line 229 "user.vala"
	result = entries;
#line 229 "user.vala"
	_g_object_unref0 (seen);
#line 229 "user.vala"
	return result;
#line 1817 "user.c"
}

/**
 * get_user:
 * @user_name: A user name.
 *
 * Returns: (transfer full): A new #ClickUser instance for @user.
 */
ClickUser*
click_users_get_user (ClickUsers* self,
                      const gchar* user_name,
                      GError** error)
{
	GError* _tmp17_;
	GError* _inner_error0_ = NULL;
	ClickUser* result;
#line 238 "user.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 238 "user.vala"
	g_return_val_if_fail (user_name != NULL, NULL);
#line 1838 "user.c"
	{
		ClickDB* _single_db_list = NULL;
		ClickDB* _tmp0_;
		gint _single_db_size = 0;
		ClickDB* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _single_db_index = 0;
#line 241 "user.vala"
		_tmp0_ = self->priv->_db;
#line 241 "user.vala"
		_single_db_list = _tmp0_;
#line 241 "user.vala"
		_tmp1_ = _single_db_list;
#line 241 "user.vala"
		_tmp2_ = click_db_get_size (_tmp1_);
#line 241 "user.vala"
		_tmp3_ = _tmp2_;
#line 241 "user.vala"
		_single_db_size = _tmp3_;
#line 241 "user.vala"
		_single_db_index = -1;
#line 241 "user.vala"
		while (TRUE) {
#line 1863 "user.c"
			gint _tmp4_;
			gint _tmp5_;
			ClickSingleDB* single_db = NULL;
			ClickDB* _tmp6_;
			ClickSingleDB* _tmp7_;
			gchar* path = NULL;
			ClickSingleDB* _tmp8_;
			const gchar* _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
			const gchar* _tmp12_;
#line 241 "user.vala"
			_single_db_index = _single_db_index + 1;
#line 241 "user.vala"
			_tmp4_ = _single_db_index;
#line 241 "user.vala"
			_tmp5_ = _single_db_size;
#line 241 "user.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 241 "user.vala"
				break;
#line 1885 "user.c"
			}
#line 241 "user.vala"
			_tmp6_ = _single_db_list;
#line 241 "user.vala"
			_tmp7_ = click_db_get (_tmp6_, _single_db_index, &_inner_error0_);
#line 241 "user.vala"
			single_db = _tmp7_;
#line 241 "user.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 241 "user.vala"
				g_propagate_error (error, _inner_error0_);
#line 241 "user.vala"
				return NULL;
#line 1899 "user.c"
			}
#line 242 "user.vala"
			_tmp8_ = single_db;
#line 242 "user.vala"
			_tmp9_ = click_single_db_get_root (_tmp8_);
#line 242 "user.vala"
			_tmp10_ = _tmp9_;
#line 242 "user.vala"
			_tmp11_ = click_db_for_user (_tmp10_, user_name);
#line 242 "user.vala"
			path = _tmp11_;
#line 243 "user.vala"
			_tmp12_ = path;
#line 243 "user.vala"
			if (click_is_dir (_tmp12_)) {
#line 1915 "user.c"
				ClickUser* _tmp13_ = NULL;
				ClickDB* _tmp14_;
				ClickUser* _tmp15_;
				ClickUser* _tmp16_;
#line 247 "user.vala"
				_tmp14_ = self->priv->_db;
#line 247 "user.vala"
				_tmp15_ = click_user_new_for_user (_tmp14_, user_name, &_inner_error0_);
#line 247 "user.vala"
				_tmp13_ = _tmp15_;
#line 247 "user.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 247 "user.vala"
					g_propagate_error (error, _inner_error0_);
#line 247 "user.vala"
					_g_free0 (path);
#line 247 "user.vala"
					_g_object_unref0 (single_db);
#line 247 "user.vala"
					return NULL;
#line 1936 "user.c"
				}
#line 247 "user.vala"
				_tmp16_ = _tmp13_;
#line 247 "user.vala"
				_tmp13_ = NULL;
#line 247 "user.vala"
				result = _tmp16_;
#line 247 "user.vala"
				_g_object_unref0 (_tmp13_);
#line 247 "user.vala"
				_g_free0 (path);
#line 247 "user.vala"
				_g_object_unref0 (single_db);
#line 247 "user.vala"
				return result;
#line 1952 "user.c"
			}
#line 241 "user.vala"
			_g_free0 (path);
#line 241 "user.vala"
			_g_object_unref0 (single_db);
#line 1958 "user.c"
		}
	}
#line 249 "user.vala"
	_tmp17_ = g_error_new (CLICK_USER_ERROR, CLICK_USER_ERROR_NO_SUCH_USER, "User %s does not exist in any database", user_name);
#line 249 "user.vala"
	_inner_error0_ = _tmp17_;
#line 249 "user.vala"
	g_propagate_error (error, _inner_error0_);
#line 249 "user.vala"
	return NULL;
#line 1969 "user.c"
}

static ClickDB*
click_users_get_db (ClickUsers* self)
{
	ClickDB* result;
	ClickDB* _tmp0_;
#line 153 "user.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 153 "user.vala"
	_tmp0_ = self->priv->_db;
#line 153 "user.vala"
	result = _tmp0_;
#line 153 "user.vala"
	return result;
#line 1985 "user.c"
}

static void
click_users_set_db (ClickUsers* self,
                    ClickDB* value)
{
	ClickDB* old_value;
#line 153 "user.vala"
	g_return_if_fail (self != NULL);
#line 153 "user.vala"
	old_value = click_users_get_db (self);
#line 153 "user.vala"
	if (old_value != value) {
#line 1999 "user.c"
		ClickDB* _tmp0_;
#line 153 "user.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 153 "user.vala"
		_g_object_unref0 (self->priv->_db);
#line 153 "user.vala"
		self->priv->_db = _tmp0_;
#line 153 "user.vala"
		g_object_notify_by_pspec ((GObject *) self, click_users_properties[CLICK_USERS_DB_PROPERTY]);
#line 2009 "user.c"
	}
}

static void
click_users_class_init (ClickUsersClass * klass,
                        gpointer klass_data)
{
#line 152 "user.vala"
	click_users_parent_class = g_type_class_peek_parent (klass);
#line 152 "user.vala"
	g_type_class_adjust_private_offset (klass, &ClickUsers_private_offset);
#line 152 "user.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_click_users_get_property;
#line 152 "user.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_click_users_set_property;
#line 152 "user.vala"
	G_OBJECT_CLASS (klass)->finalize = click_users_finalize;
#line 152 "user.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLICK_USERS_DB_PROPERTY, click_users_properties[CLICK_USERS_DB_PROPERTY] = g_param_spec_object ("db", "db", "db", CLICK_TYPE_DB, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 2029 "user.c"
}

static void
click_users_instance_init (ClickUsers * self,
                           gpointer klass)
{
#line 152 "user.vala"
	self->priv = click_users_get_instance_private (self);
#line 2038 "user.c"
}

static void
click_users_finalize (GObject * obj)
{
	ClickUsers * self;
#line 152 "user.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CLICK_TYPE_USERS, ClickUsers);
#line 153 "user.vala"
	_g_object_unref0 (self->priv->_db);
#line 154 "user.vala"
	_g_object_unref0 (self->priv->click_pw);
#line 152 "user.vala"
	G_OBJECT_CLASS (click_users_parent_class)->finalize (obj);
#line 2053 "user.c"
}

static GType
click_users_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ClickUsersClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) click_users_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ClickUsers), 0, (GInstanceInitFunc) click_users_instance_init, NULL };
	GType click_users_type_id;
	click_users_type_id = g_type_register_static (G_TYPE_OBJECT, "ClickUsers", &g_define_type_info, 0);
	ClickUsers_private_offset = g_type_add_instance_private (click_users_type_id, sizeof (ClickUsersPrivate));
	return click_users_type_id;
}

GType
click_users_get_type (void)
{
	static volatile gsize click_users_type_id__once = 0;
	if (g_once_init_enter (&click_users_type_id__once)) {
		GType click_users_type_id;
		click_users_type_id = click_users_get_type_once ();
		g_once_init_leave (&click_users_type_id__once, click_users_type_id);
	}
	return click_users_type_id__once;
}

static void
_vala_click_users_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	ClickUsers * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CLICK_TYPE_USERS, ClickUsers);
#line 152 "user.vala"
	switch (property_id) {
#line 152 "user.vala"
		case CLICK_USERS_DB_PROPERTY:
#line 152 "user.vala"
		g_value_set_object (value, click_users_get_db (self));
#line 152 "user.vala"
		break;
#line 2094 "user.c"
		default:
#line 152 "user.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 152 "user.vala"
		break;
#line 2100 "user.c"
	}
}

static void
_vala_click_users_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	ClickUsers * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CLICK_TYPE_USERS, ClickUsers);
#line 152 "user.vala"
	switch (property_id) {
#line 152 "user.vala"
		case CLICK_USERS_DB_PROPERTY:
#line 152 "user.vala"
		click_users_set_db (self, g_value_get_object (value));
#line 152 "user.vala"
		break;
#line 2120 "user.c"
		default:
#line 152 "user.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 152 "user.vala"
		break;
#line 2126 "user.c"
	}
}

static inline gpointer
click_user_get_instance_private (ClickUser* self)
{
	return G_STRUCT_MEMBER_P (self, ClickUser_private_offset);
}

static ClickUser*
click_user_construct (GType object_type,
                      ClickDB* db,
                      const gchar* name,
                      GError** error)
{
	ClickUser * self = NULL;
	ClickDB* real_db = NULL;
	gchar* real_name = NULL;
	ClickDB* _tmp6_;
	const gchar* _tmp7_;
	GError* _inner_error0_ = NULL;
#line 266 "user.vala"
	if (db != NULL) {
#line 2150 "user.c"
		ClickDB* _tmp0_;
#line 267 "user.vala"
		_tmp0_ = _g_object_ref0 (db);
#line 267 "user.vala"
		_g_object_unref0 (real_db);
#line 267 "user.vala"
		real_db = _tmp0_;
#line 2158 "user.c"
	} else {
		ClickDB* _tmp1_;
		ClickDB* _tmp2_;
#line 269 "user.vala"
		_tmp1_ = click_db_new ();
#line 269 "user.vala"
		_g_object_unref0 (real_db);
#line 269 "user.vala"
		real_db = _tmp1_;
#line 270 "user.vala"
		_tmp2_ = real_db;
#line 270 "user.vala"
		click_db_read (_tmp2_, NULL, &_inner_error0_);
#line 270 "user.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 270 "user.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 270 "user.vala"
				g_propagate_error (error, _inner_error0_);
#line 270 "user.vala"
				_g_free0 (real_name);
#line 270 "user.vala"
				_g_object_unref0 (real_db);
#line 270 "user.vala"
				_g_object_unref0 (self);
#line 270 "user.vala"
				return NULL;
#line 2186 "user.c"
			} else {
#line 270 "user.vala"
				_g_free0 (real_name);
#line 270 "user.vala"
				_g_object_unref0 (real_db);
#line 270 "user.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 270 "user.vala"
				g_clear_error (&_inner_error0_);
#line 270 "user.vala"
				return NULL;
#line 2198 "user.c"
			}
		}
	}
#line 272 "user.vala"
	if (name != NULL) {
#line 2204 "user.c"
		gchar* _tmp3_;
#line 273 "user.vala"
		_tmp3_ = g_strdup (name);
#line 273 "user.vala"
		_g_free0 (real_name);
#line 273 "user.vala"
		real_name = _tmp3_;
#line 2212 "user.c"
	} else {
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 275 "user.vala"
		_tmp4_ = g_get_user_name ();
#line 275 "user.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 275 "user.vala"
		_g_free0 (real_name);
#line 275 "user.vala"
		real_name = _tmp5_;
#line 2224 "user.c"
	}
#line 276 "user.vala"
	_tmp6_ = real_db;
#line 276 "user.vala"
	_tmp7_ = real_name;
#line 276 "user.vala"
	self = (ClickUser*) g_object_new (object_type, "db", _tmp6_, "name", _tmp7_, NULL);
#line 277 "user.vala"
	_g_object_unref0 (self->priv->users);
#line 277 "user.vala"
	self->priv->users = NULL;
#line 278 "user.vala"
	_g_object_unref0 (self->priv->user_pw);
#line 278 "user.vala"
	self->priv->user_pw = NULL;
#line 279 "user.vala"
	self->priv->dropped_privileges_count = 0;
#line 280 "user.vala"
	_g_free0 (self->priv->old_umask);
#line 280 "user.vala"
	self->priv->old_umask = NULL;
#line 263 "user.vala"
	_g_free0 (real_name);
#line 263 "user.vala"
	_g_object_unref0 (real_db);
#line 263 "user.vala"
	return self;
#line 2252 "user.c"
}

static ClickUser*
click_user_new (ClickDB* db,
                const gchar* name,
                GError** error)
{
#line 263 "user.vala"
	return click_user_construct (CLICK_TYPE_USER, db, name, error);
#line 2262 "user.c"
}

ClickUser*
click_user_construct_for_user (GType object_type,
                               ClickDB* db,
                               const gchar* name,
                               GError** error)
{
	ClickUser * self = NULL;
	GError* _inner_error0_ = NULL;
#line 284 "user.vala"
	self = (ClickUser*) click_user_construct (object_type, db, name, &_inner_error0_);
#line 284 "user.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 284 "user.vala"
		if (_inner_error0_->domain == G_FILE_ERROR) {
#line 284 "user.vala"
			g_propagate_error (error, _inner_error0_);
#line 284 "user.vala"
			_g_object_unref0 (self);
#line 284 "user.vala"
			return NULL;
#line 2285 "user.c"
		} else {
#line 284 "user.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 284 "user.vala"
			g_clear_error (&_inner_error0_);
#line 284 "user.vala"
			return NULL;
#line 2293 "user.c"
		}
	}
#line 283 "user.vala"
	return self;
#line 2298 "user.c"
}

ClickUser*
click_user_new_for_user (ClickDB* db,
                         const gchar* name,
                         GError** error)
{
#line 283 "user.vala"
	return click_user_construct_for_user (CLICK_TYPE_USER, db, name, error);
#line 2308 "user.c"
}

ClickUser*
click_user_construct_for_all_users (GType object_type,
                                    ClickDB* db,
                                    GError** error)
{
	ClickUser * self = NULL;
	GError* _inner_error0_ = NULL;
#line 288 "user.vala"
	self = (ClickUser*) click_user_construct (object_type, db, CLICK_ALL_USERS, &_inner_error0_);
#line 288 "user.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 288 "user.vala"
		if (_inner_error0_->domain == G_FILE_ERROR) {
#line 288 "user.vala"
			g_propagate_error (error, _inner_error0_);
#line 288 "user.vala"
			_g_object_unref0 (self);
#line 288 "user.vala"
			return NULL;
#line 2330 "user.c"
		} else {
#line 288 "user.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 288 "user.vala"
			g_clear_error (&_inner_error0_);
#line 288 "user.vala"
			return NULL;
#line 2338 "user.c"
		}
	}
#line 287 "user.vala"
	return self;
#line 2343 "user.c"
}

ClickUser*
click_user_new_for_all_users (ClickDB* db,
                              GError** error)
{
#line 287 "user.vala"
	return click_user_construct_for_all_users (CLICK_TYPE_USER, db, error);
#line 2352 "user.c"
}

ClickUser*
click_user_construct_for_gc_in_use (GType object_type,
                                    ClickDB* db,
                                    GError** error)
{
	ClickUser * self = NULL;
	GError* _inner_error0_ = NULL;
#line 292 "user.vala"
	self = (ClickUser*) click_user_construct (object_type, db, CLICK_GC_IN_USE_USER, &_inner_error0_);
#line 292 "user.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 292 "user.vala"
		if (_inner_error0_->domain == G_FILE_ERROR) {
#line 292 "user.vala"
			g_propagate_error (error, _inner_error0_);
#line 292 "user.vala"
			_g_object_unref0 (self);
#line 292 "user.vala"
			return NULL;
#line 2374 "user.c"
		} else {
#line 292 "user.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 292 "user.vala"
			g_clear_error (&_inner_error0_);
#line 292 "user.vala"
			return NULL;
#line 2382 "user.c"
		}
	}
#line 291 "user.vala"
	return self;
#line 2387 "user.c"
}

ClickUser*
click_user_new_for_gc_in_use (ClickDB* db,
                              GError** error)
{
#line 291 "user.vala"
	return click_user_construct_for_gc_in_use (CLICK_TYPE_USER, db, error);
#line 2396 "user.c"
}

/**
 * get_user_pw:
 *
 * Returns: The password file entry for this user.
 */
static ClickCachedPasswd*
click_user_get_user_pw (ClickUser* self,
                        GError** error)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	ClickCachedPasswd* _tmp2_;
	ClickCachedPasswd* _tmp12_;
	ClickCachedPasswd* _tmp13_;
	GError* _inner_error0_ = NULL;
	ClickCachedPasswd* result;
#line 311 "user.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 314 "user.vala"
	_tmp0_ = click_user_get_is_pseudo_user (self);
#line 314 "user.vala"
	_tmp1_ = _tmp0_;
#line 314 "user.vala"
	_vala_assert (!_tmp1_, "! is_pseudo_user");
#line 316 "user.vala"
	_tmp2_ = self->priv->user_pw;
#line 316 "user.vala"
	if (_tmp2_ == NULL) {
#line 2427 "user.c"
		struct passwd* pw = NULL;
		const gchar* _tmp3_;
		struct passwd* _tmp4_;
		struct passwd* _tmp5_;
		struct passwd* _tmp9_;
		struct passwd* _tmp10_;
		ClickCachedPasswd* _tmp11_;
#line 317 "user.vala"
		errno = 0;
#line 318 "user.vala"
		_tmp3_ = self->priv->_name;
#line 318 "user.vala"
		_tmp4_ = getpwnam (_tmp3_);
#line 318 "user.vala"
		pw = _tmp4_;
#line 319 "user.vala"
		_tmp5_ = pw;
#line 319 "user.vala"
		if (_tmp5_ == NULL) {
#line 2447 "user.c"
			const gchar* _tmp6_;
			const gchar* _tmp7_;
			GError* _tmp8_;
#line 320 "user.vala"
			_tmp6_ = self->priv->_name;
#line 320 "user.vala"
			_tmp7_ = g_strerror (errno);
#line 320 "user.vala"
			_tmp8_ = g_error_new (CLICK_USER_ERROR, CLICK_USER_ERROR_GETPWNAM, "Cannot get password file entry for " "%s: %s", _tmp6_, _tmp7_);
#line 320 "user.vala"
			_inner_error0_ = _tmp8_;
#line 320 "user.vala"
			if (_inner_error0_->domain == CLICK_USER_ERROR) {
#line 320 "user.vala"
				g_propagate_error (error, _inner_error0_);
#line 320 "user.vala"
				return NULL;
#line 2465 "user.c"
			} else {
#line 320 "user.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 320 "user.vala"
				g_clear_error (&_inner_error0_);
#line 320 "user.vala"
				return NULL;
#line 2473 "user.c"
			}
		}
#line 323 "user.vala"
		_tmp9_ = pw;
#line 323 "user.vala"
		_tmp10_ = pw;
#line 323 "user.vala"
		_tmp11_ = click_cached_passwd_new (_tmp9_->pw_uid, _tmp10_->pw_gid);
#line 323 "user.vala"
		_g_object_unref0 (self->priv->user_pw);
#line 323 "user.vala"
		self->priv->user_pw = _tmp11_;
#line 2486 "user.c"
	}
#line 325 "user.vala"
	_tmp12_ = self->priv->user_pw;
#line 325 "user.vala"
	_tmp13_ = _g_object_ref0 (_tmp12_);
#line 325 "user.vala"
	result = _tmp13_;
#line 325 "user.vala"
	return result;
#line 2496 "user.c"
}

/**
 * get_overlay_db:
 *
 * Returns: The path to the overlay database for this user, i.e. the
 * path where new packages will be installed.
 */
gchar*
click_user_get_overlay_db (ClickUser* self)
{
	ClickDB* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 334 "user.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 337 "user.vala"
	_tmp0_ = self->priv->_db;
#line 337 "user.vala"
	_tmp1_ = click_db_get_overlay (_tmp0_);
#line 337 "user.vala"
	_tmp2_ = _tmp1_;
#line 337 "user.vala"
	_tmp3_ = self->priv->_name;
#line 337 "user.vala"
	_tmp4_ = click_db_for_user (_tmp2_, _tmp3_);
#line 337 "user.vala"
	result = _tmp4_;
#line 337 "user.vala"
	return result;
#line 2530 "user.c"
}

static void
click_user_ensure_db (ClickUser* self,
                      GError** error)
{
	ClickUsers* _tmp0_;
	ClickUsers* _tmp3_;
	gchar* path = NULL;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 340 "user.vala"
	g_return_if_fail (self != NULL);
#line 343 "user.vala"
	_tmp0_ = self->priv->users;
#line 343 "user.vala"
	if (_tmp0_ == NULL) {
#line 2549 "user.c"
		ClickDB* _tmp1_;
		ClickUsers* _tmp2_;
#line 344 "user.vala"
		_tmp1_ = self->priv->_db;
#line 344 "user.vala"
		_tmp2_ = click_users_new (_tmp1_);
#line 344 "user.vala"
		_g_object_unref0 (self->priv->users);
#line 344 "user.vala"
		self->priv->users = _tmp2_;
#line 2560 "user.c"
	}
#line 345 "user.vala"
	_tmp3_ = self->priv->users;
#line 345 "user.vala"
	click_users_ensure_db (_tmp3_, &_inner_error0_);
#line 345 "user.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 345 "user.vala"
		if (_inner_error0_->domain == CLICK_USER_ERROR) {
#line 345 "user.vala"
			g_propagate_error (error, _inner_error0_);
#line 345 "user.vala"
			return;
#line 2574 "user.c"
		} else {
#line 345 "user.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 345 "user.vala"
			g_clear_error (&_inner_error0_);
#line 345 "user.vala"
			return;
#line 2582 "user.c"
		}
	}
#line 346 "user.vala"
	_tmp4_ = click_user_get_overlay_db (self);
#line 346 "user.vala"
	path = _tmp4_;
#line 347 "user.vala"
	_tmp5_ = path;
#line 347 "user.vala"
	if (!click_exists (_tmp5_)) {
#line 2593 "user.c"
		const gchar* _tmp6_;
		gboolean _tmp7_ = FALSE;
#line 348 "user.vala"
		_tmp6_ = path;
#line 348 "user.vala"
		click_try_create (_tmp6_, &_inner_error0_);
#line 348 "user.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 348 "user.vala"
			if (_inner_error0_->domain == CLICK_USER_ERROR) {
#line 348 "user.vala"
				g_propagate_error (error, _inner_error0_);
#line 348 "user.vala"
				_g_free0 (path);
#line 348 "user.vala"
				return;
#line 2610 "user.c"
			} else {
#line 348 "user.vala"
				_g_free0 (path);
#line 348 "user.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 348 "user.vala"
				g_clear_error (&_inner_error0_);
#line 348 "user.vala"
				return;
#line 2620 "user.c"
			}
		}
#line 349 "user.vala"
		if (geteuid () == ((uid_t) 0)) {
#line 2625 "user.c"
			gboolean _tmp8_;
			gboolean _tmp9_;
#line 349 "user.vala"
			_tmp8_ = click_user_get_is_pseudo_user (self);
#line 349 "user.vala"
			_tmp9_ = _tmp8_;
#line 349 "user.vala"
			_tmp7_ = !_tmp9_;
#line 2634 "user.c"
		} else {
#line 349 "user.vala"
			_tmp7_ = FALSE;
#line 2638 "user.c"
		}
#line 349 "user.vala"
		if (_tmp7_) {
#line 2642 "user.c"
			ClickCachedPasswd* _tmp10_ = NULL;
			ClickCachedPasswd* _tmp11_;
			const gchar* _tmp12_;
#line 350 "user.vala"
			_tmp11_ = click_user_get_user_pw (self, &_inner_error0_);
#line 350 "user.vala"
			_tmp10_ = _tmp11_;
#line 350 "user.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 350 "user.vala"
				if (_inner_error0_->domain == CLICK_USER_ERROR) {
#line 350 "user.vala"
					g_propagate_error (error, _inner_error0_);
#line 350 "user.vala"
					_g_free0 (path);
#line 350 "user.vala"
					return;
#line 2660 "user.c"
				} else {
#line 350 "user.vala"
					_g_free0 (path);
#line 350 "user.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 350 "user.vala"
					g_clear_error (&_inner_error0_);
#line 350 "user.vala"
					return;
#line 2670 "user.c"
				}
			}
#line 350 "user.vala"
			_tmp12_ = path;
#line 350 "user.vala"
			click_try_chown (_tmp12_, _tmp10_, &_inner_error0_);
#line 350 "user.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 350 "user.vala"
				if (_inner_error0_->domain == CLICK_USER_ERROR) {
#line 350 "user.vala"
					g_propagate_error (error, _inner_error0_);
#line 350 "user.vala"
					_g_object_unref0 (_tmp10_);
#line 350 "user.vala"
					_g_free0 (path);
#line 350 "user.vala"
					return;
#line 2689 "user.c"
				} else {
#line 350 "user.vala"
					_g_object_unref0 (_tmp10_);
#line 350 "user.vala"
					_g_free0 (path);
#line 350 "user.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 350 "user.vala"
					g_clear_error (&_inner_error0_);
#line 350 "user.vala"
					return;
#line 2701 "user.c"
				}
			}
#line 349 "user.vala"
			_g_object_unref0 (_tmp10_);
#line 2706 "user.c"
		}
	}
#line 340 "user.vala"
	_g_free0 (path);
#line 2711 "user.c"
}

static void
click_user_priv_drop_failure (ClickUser* self,
                              const gchar* name,
                              GError** error)
{
	const gchar* _tmp0_;
	GError* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 362 "user.vala"
	g_return_if_fail (self != NULL);
#line 362 "user.vala"
	g_return_if_fail (name != NULL);
#line 365 "user.vala"
	_tmp0_ = g_strerror (errno);
#line 365 "user.vala"
	_tmp1_ = g_error_new (CLICK_USER_ERROR, CLICK_USER_ERROR_DROP_PRIVS, "Cannot drop privileges (%s): %s", name, _tmp0_);
#line 365 "user.vala"
	_inner_error0_ = _tmp1_;
#line 365 "user.vala"
	if (_inner_error0_->domain == CLICK_USER_ERROR) {
#line 365 "user.vala"
		g_propagate_error (error, _inner_error0_);
#line 365 "user.vala"
		return;
#line 2738 "user.c"
	} else {
#line 365 "user.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 365 "user.vala"
		g_clear_error (&_inner_error0_);
#line 365 "user.vala"
		return;
#line 2746 "user.c"
	}
}

static mode_t*
_mode_t_dup (mode_t* self)
{
	mode_t* dup;
#line 384 "user.vala"
	dup = g_new0 (mode_t, 1);
#line 384 "user.vala"
	memcpy (dup, self, sizeof (mode_t));
#line 384 "user.vala"
	return dup;
#line 2760 "user.c"
}

static gpointer
__mode_t_dup0 (gpointer self)
{
#line 384 "user.vala"
	return self ? _mode_t_dup (self) : NULL;
#line 2768 "user.c"
}

void
click_user_drop_privileges (ClickUser* self,
                            GError** error)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gint _tmp9_;
	GError* _inner_error0_ = NULL;
#line 370 "user.vala"
	g_return_if_fail (self != NULL);
#line 373 "user.vala"
	if (self->priv->dropped_privileges_count == 0) {
#line 374 "user.vala"
		_tmp1_ = getuid () == ((uid_t) 0);
#line 2785 "user.c"
	} else {
#line 373 "user.vala"
		_tmp1_ = FALSE;
#line 2789 "user.c"
	}
#line 373 "user.vala"
	if (_tmp1_) {
#line 2793 "user.c"
		gboolean _tmp2_;
		gboolean _tmp3_;
#line 374 "user.vala"
		_tmp2_ = click_user_get_is_pseudo_user (self);
#line 374 "user.vala"
		_tmp3_ = _tmp2_;
#line 374 "user.vala"
		_tmp0_ = !_tmp3_;
#line 2802 "user.c"
	} else {
#line 373 "user.vala"
		_tmp0_ = FALSE;
#line 2806 "user.c"
	}
#line 373 "user.vala"
	if (_tmp0_) {
#line 2810 "user.c"
		ClickCachedPasswd* pw = NULL;
		ClickCachedPasswd* _tmp4_;
		ClickCachedPasswd* _tmp5_;
		ClickCachedPasswd* _tmp6_;
		mode_t _tmp7_;
		mode_t* _tmp8_;
#line 379 "user.vala"
		_tmp4_ = click_user_get_user_pw (self, &_inner_error0_);
#line 379 "user.vala"
		pw = _tmp4_;
#line 379 "user.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 379 "user.vala"
			if (_inner_error0_->domain == CLICK_USER_ERROR) {
#line 379 "user.vala"
				g_propagate_error (error, _inner_error0_);
#line 379 "user.vala"
				return;
#line 2829 "user.c"
			} else {
#line 379 "user.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 379 "user.vala"
				g_clear_error (&_inner_error0_);
#line 379 "user.vala"
				return;
#line 2837 "user.c"
			}
		}
#line 380 "user.vala"
		_tmp5_ = pw;
#line 380 "user.vala"
		if (setegid (_tmp5_->gid) < 0) {
#line 381 "user.vala"
			click_user_priv_drop_failure (self, "setegid", &_inner_error0_);
#line 381 "user.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 381 "user.vala"
				if (_inner_error0_->domain == CLICK_USER_ERROR) {
#line 381 "user.vala"
					g_propagate_error (error, _inner_error0_);
#line 381 "user.vala"
					_g_object_unref0 (pw);
#line 381 "user.vala"
					return;
#line 2856 "user.c"
				} else {
#line 381 "user.vala"
					_g_object_unref0 (pw);
#line 381 "user.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 381 "user.vala"
					g_clear_error (&_inner_error0_);
#line 381 "user.vala"
					return;
#line 2866 "user.c"
				}
			}
		}
#line 382 "user.vala"
		_tmp6_ = pw;
#line 382 "user.vala"
		if (seteuid (_tmp6_->uid) < 0) {
#line 383 "user.vala"
			click_user_priv_drop_failure (self, "seteuid", &_inner_error0_);
#line 383 "user.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 383 "user.vala"
				if (_inner_error0_->domain == CLICK_USER_ERROR) {
#line 383 "user.vala"
					g_propagate_error (error, _inner_error0_);
#line 383 "user.vala"
					_g_object_unref0 (pw);
#line 383 "user.vala"
					return;
#line 2886 "user.c"
				} else {
#line 383 "user.vala"
					_g_object_unref0 (pw);
#line 383 "user.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 383 "user.vala"
					g_clear_error (&_inner_error0_);
#line 383 "user.vala"
					return;
#line 2896 "user.c"
				}
			}
		}
#line 384 "user.vala"
		_tmp7_ = umask ((mode_t) (click_get_umask () | S_IWOTH));
#line 384 "user.vala"
		_tmp8_ = __mode_t_dup0 (&_tmp7_);
#line 384 "user.vala"
		_g_free0 (self->priv->old_umask);
#line 384 "user.vala"
		self->priv->old_umask = _tmp8_;
#line 373 "user.vala"
		_g_object_unref0 (pw);
#line 2910 "user.c"
	}
#line 387 "user.vala"
	self->priv->dropped_privileges_count = self->priv->dropped_privileges_count + 1;
#line 387 "user.vala"
	_tmp9_ = self->priv->dropped_privileges_count;
#line 2916 "user.c"
}

static void
click_user_priv_regain_failure (ClickUser* self,
                                const gchar* name)
{
	const gchar* _tmp0_;
#line 390 "user.vala"
	g_return_if_fail (self != NULL);
#line 390 "user.vala"
	g_return_if_fail (name != NULL);
#line 396 "user.vala"
	_tmp0_ = g_strerror (errno);
#line 396 "user.vala"
	g_error ("user.vala:396: Cannot regain privileges (%s): %s", name, _tmp0_);
#line 2932 "user.c"
}

void
click_user_regain_privileges (ClickUser* self)
{
	gint _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 400 "user.vala"
	g_return_if_fail (self != NULL);
#line 403 "user.vala"
	self->priv->dropped_privileges_count = self->priv->dropped_privileges_count - 1;
#line 403 "user.vala"
	_tmp0_ = self->priv->dropped_privileges_count;
#line 405 "user.vala"
	if (self->priv->dropped_privileges_count == 0) {
#line 406 "user.vala"
		_tmp2_ = getuid () == ((uid_t) 0);
#line 2951 "user.c"
	} else {
#line 405 "user.vala"
		_tmp2_ = FALSE;
#line 2955 "user.c"
	}
#line 405 "user.vala"
	if (_tmp2_) {
#line 2959 "user.c"
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 406 "user.vala"
		_tmp3_ = click_user_get_is_pseudo_user (self);
#line 406 "user.vala"
		_tmp4_ = _tmp3_;
#line 406 "user.vala"
		_tmp1_ = !_tmp4_;
#line 2968 "user.c"
	} else {
#line 405 "user.vala"
		_tmp1_ = FALSE;
#line 2972 "user.c"
	}
#line 405 "user.vala"
	if (_tmp1_) {
#line 2976 "user.c"
		mode_t* _tmp5_;
#line 407 "user.vala"
		_tmp5_ = self->priv->old_umask;
#line 407 "user.vala"
		if (_tmp5_ != NULL) {
#line 2982 "user.c"
			mode_t* _tmp6_;
#line 408 "user.vala"
			_tmp6_ = self->priv->old_umask;
#line 408 "user.vala"
			umask (*_tmp6_);
#line 2988 "user.c"
		}
#line 409 "user.vala"
		if (seteuid ((uid_t) 0) < 0) {
#line 410 "user.vala"
			click_user_priv_regain_failure (self, "seteuid");
#line 2994 "user.c"
		}
#line 411 "user.vala"
		if (setegid ((gid_t) 0) < 0) {
#line 412 "user.vala"
			click_user_priv_regain_failure (self, "setegid");
#line 3000 "user.c"
		}
	}
}

static gboolean
click_user_is_valid_link (ClickUser* self,
                          const gchar* path)
{
	gboolean _tmp3_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 416 "user.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 416 "user.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 419 "user.vala"
	if (!click_is_symlink (path)) {
#line 420 "user.vala"
		result = FALSE;
#line 420 "user.vala"
		return result;
#line 3022 "user.c"
	}
	{
		gchar* target = NULL;
		gchar* _tmp0_;
		const gchar* _tmp2_;
#line 423 "user.vala"
		_tmp0_ = g_file_read_link (path, &_inner_error0_);
#line 423 "user.vala"
		target = _tmp0_;
#line 423 "user.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3034 "user.c"
			gboolean _tmp1_ = FALSE;
#line 423 "user.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 3038 "user.c"
				goto __catch0_g_file_error;
			}
#line 423 "user.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 423 "user.vala"
			g_clear_error (&_inner_error0_);
#line 423 "user.vala"
			return _tmp1_;
#line 3047 "user.c"
		}
#line 424 "user.vala"
		_tmp2_ = target;
#line 424 "user.vala"
		result = !g_str_has_prefix (_tmp2_, "@");
#line 424 "user.vala"
		_g_free0 (target);
#line 424 "user.vala"
		return result;
#line 3057 "user.c"
	}
	goto __finally0;
	__catch0_g_file_error:
	{
#line 422 "user.vala"
		g_clear_error (&_inner_error0_);
#line 426 "user.vala"
		result = FALSE;
#line 426 "user.vala"
		return result;
#line 3068 "user.c"
	}
	__finally0:
#line 422 "user.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 422 "user.vala"
	g_clear_error (&_inner_error0_);
#line 422 "user.vala"
	return _tmp3_;
#line 3077 "user.c"
}

static GList*
click_user_get_package_names_dropped (ClickUser* self,
                                      GError** error)
{
	GList* entries = NULL;
	GeeHashSet* hidden = NULL;
	GeeHashSet* _tmp0_;
	GError* _inner_error0_ = NULL;
	GList* result;
#line 430 "user.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 433 "user.vala"
	entries = NULL;
#line 434 "user.vala"
	_tmp0_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 434 "user.vala"
	hidden = _tmp0_;
#line 3097 "user.c"
	{
		gint i = 0;
		ClickDB* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
#line 435 "user.vala"
		_tmp1_ = self->priv->_db;
#line 435 "user.vala"
		_tmp2_ = click_db_get_size (_tmp1_);
#line 435 "user.vala"
		_tmp3_ = _tmp2_;
#line 435 "user.vala"
		i = _tmp3_ - 1;
#line 3111 "user.c"
		{
			gboolean _tmp4_ = FALSE;
#line 435 "user.vala"
			_tmp4_ = TRUE;
#line 435 "user.vala"
			while (TRUE) {
#line 3118 "user.c"
				ClickSingleDB* _tmp6_ = NULL;
				ClickDB* _tmp7_;
				ClickSingleDB* _tmp8_;
				gchar* user_db = NULL;
				const gchar* _tmp9_;
				const gchar* _tmp10_;
				const gchar* _tmp11_;
				gchar* _tmp12_;
				ClickDir* _tmp13_ = NULL;
				const gchar* _tmp14_;
				ClickDir* _tmp15_;
				const gchar* _tmp38_;
#line 435 "user.vala"
				if (!_tmp4_) {
#line 3133 "user.c"
					gint _tmp5_;
#line 435 "user.vala"
					i = i - 1;
#line 435 "user.vala"
					_tmp5_ = i;
#line 3139 "user.c"
				}
#line 435 "user.vala"
				_tmp4_ = FALSE;
#line 435 "user.vala"
				if (!(i >= 0)) {
#line 435 "user.vala"
					break;
#line 3147 "user.c"
				}
#line 436 "user.vala"
				_tmp7_ = self->priv->_db;
#line 436 "user.vala"
				_tmp8_ = click_db_get (_tmp7_, i, &_inner_error0_);
#line 436 "user.vala"
				_tmp6_ = _tmp8_;
#line 436 "user.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 436 "user.vala"
					g_propagate_error (error, _inner_error0_);
#line 436 "user.vala"
					_g_object_unref0 (hidden);
#line 436 "user.vala"
					(entries == NULL) ? NULL : (entries = (_g_list_free__g_free0_ (entries), NULL));
#line 436 "user.vala"
					return NULL;
#line 3165 "user.c"
				}
#line 436 "user.vala"
				_tmp9_ = click_single_db_get_root (_tmp6_);
#line 436 "user.vala"
				_tmp10_ = _tmp9_;
#line 436 "user.vala"
				_tmp11_ = self->priv->_name;
#line 436 "user.vala"
				_tmp12_ = click_db_for_user (_tmp10_, _tmp11_);
#line 436 "user.vala"
				user_db = _tmp12_;
#line 437 "user.vala"
				_tmp14_ = user_db;
#line 437 "user.vala"
				_tmp15_ = click_dir_open (_tmp14_, (guint) 0, &_inner_error0_);
#line 437 "user.vala"
				_tmp13_ = _tmp15_;
#line 437 "user.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 437 "user.vala"
					g_propagate_error (error, _inner_error0_);
#line 437 "user.vala"
					_g_free0 (user_db);
#line 437 "user.vala"
					_g_object_unref0 (_tmp6_);
#line 437 "user.vala"
					_g_object_unref0 (hidden);
#line 437 "user.vala"
					(entries == NULL) ? NULL : (entries = (_g_list_free__g_free0_ (entries), NULL));
#line 437 "user.vala"
					return NULL;
#line 3197 "user.c"
				}
				{
					ClickDirIterator* _entry_it = NULL;
					ClickDirIterator* _tmp16_;
					const gchar* entry = NULL;
#line 437 "user.vala"
					_tmp16_ = click_dir_iterator (_tmp13_);
#line 437 "user.vala"
					_entry_it = _tmp16_;
#line 437 "user.vala"
					while (TRUE) {
#line 3209 "user.c"
						ClickDirIterator* _tmp17_;
						const gchar* _tmp18_;
						const gchar* _tmp19_;
						gboolean _tmp20_ = FALSE;
						GList* _tmp21_;
						const gchar* _tmp22_;
						GCompareFunc _tmp23_;
						GList* _tmp24_;
						gchar* path = NULL;
						const gchar* _tmp27_;
						const gchar* _tmp28_;
						gchar* _tmp29_;
						const gchar* _tmp30_;
#line 437 "user.vala"
						_tmp17_ = _entry_it;
#line 437 "user.vala"
						_tmp18_ = click_dir_iterator_next_value (_tmp17_);
#line 437 "user.vala"
						entry = _tmp18_;
#line 437 "user.vala"
						_tmp19_ = entry;
#line 437 "user.vala"
						if (!(_tmp19_ != NULL)) {
#line 437 "user.vala"
							break;
#line 3235 "user.c"
						}
#line 438 "user.vala"
						_tmp21_ = entries;
#line 438 "user.vala"
						_tmp22_ = entry;
#line 438 "user.vala"
						_tmp23_ = ((GCompareFunc) g_strcmp0);
#line 438 "user.vala"
						_tmp24_ = g_list_find_custom (_tmp21_, _tmp22_, _tmp23_);
#line 438 "user.vala"
						if (_tmp24_ != NULL) {
#line 438 "user.vala"
							_tmp20_ = TRUE;
#line 3249 "user.c"
						} else {
							GeeHashSet* _tmp25_;
							const gchar* _tmp26_;
#line 440 "user.vala"
							_tmp25_ = hidden;
#line 440 "user.vala"
							_tmp26_ = entry;
#line 440 "user.vala"
							_tmp20_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp25_, _tmp26_);
#line 3259 "user.c"
						}
#line 438 "user.vala"
						if (_tmp20_) {
#line 441 "user.vala"
							continue;
#line 3265 "user.c"
						}
#line 442 "user.vala"
						_tmp27_ = user_db;
#line 442 "user.vala"
						_tmp28_ = entry;
#line 442 "user.vala"
						_tmp29_ = g_build_filename (_tmp27_, _tmp28_, NULL);
#line 442 "user.vala"
						path = _tmp29_;
#line 443 "user.vala"
						_tmp30_ = path;
#line 443 "user.vala"
						if (click_user_is_valid_link (self, _tmp30_)) {
#line 3279 "user.c"
							const gchar* _tmp31_;
							gchar* _tmp32_;
#line 444 "user.vala"
							_tmp31_ = entry;
#line 444 "user.vala"
							_tmp32_ = g_strdup (_tmp31_);
#line 444 "user.vala"
							entries = g_list_prepend (entries, _tmp32_);
#line 3288 "user.c"
						} else {
							const gchar* _tmp33_;
#line 445 "user.vala"
							_tmp33_ = path;
#line 445 "user.vala"
							if (click_is_symlink (_tmp33_)) {
#line 3295 "user.c"
								GeeHashSet* _tmp34_;
								const gchar* _tmp35_;
								gchar* _tmp36_;
								gchar* _tmp37_;
#line 446 "user.vala"
								_tmp34_ = hidden;
#line 446 "user.vala"
								_tmp35_ = entry;
#line 446 "user.vala"
								_tmp36_ = g_strdup (_tmp35_);
#line 446 "user.vala"
								_tmp37_ = _tmp36_;
#line 446 "user.vala"
								gee_abstract_collection_add ((GeeAbstractCollection*) _tmp34_, _tmp37_);
#line 446 "user.vala"
								_g_free0 (_tmp37_);
#line 3312 "user.c"
							}
						}
#line 437 "user.vala"
						_g_free0 (path);
#line 3317 "user.c"
					}
#line 437 "user.vala"
					_g_object_unref0 (_entry_it);
#line 3321 "user.c"
				}
#line 449 "user.vala"
				_tmp38_ = self->priv->_name;
#line 449 "user.vala"
				if (g_strcmp0 (_tmp38_, CLICK_ALL_USERS) != 0) {
#line 3327 "user.c"
					ClickSingleDB* _tmp39_ = NULL;
					ClickDB* _tmp40_;
					ClickSingleDB* _tmp41_;
					gchar* all_users_db = NULL;
					const gchar* _tmp42_;
					const gchar* _tmp43_;
					gchar* _tmp44_;
					ClickDir* _tmp45_ = NULL;
					const gchar* _tmp46_;
					ClickDir* _tmp47_;
#line 450 "user.vala"
					_tmp40_ = self->priv->_db;
#line 450 "user.vala"
					_tmp41_ = click_db_get (_tmp40_, i, &_inner_error0_);
#line 450 "user.vala"
					_tmp39_ = _tmp41_;
#line 450 "user.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 450 "user.vala"
						g_propagate_error (error, _inner_error0_);
#line 450 "user.vala"
						_g_object_unref0 (_tmp13_);
#line 450 "user.vala"
						_g_free0 (user_db);
#line 450 "user.vala"
						_g_object_unref0 (_tmp6_);
#line 450 "user.vala"
						_g_object_unref0 (hidden);
#line 450 "user.vala"
						(entries == NULL) ? NULL : (entries = (_g_list_free__g_free0_ (entries), NULL));
#line 450 "user.vala"
						return NULL;
#line 3360 "user.c"
					}
#line 450 "user.vala"
					_tmp42_ = click_single_db_get_root (_tmp39_);
#line 450 "user.vala"
					_tmp43_ = _tmp42_;
#line 450 "user.vala"
					_tmp44_ = click_db_for_user (_tmp43_, CLICK_ALL_USERS);
#line 450 "user.vala"
					all_users_db = _tmp44_;
#line 452 "user.vala"
					_tmp46_ = all_users_db;
#line 452 "user.vala"
					_tmp47_ = click_dir_open (_tmp46_, (guint) 0, &_inner_error0_);
#line 452 "user.vala"
					_tmp45_ = _tmp47_;
#line 452 "user.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 452 "user.vala"
						g_propagate_error (error, _inner_error0_);
#line 452 "user.vala"
						_g_free0 (all_users_db);
#line 452 "user.vala"
						_g_object_unref0 (_tmp39_);
#line 452 "user.vala"
						_g_object_unref0 (_tmp13_);
#line 452 "user.vala"
						_g_free0 (user_db);
#line 452 "user.vala"
						_g_object_unref0 (_tmp6_);
#line 452 "user.vala"
						_g_object_unref0 (hidden);
#line 452 "user.vala"
						(entries == NULL) ? NULL : (entries = (_g_list_free__g_free0_ (entries), NULL));
#line 452 "user.vala"
						return NULL;
#line 3396 "user.c"
					}
					{
						ClickDirIterator* _entry_it = NULL;
						ClickDirIterator* _tmp48_;
						const gchar* entry = NULL;
#line 452 "user.vala"
						_tmp48_ = click_dir_iterator (_tmp45_);
#line 452 "user.vala"
						_entry_it = _tmp48_;
#line 452 "user.vala"
						while (TRUE) {
#line 3408 "user.c"
							ClickDirIterator* _tmp49_;
							const gchar* _tmp50_;
							const gchar* _tmp51_;
							gboolean _tmp52_ = FALSE;
							GList* _tmp53_;
							const gchar* _tmp54_;
							GCompareFunc _tmp55_;
							GList* _tmp56_;
							gchar* path = NULL;
							const gchar* _tmp59_;
							const gchar* _tmp60_;
							gchar* _tmp61_;
							const gchar* _tmp62_;
#line 452 "user.vala"
							_tmp49_ = _entry_it;
#line 452 "user.vala"
							_tmp50_ = click_dir_iterator_next_value (_tmp49_);
#line 452 "user.vala"
							entry = _tmp50_;
#line 452 "user.vala"
							_tmp51_ = entry;
#line 452 "user.vala"
							if (!(_tmp51_ != NULL)) {
#line 452 "user.vala"
								break;
#line 3434 "user.c"
							}
#line 454 "user.vala"
							_tmp53_ = entries;
#line 454 "user.vala"
							_tmp54_ = entry;
#line 454 "user.vala"
							_tmp55_ = ((GCompareFunc) g_strcmp0);
#line 454 "user.vala"
							_tmp56_ = g_list_find_custom (_tmp53_, _tmp54_, _tmp55_);
#line 454 "user.vala"
							if (_tmp56_ != NULL) {
#line 454 "user.vala"
								_tmp52_ = TRUE;
#line 3448 "user.c"
							} else {
								GeeHashSet* _tmp57_;
								const gchar* _tmp58_;
#line 456 "user.vala"
								_tmp57_ = hidden;
#line 456 "user.vala"
								_tmp58_ = entry;
#line 456 "user.vala"
								_tmp52_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp57_, _tmp58_);
#line 3458 "user.c"
							}
#line 454 "user.vala"
							if (_tmp52_) {
#line 457 "user.vala"
								continue;
#line 3464 "user.c"
							}
#line 458 "user.vala"
							_tmp59_ = all_users_db;
#line 458 "user.vala"
							_tmp60_ = entry;
#line 458 "user.vala"
							_tmp61_ = g_build_filename (_tmp59_, _tmp60_, NULL);
#line 458 "user.vala"
							path = _tmp61_;
#line 460 "user.vala"
							_tmp62_ = path;
#line 460 "user.vala"
							if (click_user_is_valid_link (self, _tmp62_)) {
#line 3478 "user.c"
								const gchar* _tmp63_;
								gchar* _tmp64_;
#line 461 "user.vala"
								_tmp63_ = entry;
#line 461 "user.vala"
								_tmp64_ = g_strdup (_tmp63_);
#line 461 "user.vala"
								entries = g_list_prepend (entries, _tmp64_);
#line 3487 "user.c"
							} else {
								const gchar* _tmp65_;
#line 462 "user.vala"
								_tmp65_ = path;
#line 462 "user.vala"
								if (click_is_symlink (_tmp65_)) {
#line 3494 "user.c"
									GeeHashSet* _tmp66_;
									const gchar* _tmp67_;
									gchar* _tmp68_;
									gchar* _tmp69_;
#line 463 "user.vala"
									_tmp66_ = hidden;
#line 463 "user.vala"
									_tmp67_ = entry;
#line 463 "user.vala"
									_tmp68_ = g_strdup (_tmp67_);
#line 463 "user.vala"
									_tmp69_ = _tmp68_;
#line 463 "user.vala"
									gee_abstract_collection_add ((GeeAbstractCollection*) _tmp66_, _tmp69_);
#line 463 "user.vala"
									_g_free0 (_tmp69_);
#line 3511 "user.c"
								}
							}
#line 452 "user.vala"
							_g_free0 (path);
#line 3516 "user.c"
						}
#line 452 "user.vala"
						_g_object_unref0 (_entry_it);
#line 3520 "user.c"
					}
#line 449 "user.vala"
					_g_object_unref0 (_tmp45_);
#line 449 "user.vala"
					_g_free0 (all_users_db);
#line 449 "user.vala"
					_g_object_unref0 (_tmp39_);
#line 3528 "user.c"
				}
#line 435 "user.vala"
				_g_object_unref0 (_tmp13_);
#line 435 "user.vala"
				_g_free0 (user_db);
#line 435 "user.vala"
				_g_object_unref0 (_tmp6_);
#line 3536 "user.c"
			}
		}
	}
#line 467 "user.vala"
	entries = g_list_reverse (entries);
#line 468 "user.vala"
	result = entries;
#line 468 "user.vala"
	_g_object_unref0 (hidden);
#line 468 "user.vala"
	return result;
#line 3548 "user.c"
}

/**
 * get_package_names:
 *
 * Returns: (transfer full): A list of package names installed for
 * this user.
 */
GList*
click_user_get_package_names (ClickUser* self,
                              GError** error)
{
	GError* _inner_error0_ = NULL;
	GList* result;
#line 477 "user.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 480 "user.vala"
	click_user_drop_privileges (self, &_inner_error0_);
#line 480 "user.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 480 "user.vala"
		g_propagate_error (error, _inner_error0_);
#line 480 "user.vala"
		return NULL;
#line 3573 "user.c"
	}
	{
		GList* _tmp0_ = NULL;
		GList* _tmp1_;
		GList* _tmp2_;
#line 482 "user.vala"
		_tmp1_ = click_user_get_package_names_dropped (self, &_inner_error0_);
#line 482 "user.vala"
		_tmp0_ = _tmp1_;
#line 482 "user.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3585 "user.c"
			goto __finally0;
		}
#line 482 "user.vala"
		_tmp2_ = _tmp0_;
#line 482 "user.vala"
		_tmp0_ = NULL;
#line 482 "user.vala"
		result = _tmp2_;
#line 482 "user.vala"
		(_tmp0_ == NULL) ? NULL : (_tmp0_ = (_g_list_free__g_free0_ (_tmp0_), NULL));
#line 3596 "user.c"
		{
			GError* _inner_error0_ = NULL;
#line 484 "user.vala"
			click_user_regain_privileges (self);
#line 3601 "user.c"
		}
#line 482 "user.vala"
		return result;
#line 3605 "user.c"
	}
	__finally0:
	{
		GError* _inner_error1_ = NULL;
#line 484 "user.vala"
		click_user_regain_privileges (self);
#line 3612 "user.c"
	}
#line 481 "user.vala"
	g_propagate_error (error, _inner_error0_);
#line 481 "user.vala"
	return NULL;
#line 3618 "user.c"
}

/**
 * has_package_name:
 * @package: A package name.
 *
 * Returns: True if this user has a version of @package registered,
 * otherwise false.
 */
gboolean
click_user_has_package_name (ClickUser* self,
                             const gchar* package)
{
	gboolean _tmp3_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 495 "user.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 495 "user.vala"
	g_return_val_if_fail (package != NULL, FALSE);
#line 3639 "user.c"
	{
		gchar* _tmp0_;
		gchar* _tmp1_;
#line 499 "user.vala"
		_tmp0_ = click_user_get_version (self, package, &_inner_error0_);
#line 499 "user.vala"
		_tmp1_ = _tmp0_;
#line 499 "user.vala"
		_g_free0 (_tmp1_);
#line 499 "user.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3651 "user.c"
			gboolean _tmp2_ = FALSE;
#line 499 "user.vala"
			if (_inner_error0_->domain == CLICK_USER_ERROR) {
#line 3655 "user.c"
				goto __catch0_click_user_error;
			}
#line 499 "user.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 499 "user.vala"
			g_clear_error (&_inner_error0_);
#line 499 "user.vala"
			return _tmp2_;
#line 3664 "user.c"
		}
#line 500 "user.vala"
		result = TRUE;
#line 500 "user.vala"
		return result;
#line 3670 "user.c"
	}
	goto __finally0;
	__catch0_click_user_error:
	{
#line 498 "user.vala"
		g_clear_error (&_inner_error0_);
#line 502 "user.vala"
		result = FALSE;
#line 502 "user.vala"
		return result;
#line 3681 "user.c"
	}
	__finally0:
#line 498 "user.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 498 "user.vala"
	g_clear_error (&_inner_error0_);
#line 498 "user.vala"
	return _tmp3_;
#line 3690 "user.c"
}

/**
 * get_version:
 * @package: A package name.
 *
 * Returns: The version of @package registered for this user.
 */
gchar*
click_user_get_version (ClickUser* self,
                        const gchar* package,
                        GError** error)
{
	const gchar* _tmp37_;
	GError* _tmp38_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 512 "user.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 512 "user.vala"
	g_return_val_if_fail (package != NULL, NULL);
#line 3712 "user.c"
	{
		gint i = 0;
		ClickDB* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
#line 515 "user.vala"
		_tmp0_ = self->priv->_db;
#line 515 "user.vala"
		_tmp1_ = click_db_get_size (_tmp0_);
#line 515 "user.vala"
		_tmp2_ = _tmp1_;
#line 515 "user.vala"
		i = _tmp2_ - 1;
#line 3726 "user.c"
		{
			gboolean _tmp3_ = FALSE;
#line 515 "user.vala"
			_tmp3_ = TRUE;
#line 515 "user.vala"
			while (TRUE) {
#line 3733 "user.c"
				ClickSingleDB* _tmp5_ = NULL;
				ClickDB* _tmp6_;
				ClickSingleDB* _tmp7_;
				gchar* user_db = NULL;
				const gchar* _tmp8_;
				const gchar* _tmp9_;
				const gchar* _tmp10_;
				gchar* _tmp11_;
				gchar* path = NULL;
				const gchar* _tmp12_;
				gchar* _tmp13_;
				ClickSingleDB* _tmp22_ = NULL;
				ClickDB* _tmp23_;
				ClickSingleDB* _tmp24_;
				gchar* all_users_db = NULL;
				const gchar* _tmp25_;
				const gchar* _tmp26_;
				gchar* _tmp27_;
				const gchar* _tmp28_;
				gchar* _tmp29_;
				const gchar* _tmp30_;
#line 515 "user.vala"
				if (!_tmp3_) {
#line 3757 "user.c"
					gint _tmp4_;
#line 515 "user.vala"
					i = i - 1;
#line 515 "user.vala"
					_tmp4_ = i;
#line 3763 "user.c"
				}
#line 515 "user.vala"
				_tmp3_ = FALSE;
#line 515 "user.vala"
				if (!(i >= 0)) {
#line 515 "user.vala"
					break;
#line 3771 "user.c"
				}
#line 516 "user.vala"
				_tmp6_ = self->priv->_db;
#line 516 "user.vala"
				_tmp7_ = click_db_get (_tmp6_, i, &_inner_error0_);
#line 516 "user.vala"
				_tmp5_ = _tmp7_;
#line 516 "user.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 516 "user.vala"
					if (_inner_error0_->domain == CLICK_USER_ERROR) {
#line 516 "user.vala"
						g_propagate_error (error, _inner_error0_);
#line 516 "user.vala"
						return NULL;
#line 3787 "user.c"
					} else {
#line 516 "user.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 516 "user.vala"
						g_clear_error (&_inner_error0_);
#line 516 "user.vala"
						return NULL;
#line 3795 "user.c"
					}
				}
#line 516 "user.vala"
				_tmp8_ = click_single_db_get_root (_tmp5_);
#line 516 "user.vala"
				_tmp9_ = _tmp8_;
#line 516 "user.vala"
				_tmp10_ = self->priv->_name;
#line 516 "user.vala"
				_tmp11_ = click_db_for_user (_tmp9_, _tmp10_);
#line 516 "user.vala"
				user_db = _tmp11_;
#line 517 "user.vala"
				_tmp12_ = user_db;
#line 517 "user.vala"
				_tmp13_ = g_build_filename (_tmp12_, package, NULL);
#line 517 "user.vala"
				path = _tmp13_;
#line 518 "user.vala"
				click_user_drop_privileges (self, &_inner_error0_);
#line 518 "user.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 518 "user.vala"
					if (_inner_error0_->domain == CLICK_USER_ERROR) {
#line 518 "user.vala"
						g_propagate_error (error, _inner_error0_);
#line 518 "user.vala"
						_g_free0 (path);
#line 518 "user.vala"
						_g_free0 (user_db);
#line 518 "user.vala"
						_g_object_unref0 (_tmp5_);
#line 518 "user.vala"
						return NULL;
#line 3830 "user.c"
					} else {
#line 518 "user.vala"
						_g_free0 (path);
#line 518 "user.vala"
						_g_free0 (user_db);
#line 518 "user.vala"
						_g_object_unref0 (_tmp5_);
#line 518 "user.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 518 "user.vala"
						g_clear_error (&_inner_error0_);
#line 518 "user.vala"
						return NULL;
#line 3844 "user.c"
					}
				}
				{
					const gchar* _tmp14_;
#line 520 "user.vala"
					_tmp14_ = path;
#line 520 "user.vala"
					if (click_user_is_valid_link (self, _tmp14_)) {
#line 3853 "user.c"
						{
							gchar* target = NULL;
							const gchar* _tmp15_;
							gchar* _tmp16_;
							const gchar* _tmp17_;
							gchar* _tmp18_;
#line 522 "user.vala"
							_tmp15_ = path;
#line 522 "user.vala"
							_tmp16_ = g_file_read_link (_tmp15_, &_inner_error0_);
#line 522 "user.vala"
							target = _tmp16_;
#line 522 "user.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 522 "user.vala"
								if (_inner_error0_->domain == G_FILE_ERROR) {
#line 3870 "user.c"
									goto __catch1_g_file_error;
								}
								{
									GError* _inner_error0_ = NULL;
#line 534 "user.vala"
									click_user_regain_privileges (self);
#line 3877 "user.c"
								}
#line 522 "user.vala"
								_g_free0 (path);
#line 522 "user.vala"
								_g_free0 (user_db);
#line 522 "user.vala"
								_g_object_unref0 (_tmp5_);
#line 522 "user.vala"
								g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 522 "user.vala"
								g_clear_error (&_inner_error0_);
#line 522 "user.vala"
								return NULL;
#line 3891 "user.c"
							}
#line 525 "user.vala"
							_tmp17_ = target;
#line 525 "user.vala"
							_tmp18_ = g_path_get_basename (_tmp17_);
#line 525 "user.vala"
							result = _tmp18_;
#line 525 "user.vala"
							_g_free0 (target);
#line 3901 "user.c"
							{
								GError* _inner_error0_ = NULL;
#line 534 "user.vala"
								click_user_regain_privileges (self);
#line 3906 "user.c"
							}
#line 525 "user.vala"
							_g_free0 (path);
#line 525 "user.vala"
							_g_free0 (user_db);
#line 525 "user.vala"
							_g_object_unref0 (_tmp5_);
#line 525 "user.vala"
							return result;
#line 3916 "user.c"
						}
						goto __finally1;
						__catch1_g_file_error:
						{
#line 521 "user.vala"
							g_clear_error (&_inner_error0_);
#line 3923 "user.c"
						}
						__finally1:
#line 521 "user.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 521 "user.vala"
							_g_free0 (path);
#line 521 "user.vala"
							_g_free0 (user_db);
#line 521 "user.vala"
							_g_object_unref0 (_tmp5_);
#line 521 "user.vala"
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 521 "user.vala"
							g_clear_error (&_inner_error0_);
#line 521 "user.vala"
							return NULL;
#line 3940 "user.c"
						}
					} else {
						const gchar* _tmp19_;
#line 529 "user.vala"
						_tmp19_ = path;
#line 529 "user.vala"
						if (click_is_symlink (_tmp19_)) {
#line 3948 "user.c"
							const gchar* _tmp20_;
							GError* _tmp21_;
#line 530 "user.vala"
							_tmp20_ = self->priv->_name;
#line 530 "user.vala"
							_tmp21_ = g_error_new (CLICK_USER_ERROR, CLICK_USER_ERROR_HIDDEN_PACKAGE, "%s is hidden for user %s", package, _tmp20_);
#line 530 "user.vala"
							_inner_error0_ = _tmp21_;
#line 3957 "user.c"
							goto __finally0;
						}
					}
				}
				__finally0:
				{
					GError* _inner_error1_ = NULL;
#line 534 "user.vala"
					click_user_regain_privileges (self);
#line 3967 "user.c"
				}
#line 519 "user.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 519 "user.vala"
					if (_inner_error0_->domain == CLICK_USER_ERROR) {
#line 519 "user.vala"
						g_propagate_error (error, _inner_error0_);
#line 519 "user.vala"
						_g_free0 (path);
#line 519 "user.vala"
						_g_free0 (user_db);
#line 519 "user.vala"
						_g_object_unref0 (_tmp5_);
#line 519 "user.vala"
						return NULL;
#line 3983 "user.c"
					} else {
#line 519 "user.vala"
						_g_free0 (path);
#line 519 "user.vala"
						_g_free0 (user_db);
#line 519 "user.vala"
						_g_object_unref0 (_tmp5_);
#line 519 "user.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 519 "user.vala"
						g_clear_error (&_inner_error0_);
#line 519 "user.vala"
						return NULL;
#line 3997 "user.c"
					}
				}
#line 537 "user.vala"
				_tmp23_ = self->priv->_db;
#line 537 "user.vala"
				_tmp24_ = click_db_get (_tmp23_, i, &_inner_error0_);
#line 537 "user.vala"
				_tmp22_ = _tmp24_;
#line 537 "user.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 537 "user.vala"
					if (_inner_error0_->domain == CLICK_USER_ERROR) {
#line 537 "user.vala"
						g_propagate_error (error, _inner_error0_);
#line 537 "user.vala"
						_g_free0 (path);
#line 537 "user.vala"
						_g_free0 (user_db);
#line 537 "user.vala"
						_g_object_unref0 (_tmp5_);
#line 537 "user.vala"
						return NULL;
#line 4020 "user.c"
					} else {
#line 537 "user.vala"
						_g_free0 (path);
#line 537 "user.vala"
						_g_free0 (user_db);
#line 537 "user.vala"
						_g_object_unref0 (_tmp5_);
#line 537 "user.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 537 "user.vala"
						g_clear_error (&_inner_error0_);
#line 537 "user.vala"
						return NULL;
#line 4034 "user.c"
					}
				}
#line 537 "user.vala"
				_tmp25_ = click_single_db_get_root (_tmp22_);
#line 537 "user.vala"
				_tmp26_ = _tmp25_;
#line 537 "user.vala"
				_tmp27_ = click_db_for_user (_tmp26_, CLICK_ALL_USERS);
#line 537 "user.vala"
				all_users_db = _tmp27_;
#line 538 "user.vala"
				_tmp28_ = all_users_db;
#line 538 "user.vala"
				_tmp29_ = g_build_filename (_tmp28_, package, NULL);
#line 538 "user.vala"
				_g_free0 (path);
#line 538 "user.vala"
				path = _tmp29_;
#line 539 "user.vala"
				_tmp30_ = path;
#line 539 "user.vala"
				if (click_user_is_valid_link (self, _tmp30_)) {
#line 4057 "user.c"
					{
						gchar* target = NULL;
						const gchar* _tmp31_;
						gchar* _tmp32_;
						const gchar* _tmp33_;
						gchar* _tmp34_;
#line 541 "user.vala"
						_tmp31_ = path;
#line 541 "user.vala"
						_tmp32_ = g_file_read_link (_tmp31_, &_inner_error0_);
#line 541 "user.vala"
						target = _tmp32_;
#line 541 "user.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 541 "user.vala"
							if (_inner_error0_->domain == G_FILE_ERROR) {
#line 4074 "user.c"
								goto __catch2_g_file_error;
							}
#line 541 "user.vala"
							_g_free0 (all_users_db);
#line 541 "user.vala"
							_g_object_unref0 (_tmp22_);
#line 541 "user.vala"
							_g_free0 (path);
#line 541 "user.vala"
							_g_free0 (user_db);
#line 541 "user.vala"
							_g_object_unref0 (_tmp5_);
#line 541 "user.vala"
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 541 "user.vala"
							g_clear_error (&_inner_error0_);
#line 541 "user.vala"
							return NULL;
#line 4093 "user.c"
						}
#line 543 "user.vala"
						_tmp33_ = target;
#line 543 "user.vala"
						_tmp34_ = g_path_get_basename (_tmp33_);
#line 543 "user.vala"
						result = _tmp34_;
#line 543 "user.vala"
						_g_free0 (target);
#line 543 "user.vala"
						_g_free0 (all_users_db);
#line 543 "user.vala"
						_g_object_unref0 (_tmp22_);
#line 543 "user.vala"
						_g_free0 (path);
#line 543 "user.vala"
						_g_free0 (user_db);
#line 543 "user.vala"
						_g_object_unref0 (_tmp5_);
#line 543 "user.vala"
						return result;
#line 4115 "user.c"
					}
					goto __finally2;
					__catch2_g_file_error:
					{
#line 540 "user.vala"
						g_clear_error (&_inner_error0_);
#line 4122 "user.c"
					}
					__finally2:
#line 540 "user.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 540 "user.vala"
						if (_inner_error0_->domain == CLICK_USER_ERROR) {
#line 540 "user.vala"
							g_propagate_error (error, _inner_error0_);
#line 540 "user.vala"
							_g_free0 (all_users_db);
#line 540 "user.vala"
							_g_object_unref0 (_tmp22_);
#line 540 "user.vala"
							_g_free0 (path);
#line 540 "user.vala"
							_g_free0 (user_db);
#line 540 "user.vala"
							_g_object_unref0 (_tmp5_);
#line 540 "user.vala"
							return NULL;
#line 4143 "user.c"
						} else {
#line 540 "user.vala"
							_g_free0 (all_users_db);
#line 540 "user.vala"
							_g_object_unref0 (_tmp22_);
#line 540 "user.vala"
							_g_free0 (path);
#line 540 "user.vala"
							_g_free0 (user_db);
#line 540 "user.vala"
							_g_object_unref0 (_tmp5_);
#line 540 "user.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 540 "user.vala"
							g_clear_error (&_inner_error0_);
#line 540 "user.vala"
							return NULL;
#line 4161 "user.c"
						}
					}
				} else {
					const gchar* _tmp35_;
#line 546 "user.vala"
					_tmp35_ = path;
#line 546 "user.vala"
					if (click_is_symlink (_tmp35_)) {
#line 4170 "user.c"
						GError* _tmp36_;
#line 547 "user.vala"
						_tmp36_ = g_error_new (CLICK_USER_ERROR, CLICK_USER_ERROR_HIDDEN_PACKAGE, "%s is hidden for all users", package);
#line 547 "user.vala"
						_inner_error0_ = _tmp36_;
#line 547 "user.vala"
						if (_inner_error0_->domain == CLICK_USER_ERROR) {
#line 547 "user.vala"
							g_propagate_error (error, _inner_error0_);
#line 547 "user.vala"
							_g_free0 (all_users_db);
#line 547 "user.vala"
							_g_object_unref0 (_tmp22_);
#line 547 "user.vala"
							_g_free0 (path);
#line 547 "user.vala"
							_g_free0 (user_db);
#line 547 "user.vala"
							_g_object_unref0 (_tmp5_);
#line 547 "user.vala"
							return NULL;
#line 4192 "user.c"
						} else {
#line 547 "user.vala"
							_g_free0 (all_users_db);
#line 547 "user.vala"
							_g_object_unref0 (_tmp22_);
#line 547 "user.vala"
							_g_free0 (path);
#line 547 "user.vala"
							_g_free0 (user_db);
#line 547 "user.vala"
							_g_object_unref0 (_tmp5_);
#line 547 "user.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 547 "user.vala"
							g_clear_error (&_inner_error0_);
#line 547 "user.vala"
							return NULL;
#line 4210 "user.c"
						}
					}
				}
#line 515 "user.vala"
				_g_free0 (all_users_db);
#line 515 "user.vala"
				_g_object_unref0 (_tmp22_);
#line 515 "user.vala"
				_g_free0 (path);
#line 515 "user.vala"
				_g_free0 (user_db);
#line 515 "user.vala"
				_g_object_unref0 (_tmp5_);
#line 4224 "user.c"
			}
		}
	}
#line 552 "user.vala"
	_tmp37_ = self->priv->_name;
#line 552 "user.vala"
	_tmp38_ = g_error_new (CLICK_USER_ERROR, CLICK_USER_ERROR_NO_SUCH_PACKAGE, "%s does not exist in any database for user %s", package, _tmp37_);
#line 552 "user.vala"
	_inner_error0_ = _tmp38_;
#line 552 "user.vala"
	if (_inner_error0_->domain == CLICK_USER_ERROR) {
#line 552 "user.vala"
		g_propagate_error (error, _inner_error0_);
#line 552 "user.vala"
		return NULL;
#line 4240 "user.c"
	} else {
#line 552 "user.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 552 "user.vala"
		g_clear_error (&_inner_error0_);
#line 552 "user.vala"
		return NULL;
#line 4248 "user.c"
	}
}

/**
 * raw_set_version:
 * @package: A package name.
 * @version: A version string.
 *
 * Set the version of @package to @version, without running any
 * hooks.  Must be run with dropped privileges.
 */
static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1581 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1582 "glib-2.0.vapi"
	result = self;
#line 1582 "glib-2.0.vapi"
	return result;
#line 4270 "user.c"
}

void
click_user_raw_set_version (ClickUser* self,
                            const gchar* package,
                            const gchar* version,
                            GError** error)
{
	gchar* user_db = NULL;
	gchar* _tmp0_;
	gchar* path = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* new_path = NULL;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* target = NULL;
	ClickDB* _tmp9_;
	gchar* _tmp10_;
	gboolean done = FALSE;
	const gchar* _tmp11_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	GError* _inner_error0_ = NULL;
#line 565 "user.vala"
	g_return_if_fail (self != NULL);
#line 565 "user.vala"
	g_return_if_fail (package != NULL);
#line 565 "user.vala"
	g_return_if_fail (version != NULL);
#line 568 "user.vala"
	_vala_assert (self->priv->dropped_privileges_count > 0, "dropped_privileges_count > 0");
#line 569 "user.vala"
	_tmp0_ = click_user_get_overlay_db (self);
#line 569 "user.vala"
	user_db = _tmp0_;
#line 570 "user.vala"
	_tmp1_ = user_db;
#line 570 "user.vala"
	_tmp2_ = g_build_filename (_tmp1_, package, NULL);
#line 570 "user.vala"
	path = _tmp2_;
#line 571 "user.vala"
	_tmp3_ = user_db;
#line 571 "user.vala"
	_tmp4_ = string_to_string (package);
#line 571 "user.vala"
	_tmp5_ = g_strconcat (".", _tmp4_, ".new", NULL);
#line 571 "user.vala"
	_tmp6_ = _tmp5_;
#line 571 "user.vala"
	_tmp7_ = g_build_filename (_tmp3_, _tmp6_, NULL);
#line 571 "user.vala"
	_tmp8_ = _tmp7_;
#line 571 "user.vala"
	_g_free0 (_tmp6_);
#line 571 "user.vala"
	new_path = _tmp8_;
#line 572 "user.vala"
	_tmp9_ = self->priv->_db;
#line 572 "user.vala"
	_tmp10_ = click_db_get_path (_tmp9_, package, version, &_inner_error0_);
#line 572 "user.vala"
	target = _tmp10_;
#line 572 "user.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 572 "user.vala"
		g_propagate_error (error, _inner_error0_);
#line 572 "user.vala"
		_g_free0 (new_path);
#line 572 "user.vala"
		_g_free0 (path);
#line 572 "user.vala"
		_g_free0 (user_db);
#line 572 "user.vala"
		return;
#line 4353 "user.c"
	}
#line 573 "user.vala"
	done = FALSE;
#line 574 "user.vala"
	_tmp11_ = path;
#line 574 "user.vala"
	if (click_user_is_valid_link (self, _tmp11_)) {
#line 4361 "user.c"
		const gchar* _tmp12_;
#line 575 "user.vala"
		_tmp12_ = path;
#line 575 "user.vala"
		click_unlink_force (_tmp12_, &_inner_error0_);
#line 575 "user.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 575 "user.vala"
			g_propagate_error (error, _inner_error0_);
#line 575 "user.vala"
			_g_free0 (target);
#line 575 "user.vala"
			_g_free0 (new_path);
#line 575 "user.vala"
			_g_free0 (path);
#line 575 "user.vala"
			_g_free0 (user_db);
#line 575 "user.vala"
			return;
#line 4381 "user.c"
		}
		{
			gchar* _tmp13_ = NULL;
			gchar* _tmp14_;
#line 577 "user.vala"
			_tmp14_ = click_user_get_version (self, package, &_inner_error0_);
#line 577 "user.vala"
			_tmp13_ = _tmp14_;
#line 577 "user.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 577 "user.vala"
				if (_inner_error0_->domain == CLICK_USER_ERROR) {
#line 4394 "user.c"
					goto __catch0_click_user_error;
				}
#line 577 "user.vala"
				_g_free0 (target);
#line 577 "user.vala"
				_g_free0 (new_path);
#line 577 "user.vala"
				_g_free0 (path);
#line 577 "user.vala"
				_g_free0 (user_db);
#line 577 "user.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 577 "user.vala"
				g_clear_error (&_inner_error0_);
#line 577 "user.vala"
				return;
#line 4411 "user.c"
			}
#line 577 "user.vala"
			if (g_strcmp0 (_tmp13_, version) == 0) {
#line 578 "user.vala"
				done = TRUE;
#line 4417 "user.c"
			}
#line 576 "user.vala"
			_g_free0 (_tmp13_);
#line 4421 "user.c"
		}
		goto __finally0;
		__catch0_click_user_error:
		{
#line 576 "user.vala"
			g_clear_error (&_inner_error0_);
#line 4428 "user.c"
		}
		__finally0:
#line 576 "user.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 576 "user.vala"
			g_propagate_error (error, _inner_error0_);
#line 576 "user.vala"
			_g_free0 (target);
#line 576 "user.vala"
			_g_free0 (new_path);
#line 576 "user.vala"
			_g_free0 (path);
#line 576 "user.vala"
			_g_free0 (user_db);
#line 576 "user.vala"
			return;
#line 4445 "user.c"
		}
	}
#line 582 "user.vala"
	if (done) {
#line 583 "user.vala"
		_g_free0 (target);
#line 583 "user.vala"
		_g_free0 (new_path);
#line 583 "user.vala"
		_g_free0 (path);
#line 583 "user.vala"
		_g_free0 (user_db);
#line 583 "user.vala"
		return;
#line 4460 "user.c"
	}
#line 584 "user.vala"
	_tmp15_ = target;
#line 584 "user.vala"
	_tmp16_ = new_path;
#line 584 "user.vala"
	click_symlink_force (_tmp15_, _tmp16_, &_inner_error0_);
#line 584 "user.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 584 "user.vala"
		g_propagate_error (error, _inner_error0_);
#line 584 "user.vala"
		_g_free0 (target);
#line 584 "user.vala"
		_g_free0 (new_path);
#line 584 "user.vala"
		_g_free0 (path);
#line 584 "user.vala"
		_g_free0 (user_db);
#line 584 "user.vala"
		return;
#line 4482 "user.c"
	}
#line 585 "user.vala"
	_tmp17_ = new_path;
#line 585 "user.vala"
	_tmp18_ = path;
#line 585 "user.vala"
	if (g_rename (_tmp17_, _tmp18_) < 0) {
#line 4490 "user.c"
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		const gchar* _tmp21_;
		GError* _tmp22_;
#line 586 "user.vala"
		_tmp19_ = new_path;
#line 586 "user.vala"
		_tmp20_ = path;
#line 586 "user.vala"
		_tmp21_ = g_strerror (errno);
#line 586 "user.vala"
		_tmp22_ = g_error_new (CLICK_USER_ERROR, CLICK_USER_ERROR_RENAME, "rename %s -> %s failed: %s", _tmp19_, _tmp20_, _tmp21_);
#line 586 "user.vala"
		_inner_error0_ = _tmp22_;
#line 586 "user.vala"
		g_propagate_error (error, _inner_error0_);
#line 586 "user.vala"
		_g_free0 (target);
#line 586 "user.vala"
		_g_free0 (new_path);
#line 586 "user.vala"
		_g_free0 (path);
#line 586 "user.vala"
		_g_free0 (user_db);
#line 586 "user.vala"
		return;
#line 4517 "user.c"
	}
#line 565 "user.vala"
	_g_free0 (target);
#line 565 "user.vala"
	_g_free0 (new_path);
#line 565 "user.vala"
	_g_free0 (path);
#line 565 "user.vala"
	_g_free0 (user_db);
#line 4527 "user.c"
}

/**
 * set_version:
 * @package: A package name.
 * @version: A version string.
 *
 * Register version @version of @package for this user.
 */
void
click_user_set_version (ClickUser* self,
                        const gchar* package,
                        const gchar* version,
                        GError** error)
{
	gchar* old_version = NULL;
	gboolean _tmp3_;
	gboolean _tmp4_;
	const gchar* _tmp8_;
	GError* _inner_error0_ = NULL;
#line 598 "user.vala"
	g_return_if_fail (self != NULL);
#line 598 "user.vala"
	g_return_if_fail (package != NULL);
#line 598 "user.vala"
	g_return_if_fail (version != NULL);
#line 602 "user.vala"
	click_user_ensure_db (self, &_inner_error0_);
#line 602 "user.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 602 "user.vala"
		g_propagate_error (error, _inner_error0_);
#line 602 "user.vala"
		return;
#line 4562 "user.c"
	}
#line 603 "user.vala"
	old_version = NULL;
#line 4566 "user.c"
	{
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 605 "user.vala"
		_tmp1_ = click_user_get_version (self, package, &_inner_error0_);
#line 605 "user.vala"
		_tmp0_ = _tmp1_;
#line 605 "user.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 605 "user.vala"
			if (_inner_error0_->domain == CLICK_USER_ERROR) {
#line 4579 "user.c"
				goto __catch0_click_user_error;
			}
#line 605 "user.vala"
			_g_free0 (old_version);
#line 605 "user.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 605 "user.vala"
			g_clear_error (&_inner_error0_);
#line 605 "user.vala"
			return;
#line 4590 "user.c"
		}
#line 605 "user.vala"
		_tmp2_ = _tmp0_;
#line 605 "user.vala"
		_tmp0_ = NULL;
#line 605 "user.vala"
		_g_free0 (old_version);
#line 605 "user.vala"
		old_version = _tmp2_;
#line 604 "user.vala"
		_g_free0 (_tmp0_);
#line 4602 "user.c"
	}
	goto __finally0;
	__catch0_click_user_error:
	{
#line 604 "user.vala"
		g_clear_error (&_inner_error0_);
#line 4609 "user.c"
	}
	__finally0:
#line 604 "user.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 604 "user.vala"
		g_propagate_error (error, _inner_error0_);
#line 604 "user.vala"
		_g_free0 (old_version);
#line 604 "user.vala"
		return;
#line 4620 "user.c"
	}
#line 608 "user.vala"
	click_user_drop_privileges (self, &_inner_error0_);
#line 608 "user.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 608 "user.vala"
		g_propagate_error (error, _inner_error0_);
#line 608 "user.vala"
		_g_free0 (old_version);
#line 608 "user.vala"
		return;
#line 4632 "user.c"
	}
	{
#line 610 "user.vala"
		click_user_raw_set_version (self, package, version, &_inner_error0_);
#line 610 "user.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4639 "user.c"
			goto __finally1;
		}
	}
	__finally1:
	{
		GError* _inner_error1_ = NULL;
#line 612 "user.vala"
		click_user_regain_privileges (self);
#line 4648 "user.c"
	}
#line 609 "user.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 609 "user.vala"
		g_propagate_error (error, _inner_error0_);
#line 609 "user.vala"
		_g_free0 (old_version);
#line 609 "user.vala"
		return;
#line 4658 "user.c"
	}
#line 614 "user.vala"
	_tmp3_ = click_user_get_is_pseudo_user (self);
#line 614 "user.vala"
	_tmp4_ = _tmp3_;
#line 614 "user.vala"
	if (!_tmp4_) {
#line 4666 "user.c"
		ClickDB* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 615 "user.vala"
		_tmp5_ = self->priv->_db;
#line 615 "user.vala"
		_tmp6_ = old_version;
#line 615 "user.vala"
		_tmp7_ = self->priv->_name;
#line 615 "user.vala"
		click_package_install_hooks (_tmp5_, package, _tmp6_, version, _tmp7_, &_inner_error0_);
#line 615 "user.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 615 "user.vala"
			g_propagate_error (error, _inner_error0_);
#line 615 "user.vala"
			_g_free0 (old_version);
#line 615 "user.vala"
			return;
#line 4686 "user.c"
		}
	}
#line 619 "user.vala"
	_tmp8_ = self->priv->_name;
#line 619 "user.vala"
	if (g_strcmp0 (_tmp8_, CLICK_ALL_USERS) == 0) {
#line 4693 "user.c"
		const gchar* _tmp9_;
#line 620 "user.vala"
		_tmp9_ = old_version;
#line 620 "user.vala"
		click_user_run_user_install_hooks_for_all_logged_in_users (self, package, _tmp9_, version, &_inner_error0_);
#line 620 "user.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 620 "user.vala"
			g_propagate_error (error, _inner_error0_);
#line 620 "user.vala"
			_g_free0 (old_version);
#line 620 "user.vala"
			return;
#line 4707 "user.c"
		}
	}
#line 598 "user.vala"
	_g_free0 (old_version);
#line 4712 "user.c"
}

static void
_vala_array_add12 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 642 "user.vala"
	if ((*length) == (*size)) {
#line 642 "user.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 642 "user.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 4727 "user.c"
	}
#line 642 "user.vala"
	(*array)[(*length)++] = value;
#line 642 "user.vala"
	(*array)[*length] = NULL;
#line 4733 "user.c"
}

static gchar**
click_user_get_logged_in_users (ClickUser* self,
                                gint* result_length1)
{
	gchar** logged_in_users = NULL;
	gchar** _tmp0_;
	gint logged_in_users_length1;
	gint _logged_in_users_size_;
	gchar** _tmp26_;
	gint _tmp26__length1;
	GError* _inner_error0_ = NULL;
	gchar** result;
#line 623 "user.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 626 "user.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 626 "user.vala"
	logged_in_users = _tmp0_;
#line 626 "user.vala"
	logged_in_users_length1 = 0;
#line 626 "user.vala"
	_logged_in_users_size_ = logged_in_users_length1;
#line 4758 "user.c"
	{
		ClickLogindManager* logind = NULL;
		ClickLogindManager* _tmp1_;
		ClickLogindUser* users = NULL;
		ClickLogindManager* _tmp2_;
		gint _tmp3_ = 0;
		ClickLogindUser* _tmp4_;
		gint users_length1;
		gint _users_size_;
		ClickLogindUser* _tmp5_;
		gint _tmp5__length1;
#line 628 "user.vala"
		_tmp1_ = (ClickLogindManager*) g_initable_new (CLICK_TYPE_LOGIND_MANAGER_PROXY, NULL, &_inner_error0_, "g-flags", 0, "g-name", "org.freedesktop.login1", "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", "/org/freedesktop/login1", "g-interface-name", "org.freedesktop.login1.Manager", NULL);
#line 628 "user.vala"
		logind = (ClickLogindManager*) _tmp1_;
#line 628 "user.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4776 "user.c"
			goto __catch0_g_error;
		}
#line 632 "user.vala"
		_tmp2_ = logind;
#line 632 "user.vala"
		_tmp4_ = click_logind_manager_ListUsers (_tmp2_, &_tmp3_, &_inner_error0_);
#line 632 "user.vala"
		users = _tmp4_;
#line 632 "user.vala"
		users_length1 = _tmp3_;
#line 632 "user.vala"
		_users_size_ = users_length1;
#line 632 "user.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 632 "user.vala"
			_g_object_unref0 (logind);
#line 4793 "user.c"
			goto __catch0_g_error;
		}
#line 633 "user.vala"
		_tmp5_ = users;
#line 633 "user.vala"
		_tmp5__length1 = users_length1;
#line 4800 "user.c"
		{
			ClickLogindUser* user_collection = NULL;
			gint user_collection_length1 = 0;
			gint _user_collection_size_ = 0;
			gint user_it = 0;
#line 633 "user.vala"
			user_collection = _tmp5_;
#line 633 "user.vala"
			user_collection_length1 = _tmp5__length1;
#line 633 "user.vala"
			for (user_it = 0; user_it < user_collection_length1; user_it = user_it + 1) {
#line 4812 "user.c"
				ClickLogindUser _tmp6_;
				ClickLogindUser _tmp7_ = {0};
				ClickLogindUser user = {0};
#line 633 "user.vala"
				_tmp6_ = user_collection[user_it];
#line 633 "user.vala"
				click_logind_user_copy (&_tmp6_, &_tmp7_);
#line 633 "user.vala"
				user = _tmp7_;
#line 4822 "user.c"
				{
					ClickASUser* asUser = NULL;
					ClickLogindUser _tmp8_;
					gchar* _tmp9_;
					gchar* _tmp10_;
					gchar* _tmp11_;
					gchar* _tmp12_;
					ClickASUser* _tmp13_;
					ClickASUser* _tmp14_;
					ClickASUser* _tmp15_;
					gboolean _tmp16_;
					gboolean _tmp17_;
#line 635 "user.vala"
					_tmp8_ = user;
#line 635 "user.vala"
					_tmp9_ = g_strdup_printf ("%u", _tmp8_.uid);
#line 635 "user.vala"
					_tmp10_ = _tmp9_;
#line 635 "user.vala"
					_tmp11_ = g_strconcat ("/org/freedesktop/Accounts/User", _tmp10_, NULL);
#line 635 "user.vala"
					_tmp12_ = _tmp11_;
#line 635 "user.vala"
					_tmp13_ = (ClickASUser*) g_initable_new (CLICK_TYPE_AS_USER_PROXY, NULL, &_inner_error0_, "g-flags", 0, "g-name", "org.freedesktop.Accounts.User", "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", _tmp12_, "g-interface-name", "org.freedesktop.Accounts.User", NULL);
#line 635 "user.vala"
					_tmp14_ = (ClickASUser*) _tmp13_;
#line 635 "user.vala"
					_g_free0 (_tmp12_);
#line 635 "user.vala"
					_g_free0 (_tmp10_);
#line 635 "user.vala"
					asUser = _tmp14_;
#line 635 "user.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 635 "user.vala"
						click_logind_user_destroy (&user);
#line 635 "user.vala"
						users = (_vala_ClickLogindUser_array_free (users, users_length1), NULL);
#line 635 "user.vala"
						_g_object_unref0 (logind);
#line 4863 "user.c"
						goto __catch0_g_error;
					}
#line 640 "user.vala"
					_tmp15_ = asUser;
#line 640 "user.vala"
					_tmp16_ = click_as_user_get_system_account (_tmp15_);
#line 640 "user.vala"
					_tmp17_ = _tmp16_;
#line 640 "user.vala"
					if (!_tmp17_) {
#line 4874 "user.c"
						ClickLogindUser _tmp18_;
						const gchar* _tmp19_;
						gchar* _tmp20_;
#line 642 "user.vala"
						_tmp18_ = user;
#line 642 "user.vala"
						_tmp19_ = _tmp18_.name;
#line 642 "user.vala"
						_tmp20_ = g_strdup (_tmp19_);
#line 642 "user.vala"
						_vala_array_add12 (&logged_in_users, &logged_in_users_length1, &_logged_in_users_size_, _tmp20_);
#line 4886 "user.c"
					}
#line 633 "user.vala"
					_g_object_unref0 (asUser);
#line 633 "user.vala"
					click_logind_user_destroy (&user);
#line 4892 "user.c"
				}
			}
		}
#line 627 "user.vala"
		users = (_vala_ClickLogindUser_array_free (users, users_length1), NULL);
#line 627 "user.vala"
		_g_object_unref0 (logind);
#line 4900 "user.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
#line 627 "user.vala"
		e = _inner_error0_;
#line 627 "user.vala"
		_inner_error0_ = NULL;
#line 646 "user.vala"
		_tmp21_ = e;
#line 646 "user.vala"
		_tmp22_ = _tmp21_->message;
#line 646 "user.vala"
		_tmp23_ = string_to_string (_tmp22_);
#line 646 "user.vala"
		_tmp24_ = g_strconcat ("Can not connect to logind or AccountsService: ", _tmp23_, NULL);
#line 646 "user.vala"
		_tmp25_ = _tmp24_;
#line 646 "user.vala"
		g_warning ("user.vala:646: %s", _tmp25_);
#line 646 "user.vala"
		_g_free0 (_tmp25_);
#line 627 "user.vala"
		_g_error_free0 (e);
#line 4931 "user.c"
	}
	__finally0:
#line 627 "user.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 627 "user.vala"
		logged_in_users = (_vala_array_free (logged_in_users, logged_in_users_length1, (GDestroyNotify) g_free), NULL);
#line 627 "user.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 627 "user.vala"
		g_clear_error (&_inner_error0_);
#line 627 "user.vala"
		return NULL;
#line 4944 "user.c"
	}
#line 648 "user.vala"
	_tmp26_ = logged_in_users;
#line 648 "user.vala"
	_tmp26__length1 = logged_in_users_length1;
#line 648 "user.vala"
	if (result_length1) {
#line 648 "user.vala"
		*result_length1 = _tmp26__length1;
#line 4954 "user.c"
	}
#line 648 "user.vala"
	result = _tmp26_;
#line 648 "user.vala"
	return result;
#line 4960 "user.c"
}

static void
click_user_run_user_install_hooks_for_all_logged_in_users (ClickUser* self,
                                                           const gchar* package,
                                                           const gchar* old_version,
                                                           const gchar* version,
                                                           GError** error)
{
	gint _tmp0_ = 0;
	gchar** _tmp1_;
	GError* _inner_error0_ = NULL;
#line 651 "user.vala"
	g_return_if_fail (self != NULL);
#line 651 "user.vala"
	g_return_if_fail (package != NULL);
#line 651 "user.vala"
	g_return_if_fail (version != NULL);
#line 656 "user.vala"
	_tmp1_ = click_user_get_logged_in_users (self, &_tmp0_);
#line 4981 "user.c"
	{
		gchar** username_collection = NULL;
		gint username_collection_length1 = 0;
		gint _username_collection_size_ = 0;
		gint username_it = 0;
#line 656 "user.vala"
		username_collection = _tmp1_;
#line 656 "user.vala"
		username_collection_length1 = _tmp0_;
#line 656 "user.vala"
		for (username_it = 0; username_it < username_collection_length1; username_it = username_it + 1) {
#line 4993 "user.c"
			gchar* _tmp2_;
			gchar* username = NULL;
#line 656 "user.vala"
			_tmp2_ = g_strdup (username_collection[username_it]);
#line 656 "user.vala"
			username = _tmp2_;
#line 5000 "user.c"
			{
				ClickDB* _tmp3_;
				const gchar* _tmp4_;
#line 657 "user.vala"
				_tmp3_ = self->priv->_db;
#line 657 "user.vala"
				_tmp4_ = username;
#line 657 "user.vala"
				click_package_install_hooks (_tmp3_, package, old_version, version, _tmp4_, &_inner_error0_);
#line 657 "user.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 657 "user.vala"
					if (_inner_error0_->domain == G_IO_ERROR) {
#line 657 "user.vala"
						g_propagate_error (error, _inner_error0_);
#line 657 "user.vala"
						_g_free0 (username);
#line 657 "user.vala"
						username_collection = (_vala_array_free (username_collection, username_collection_length1, (GDestroyNotify) g_free), NULL);
#line 657 "user.vala"
						return;
#line 5022 "user.c"
					} else {
#line 657 "user.vala"
						_g_free0 (username);
#line 657 "user.vala"
						username_collection = (_vala_array_free (username_collection, username_collection_length1, (GDestroyNotify) g_free), NULL);
#line 657 "user.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 657 "user.vala"
						g_clear_error (&_inner_error0_);
#line 657 "user.vala"
						return;
#line 5034 "user.c"
					}
				}
#line 656 "user.vala"
				_g_free0 (username);
#line 5039 "user.c"
			}
		}
#line 656 "user.vala"
		username_collection = (_vala_array_free (username_collection, username_collection_length1, (GDestroyNotify) g_free), NULL);
#line 5044 "user.c"
	}
}

static void
click_user_run_user_remove_hooks_for_all_logged_in_users (ClickUser* self,
                                                          const gchar* package,
                                                          const gchar* old_version,
                                                          GError** error)
{
	gint _tmp0_ = 0;
	gchar** _tmp1_;
	GError* _inner_error0_ = NULL;
#line 661 "user.vala"
	g_return_if_fail (self != NULL);
#line 661 "user.vala"
	g_return_if_fail (package != NULL);
#line 661 "user.vala"
	g_return_if_fail (old_version != NULL);
#line 665 "user.vala"
	_tmp1_ = click_user_get_logged_in_users (self, &_tmp0_);
#line 5065 "user.c"
	{
		gchar** username_collection = NULL;
		gint username_collection_length1 = 0;
		gint _username_collection_size_ = 0;
		gint username_it = 0;
#line 665 "user.vala"
		username_collection = _tmp1_;
#line 665 "user.vala"
		username_collection_length1 = _tmp0_;
#line 665 "user.vala"
		for (username_it = 0; username_it < username_collection_length1; username_it = username_it + 1) {
#line 5077 "user.c"
			gchar* _tmp2_;
			gchar* username = NULL;
#line 665 "user.vala"
			_tmp2_ = g_strdup (username_collection[username_it]);
#line 665 "user.vala"
			username = _tmp2_;
#line 5084 "user.c"
			{
				ClickDB* _tmp3_;
				const gchar* _tmp4_;
#line 666 "user.vala"
				_tmp3_ = self->priv->_db;
#line 666 "user.vala"
				_tmp4_ = username;
#line 666 "user.vala"
				click_package_remove_hooks (_tmp3_, package, old_version, _tmp4_, &_inner_error0_);
#line 666 "user.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 666 "user.vala"
					if (_inner_error0_->domain == G_IO_ERROR) {
#line 666 "user.vala"
						g_propagate_error (error, _inner_error0_);
#line 666 "user.vala"
						_g_free0 (username);
#line 666 "user.vala"
						username_collection = (_vala_array_free (username_collection, username_collection_length1, (GDestroyNotify) g_free), NULL);
#line 666 "user.vala"
						return;
#line 5106 "user.c"
					} else {
#line 666 "user.vala"
						_g_free0 (username);
#line 666 "user.vala"
						username_collection = (_vala_array_free (username_collection, username_collection_length1, (GDestroyNotify) g_free), NULL);
#line 666 "user.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 666 "user.vala"
						g_clear_error (&_inner_error0_);
#line 666 "user.vala"
						return;
#line 5118 "user.c"
					}
				}
#line 665 "user.vala"
				_g_free0 (username);
#line 5123 "user.c"
			}
		}
#line 665 "user.vala"
		username_collection = (_vala_array_free (username_collection, username_collection_length1, (GDestroyNotify) g_free), NULL);
#line 5128 "user.c"
	}
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1370 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1371 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1371 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1372 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1373 "glib-2.0.vapi"
	result = _result_;
#line 1373 "glib-2.0.vapi"
	return result;
#line 5150 "user.c"
}

static gchar*
click_user_get_dbus_session_bus_env_for_current_user (ClickUser* self)
{
	gchar* euid = NULL;
	gchar* _tmp0_;
	gchar* dbus_session_file = NULL;
	gchar* _tmp1_;
	gchar* session_env = NULL;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 670 "user.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 673 "user.vala"
	_tmp0_ = g_strdup_printf ("%i", (gint) geteuid ());
#line 673 "user.vala"
	euid = _tmp0_;
#line 674 "user.vala"
	_tmp1_ = g_build_filename ("/run", "user", euid, "dbus-session", NULL);
#line 674 "user.vala"
	dbus_session_file = _tmp1_;
#line 5173 "user.c"
	{
		gchar* _tmp2_ = NULL;
		const gchar* _tmp3_;
		gchar* _tmp4_;
#line 678 "user.vala"
		g_file_get_contents (dbus_session_file, &_tmp2_, NULL, &_inner_error0_);
#line 678 "user.vala"
		_g_free0 (session_env);
#line 678 "user.vala"
		session_env = _tmp2_;
#line 678 "user.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5186 "user.c"
			goto __catch0_g_error;
		}
#line 679 "user.vala"
		_tmp3_ = session_env;
#line 679 "user.vala"
		_tmp4_ = string_strip (_tmp3_);
#line 679 "user.vala"
		_g_free0 (session_env);
#line 679 "user.vala"
		session_env = _tmp4_;
#line 5197 "user.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 677 "user.vala"
		e = _inner_error0_;
#line 677 "user.vala"
		_inner_error0_ = NULL;
#line 681 "user.vala"
		_tmp5_ = e;
#line 681 "user.vala"
		_tmp6_ = _tmp5_->message;
#line 681 "user.vala"
		g_warning ("user.vala:681: Can not get the dbus session to stop app (%s)", _tmp6_);
#line 677 "user.vala"
		_g_error_free0 (e);
#line 5217 "user.c"
	}
	__finally0:
#line 677 "user.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 677 "user.vala"
		_g_free0 (session_env);
#line 677 "user.vala"
		_g_free0 (dbus_session_file);
#line 677 "user.vala"
		_g_free0 (euid);
#line 677 "user.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 677 "user.vala"
		g_clear_error (&_inner_error0_);
#line 677 "user.vala"
		return NULL;
#line 5234 "user.c"
	}
#line 683 "user.vala"
	result = session_env;
#line 683 "user.vala"
	_g_free0 (dbus_session_file);
#line 683 "user.vala"
	_g_free0 (euid);
#line 683 "user.vala"
	return result;
#line 5244 "user.c"
}

static void
_vala_array_add13 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 692 "user.vala"
	if ((*length) == (*size)) {
#line 692 "user.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 692 "user.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 5259 "user.c"
	}
#line 692 "user.vala"
	(*array)[(*length)++] = value;
#line 692 "user.vala"
	(*array)[*length] = NULL;
#line 5265 "user.c"
}

static gboolean
click_user_stop_single_app (ClickUser* self,
                            const gchar* app_id)
{
	gchar** envp = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint envp_length1;
	gint _envp_size_;
	gchar* _tmp2_;
	gchar** command = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar** _tmp5_;
	gint command_length1;
	gint _command_size_;
	gboolean res = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 686 "user.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 686 "user.vala"
	g_return_val_if_fail (app_id != NULL, FALSE);
#line 691 "user.vala"
	_tmp1_ = _tmp0_ = g_get_environ ();
#line 691 "user.vala"
	envp = _tmp1_;
#line 691 "user.vala"
	envp_length1 = _vala_array_length (_tmp0_);
#line 691 "user.vala"
	_envp_size_ = envp_length1;
#line 692 "user.vala"
	_tmp2_ = click_user_get_dbus_session_bus_env_for_current_user (self);
#line 692 "user.vala"
	_vala_array_add13 (&envp, &envp_length1, &_envp_size_, _tmp2_);
#line 694 "user.vala"
	_tmp3_ = g_strdup ("lomiri-app-stop");
#line 694 "user.vala"
	_tmp4_ = g_strdup (app_id);
#line 694 "user.vala"
	_tmp5_ = g_new0 (gchar*, 2 + 1);
#line 694 "user.vala"
	_tmp5_[0] = _tmp3_;
#line 694 "user.vala"
	_tmp5_[1] = _tmp4_;
#line 694 "user.vala"
	command = _tmp5_;
#line 694 "user.vala"
	command_length1 = 2;
#line 694 "user.vala"
	_command_size_ = command_length1;
#line 697 "user.vala"
	res = FALSE;
#line 5321 "user.c"
	{
		gint exit_status = 0;
		gchar** _tmp6_;
		gint _tmp6__length1;
		gchar** _tmp7_;
		gint _tmp7__length1;
		gint _tmp8_ = 0;
		gboolean _tmp9_ = FALSE;
#line 700 "user.vala"
		_tmp6_ = command;
#line 700 "user.vala"
		_tmp6__length1 = command_length1;
#line 700 "user.vala"
		_tmp7_ = envp;
#line 700 "user.vala"
		_tmp7__length1 = envp_length1;
#line 700 "user.vala"
		g_spawn_sync (NULL, _tmp6_, _tmp7_, G_SPAWN_SEARCH_PATH, NULL, NULL, NULL, NULL, &_tmp8_, &_inner_error0_);
#line 700 "user.vala"
		exit_status = _tmp8_;
#line 700 "user.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5344 "user.c"
			goto __catch0_g_error;
		}
#line 704 "user.vala"
		_tmp9_ = g_spawn_check_exit_status (exit_status, &_inner_error0_);
#line 704 "user.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5351 "user.c"
			goto __catch0_g_error;
		}
#line 704 "user.vala"
		res = _tmp9_;
#line 5356 "user.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 698 "user.vala"
		g_clear_error (&_inner_error0_);
#line 706 "user.vala"
		res = FALSE;
#line 5365 "user.c"
	}
	__finally0:
#line 698 "user.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5370 "user.c"
		gboolean _tmp10_ = FALSE;
#line 698 "user.vala"
		command = (_vala_array_free (command, command_length1, (GDestroyNotify) g_free), NULL);
#line 698 "user.vala"
		envp = (_vala_array_free (envp, envp_length1, (GDestroyNotify) g_free), NULL);
#line 698 "user.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 698 "user.vala"
		g_clear_error (&_inner_error0_);
#line 698 "user.vala"
		return _tmp10_;
#line 5382 "user.c"
	}
#line 708 "user.vala"
	result = res;
#line 708 "user.vala"
	command = (_vala_array_free (command, command_length1, (GDestroyNotify) g_free), NULL);
#line 708 "user.vala"
	envp = (_vala_array_free (envp, envp_length1, (GDestroyNotify) g_free), NULL);
#line 708 "user.vala"
	return result;
#line 5392 "user.c"
}

static gpointer
_json_object_ref0 (gpointer self)
{
#line 730 "user.vala"
	return self ? json_object_ref (self) : NULL;
#line 5400 "user.c"
}

static gboolean
click_user_stop_running_apps_for_package (ClickUser* self,
                                          const gchar* package,
                                          const gchar* version)
{
	gboolean res = FALSE;
	JsonObject* manifest = NULL;
	JsonObject* _tmp4_;
	JsonObject* hooks = NULL;
	JsonObject* _tmp5_;
	JsonObject* _tmp6_;
	JsonObject* _tmp7_;
	JsonObject* _tmp8_;
	GList* _tmp9_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 711 "user.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 711 "user.vala"
	g_return_val_if_fail (package != NULL, FALSE);
#line 711 "user.vala"
	g_return_val_if_fail (version != NULL, FALSE);
#line 714 "user.vala"
	res = TRUE;
#line 715 "user.vala"
	if (!click_find_on_path ("lomiri-app-stop")) {
#line 716 "user.vala"
		result = FALSE;
#line 716 "user.vala"
		return result;
#line 5433 "user.c"
	}
	{
		JsonObject* _tmp0_ = NULL;
		JsonObject* _tmp1_;
		JsonObject* _tmp2_;
#line 720 "user.vala"
		_tmp1_ = click_user_get_manifest (self, package, &_inner_error0_);
#line 720 "user.vala"
		_tmp0_ = _tmp1_;
#line 720 "user.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5445 "user.c"
			goto __catch0_g_error;
		}
#line 720 "user.vala"
		_tmp2_ = _tmp0_;
#line 720 "user.vala"
		_tmp0_ = NULL;
#line 720 "user.vala"
		_json_object_unref0 (manifest);
#line 720 "user.vala"
		manifest = _tmp2_;
#line 719 "user.vala"
		_json_object_unref0 (_tmp0_);
#line 5458 "user.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 719 "user.vala"
		g_clear_error (&_inner_error0_);
#line 722 "user.vala"
		g_warning ("user.vala:722: Can not get manifest for %s", package);
#line 723 "user.vala"
		result = FALSE;
#line 723 "user.vala"
		_json_object_unref0 (manifest);
#line 723 "user.vala"
		return result;
#line 5473 "user.c"
	}
	__finally0:
#line 719 "user.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5478 "user.c"
		gboolean _tmp3_ = FALSE;
#line 719 "user.vala"
		_json_object_unref0 (manifest);
#line 719 "user.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 719 "user.vala"
		g_clear_error (&_inner_error0_);
#line 719 "user.vala"
		return _tmp3_;
#line 5488 "user.c"
	}
#line 726 "user.vala"
	_tmp4_ = manifest;
#line 726 "user.vala"
	if (!json_object_has_member (_tmp4_, "hooks")) {
#line 727 "user.vala"
		g_warning ("user.vala:727: No hooks in manifest %s", package);
#line 728 "user.vala"
		result = FALSE;
#line 728 "user.vala"
		_json_object_unref0 (manifest);
#line 728 "user.vala"
		return result;
#line 5502 "user.c"
	}
#line 730 "user.vala"
	_tmp5_ = manifest;
#line 730 "user.vala"
	_tmp6_ = json_object_get_object_member (_tmp5_, "hooks");
#line 730 "user.vala"
	_tmp7_ = _json_object_ref0 (_tmp6_);
#line 730 "user.vala"
	hooks = _tmp7_;
#line 731 "user.vala"
	_tmp8_ = hooks;
#line 731 "user.vala"
	_tmp9_ = json_object_get_members (_tmp8_);
#line 5516 "user.c"
	{
		GList* app_name_collection = NULL;
		GList* app_name_it = NULL;
#line 731 "user.vala"
		app_name_collection = _tmp9_;
#line 731 "user.vala"
		for (app_name_it = app_name_collection; app_name_it != NULL; app_name_it = app_name_it->next) {
#line 5524 "user.c"
			const gchar* app_name = NULL;
#line 731 "user.vala"
			app_name = (const gchar*) app_name_it->data;
#line 5528 "user.c"
			{
				const gchar* _tmp10_;
				const gchar* _tmp11_;
				const gchar* _tmp12_;
				const gchar* _tmp13_;
				gchar* _tmp14_;
				gchar* _tmp15_;
#line 732 "user.vala"
				_tmp10_ = string_to_string (package);
#line 732 "user.vala"
				_tmp11_ = app_name;
#line 732 "user.vala"
				_tmp12_ = string_to_string (_tmp11_);
#line 732 "user.vala"
				_tmp13_ = string_to_string (version);
#line 732 "user.vala"
				_tmp14_ = g_strconcat (_tmp10_, "_", _tmp12_, "_", _tmp13_, NULL);
#line 732 "user.vala"
				_tmp15_ = _tmp14_;
#line 732 "user.vala"
				res &= click_user_stop_single_app (self, _tmp15_);
#line 732 "user.vala"
				_g_free0 (_tmp15_);
#line 5552 "user.c"
			}
		}
#line 731 "user.vala"
		(app_name_collection == NULL) ? NULL : (app_name_collection = (g_list_free (app_name_collection), NULL));
#line 5557 "user.c"
	}
#line 733 "user.vala"
	result = res;
#line 733 "user.vala"
	_json_object_unref0 (hooks);
#line 733 "user.vala"
	_json_object_unref0 (manifest);
#line 733 "user.vala"
	return result;
#line 5567 "user.c"
}

static void
click_user_package_remove_user_cache (ClickUser* self,
                                      const gchar* package,
                                      GError** error)
{
	GError* _inner_error0_ = NULL;
#line 736 "user.vala"
	g_return_if_fail (self != NULL);
#line 736 "user.vala"
	g_return_if_fail (package != NULL);
#line 739 "user.vala"
	click_user_drop_privileges (self, &_inner_error0_);
#line 739 "user.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 739 "user.vala"
		g_propagate_error (error, _inner_error0_);
#line 739 "user.vala"
		return;
#line 5588 "user.c"
	}
	{
		gchar* path = NULL;
		const gchar* _tmp0_;
		gchar* _tmp1_;
		GFile* file = NULL;
		const gchar* _tmp2_;
		GFile* _tmp3_;
		GFile* _tmp4_;
#line 741 "user.vala"
		_tmp0_ = g_get_user_cache_dir ();
#line 741 "user.vala"
		_tmp1_ = g_build_filename (_tmp0_, package, NULL);
#line 741 "user.vala"
		path = _tmp1_;
#line 743 "user.vala"
		_tmp2_ = path;
#line 743 "user.vala"
		_tmp3_ = g_file_new_for_path (_tmp2_);
#line 743 "user.vala"
		file = _tmp3_;
#line 744 "user.vala"
		_tmp4_ = file;
#line 744 "user.vala"
		click_rmtree (_tmp4_, NULL, &_inner_error0_);
#line 744 "user.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 744 "user.vala"
			_g_object_unref0 (file);
#line 744 "user.vala"
			_g_free0 (path);
#line 5620 "user.c"
			goto __catch0_g_error;
		}
#line 740 "user.vala"
		_g_object_unref0 (file);
#line 740 "user.vala"
		_g_free0 (path);
#line 5627 "user.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 740 "user.vala"
		e = _inner_error0_;
#line 740 "user.vala"
		_inner_error0_ = NULL;
#line 746 "user.vala"
		_tmp5_ = e;
#line 746 "user.vala"
		_tmp6_ = _tmp5_->message;
#line 746 "user.vala"
		g_warning ("user.vala:746: Error removing cache for '%s': %s", package, _tmp6_);
#line 740 "user.vala"
		_g_error_free0 (e);
#line 5647 "user.c"
	}
	__finally0:
	{
		GError* _inner_error1_ = NULL;
#line 748 "user.vala"
		click_user_regain_privileges (self);
#line 5654 "user.c"
	}
#line 740 "user.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 740 "user.vala"
		g_propagate_error (error, _inner_error0_);
#line 740 "user.vala"
		return;
#line 5662 "user.c"
	}
}

/**
 * remove:
 * @package: A package name.
 *
 * Remove this user's registration of @package.
 */
void
click_user_remove (ClickUser* self,
                   const gchar* package,
                   GError** error)
{
	gchar* user_db = NULL;
	gchar* _tmp0_;
	gchar* path = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* old_version = NULL;
	const gchar* _tmp3_;
	gboolean _tmp17_;
	gboolean _tmp18_;
	const gchar* _tmp22_;
	GError* _inner_error0_ = NULL;
#line 758 "user.vala"
	g_return_if_fail (self != NULL);
#line 758 "user.vala"
	g_return_if_fail (package != NULL);
#line 762 "user.vala"
	_tmp0_ = click_user_get_overlay_db (self);
#line 762 "user.vala"
	user_db = _tmp0_;
#line 763 "user.vala"
	_tmp1_ = user_db;
#line 763 "user.vala"
	_tmp2_ = g_build_filename (_tmp1_, package, NULL);
#line 763 "user.vala"
	path = _tmp2_;
#line 765 "user.vala"
	_tmp3_ = path;
#line 765 "user.vala"
	if (click_user_is_valid_link (self, _tmp3_)) {
#line 5706 "user.c"
		gchar* target = NULL;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
#line 766 "user.vala"
		_tmp4_ = path;
#line 766 "user.vala"
		_tmp5_ = g_file_read_link (_tmp4_, &_inner_error0_);
#line 766 "user.vala"
		target = _tmp5_;
#line 766 "user.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 766 "user.vala"
			g_propagate_error (error, _inner_error0_);
#line 766 "user.vala"
			_g_free0 (old_version);
#line 766 "user.vala"
			_g_free0 (path);
#line 766 "user.vala"
			_g_free0 (user_db);
#line 766 "user.vala"
			return;
#line 5730 "user.c"
		}
#line 767 "user.vala"
		_tmp6_ = target;
#line 767 "user.vala"
		_tmp7_ = g_path_get_basename (_tmp6_);
#line 767 "user.vala"
		_g_free0 (old_version);
#line 767 "user.vala"
		old_version = _tmp7_;
#line 768 "user.vala"
		click_user_drop_privileges (self, &_inner_error0_);
#line 768 "user.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 768 "user.vala"
			g_propagate_error (error, _inner_error0_);
#line 768 "user.vala"
			_g_free0 (target);
#line 768 "user.vala"
			_g_free0 (old_version);
#line 768 "user.vala"
			_g_free0 (path);
#line 768 "user.vala"
			_g_free0 (user_db);
#line 768 "user.vala"
			return;
#line 5756 "user.c"
		}
		{
			const gchar* _tmp8_;
			const gchar* _tmp9_;
#line 771 "user.vala"
			_tmp8_ = old_version;
#line 771 "user.vala"
			click_user_stop_running_apps_for_package (self, package, _tmp8_);
#line 772 "user.vala"
			_tmp9_ = path;
#line 772 "user.vala"
			click_unlink_force (_tmp9_, &_inner_error0_);
#line 772 "user.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5771 "user.c"
				goto __finally0;
			}
		}
		__finally0:
		{
			GError* _inner_error1_ = NULL;
#line 774 "user.vala"
			click_user_regain_privileges (self);
#line 5780 "user.c"
		}
#line 769 "user.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 769 "user.vala"
			g_propagate_error (error, _inner_error0_);
#line 769 "user.vala"
			_g_free0 (target);
#line 769 "user.vala"
			_g_free0 (old_version);
#line 769 "user.vala"
			_g_free0 (path);
#line 769 "user.vala"
			_g_free0 (user_db);
#line 769 "user.vala"
			return;
#line 5796 "user.c"
		}
#line 765 "user.vala"
		_g_free0 (target);
#line 5800 "user.c"
	} else {
		{
			gchar* _tmp10_ = NULL;
			gchar* _tmp11_;
			gchar* _tmp12_;
#line 778 "user.vala"
			_tmp11_ = click_user_get_version (self, package, &_inner_error0_);
#line 778 "user.vala"
			_tmp10_ = _tmp11_;
#line 778 "user.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 778 "user.vala"
				if (_inner_error0_->domain == CLICK_USER_ERROR) {
#line 5814 "user.c"
					goto __catch1_click_user_error;
				}
#line 778 "user.vala"
				_g_free0 (old_version);
#line 778 "user.vala"
				_g_free0 (path);
#line 778 "user.vala"
				_g_free0 (user_db);
#line 778 "user.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 778 "user.vala"
				g_clear_error (&_inner_error0_);
#line 778 "user.vala"
				return;
#line 5829 "user.c"
			}
#line 778 "user.vala"
			_tmp12_ = _tmp10_;
#line 778 "user.vala"
			_tmp10_ = NULL;
#line 778 "user.vala"
			_g_free0 (old_version);
#line 778 "user.vala"
			old_version = _tmp12_;
#line 777 "user.vala"
			_g_free0 (_tmp10_);
#line 5841 "user.c"
		}
		goto __finally1;
		__catch1_click_user_error:
		{
			const gchar* _tmp13_;
			GError* _tmp14_;
#line 777 "user.vala"
			g_clear_error (&_inner_error0_);
#line 780 "user.vala"
			_tmp13_ = self->priv->_name;
#line 780 "user.vala"
			_tmp14_ = g_error_new (CLICK_USER_ERROR, CLICK_USER_ERROR_NO_SUCH_PACKAGE, "%s does not exist in any database " "for user %s", package, _tmp13_);
#line 780 "user.vala"
			_inner_error0_ = _tmp14_;
#line 5856 "user.c"
			goto __finally1;
		}
		__finally1:
#line 777 "user.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 777 "user.vala"
			g_propagate_error (error, _inner_error0_);
#line 777 "user.vala"
			_g_free0 (old_version);
#line 777 "user.vala"
			_g_free0 (path);
#line 777 "user.vala"
			_g_free0 (user_db);
#line 777 "user.vala"
			return;
#line 5872 "user.c"
		}
#line 784 "user.vala"
		click_user_ensure_db (self, &_inner_error0_);
#line 784 "user.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 784 "user.vala"
			g_propagate_error (error, _inner_error0_);
#line 784 "user.vala"
			_g_free0 (old_version);
#line 784 "user.vala"
			_g_free0 (path);
#line 784 "user.vala"
			_g_free0 (user_db);
#line 784 "user.vala"
			return;
#line 5888 "user.c"
		}
#line 785 "user.vala"
		click_user_drop_privileges (self, &_inner_error0_);
#line 785 "user.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 785 "user.vala"
			g_propagate_error (error, _inner_error0_);
#line 785 "user.vala"
			_g_free0 (old_version);
#line 785 "user.vala"
			_g_free0 (path);
#line 785 "user.vala"
			_g_free0 (user_db);
#line 785 "user.vala"
			return;
#line 5904 "user.c"
		}
		{
			const gchar* _tmp15_;
			const gchar* _tmp16_;
#line 788 "user.vala"
			_tmp15_ = old_version;
#line 788 "user.vala"
			click_user_stop_running_apps_for_package (self, package, _tmp15_);
#line 789 "user.vala"
			_tmp16_ = path;
#line 789 "user.vala"
			click_symlink_force (CLICK_HIDDEN_VERSION, _tmp16_, &_inner_error0_);
#line 789 "user.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5919 "user.c"
				goto __finally2;
			}
		}
		__finally2:
		{
			GError* _inner_error1_ = NULL;
#line 791 "user.vala"
			click_user_regain_privileges (self);
#line 5928 "user.c"
		}
#line 786 "user.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 786 "user.vala"
			g_propagate_error (error, _inner_error0_);
#line 786 "user.vala"
			_g_free0 (old_version);
#line 786 "user.vala"
			_g_free0 (path);
#line 786 "user.vala"
			_g_free0 (user_db);
#line 786 "user.vala"
			return;
#line 5942 "user.c"
		}
	}
#line 795 "user.vala"
	_tmp17_ = click_user_get_is_pseudo_user (self);
#line 795 "user.vala"
	_tmp18_ = _tmp17_;
#line 795 "user.vala"
	if (!_tmp18_) {
#line 5951 "user.c"
		ClickDB* _tmp19_;
		const gchar* _tmp20_;
		const gchar* _tmp21_;
#line 796 "user.vala"
		_tmp19_ = self->priv->_db;
#line 796 "user.vala"
		_tmp20_ = old_version;
#line 796 "user.vala"
		_tmp21_ = self->priv->_name;
#line 796 "user.vala"
		click_package_remove_hooks (_tmp19_, package, _tmp20_, _tmp21_, &_inner_error0_);
#line 796 "user.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 796 "user.vala"
			g_propagate_error (error, _inner_error0_);
#line 796 "user.vala"
			_g_free0 (old_version);
#line 796 "user.vala"
			_g_free0 (path);
#line 796 "user.vala"
			_g_free0 (user_db);
#line 796 "user.vala"
			return;
#line 5975 "user.c"
		}
#line 797 "user.vala"
		click_user_package_remove_user_cache (self, package, &_inner_error0_);
#line 797 "user.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 797 "user.vala"
			g_propagate_error (error, _inner_error0_);
#line 797 "user.vala"
			_g_free0 (old_version);
#line 797 "user.vala"
			_g_free0 (path);
#line 797 "user.vala"
			_g_free0 (user_db);
#line 797 "user.vala"
			return;
#line 5991 "user.c"
		}
	}
#line 801 "user.vala"
	_tmp22_ = self->priv->_name;
#line 801 "user.vala"
	if (g_strcmp0 (_tmp22_, CLICK_ALL_USERS) == 0) {
#line 5998 "user.c"
		const gchar* _tmp23_;
#line 802 "user.vala"
		_tmp23_ = old_version;
#line 802 "user.vala"
		click_user_run_user_remove_hooks_for_all_logged_in_users (self, package, _tmp23_, &_inner_error0_);
#line 802 "user.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 802 "user.vala"
			g_propagate_error (error, _inner_error0_);
#line 802 "user.vala"
			_g_free0 (old_version);
#line 802 "user.vala"
			_g_free0 (path);
#line 802 "user.vala"
			_g_free0 (user_db);
#line 802 "user.vala"
			return;
#line 6016 "user.c"
		}
	}
#line 758 "user.vala"
	_g_free0 (old_version);
#line 758 "user.vala"
	_g_free0 (path);
#line 758 "user.vala"
	_g_free0 (user_db);
#line 6025 "user.c"
}

/**
 * get_path:
 * @package: A package name.
 *
 * Returns: The path at which @package is registered for this user.
 */
gchar*
click_user_get_path (ClickUser* self,
                     const gchar* package,
                     GError** error)
{
	const gchar* _tmp29_;
	GError* _tmp30_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 811 "user.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 811 "user.vala"
	g_return_val_if_fail (package != NULL, NULL);
#line 6047 "user.c"
	{
		gint i = 0;
		ClickDB* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
#line 814 "user.vala"
		_tmp0_ = self->priv->_db;
#line 814 "user.vala"
		_tmp1_ = click_db_get_size (_tmp0_);
#line 814 "user.vala"
		_tmp2_ = _tmp1_;
#line 814 "user.vala"
		i = _tmp2_ - 1;
#line 6061 "user.c"
		{
			gboolean _tmp3_ = FALSE;
#line 814 "user.vala"
			_tmp3_ = TRUE;
#line 814 "user.vala"
			while (TRUE) {
#line 6068 "user.c"
				ClickSingleDB* _tmp5_ = NULL;
				ClickDB* _tmp6_;
				ClickSingleDB* _tmp7_;
				gchar* user_db = NULL;
				const gchar* _tmp8_;
				const gchar* _tmp9_;
				const gchar* _tmp10_;
				gchar* _tmp11_;
				gchar* path = NULL;
				const gchar* _tmp12_;
				gchar* _tmp13_;
				const gchar* _tmp14_;
				ClickSingleDB* _tmp18_ = NULL;
				ClickDB* _tmp19_;
				ClickSingleDB* _tmp20_;
				gchar* all_users_db = NULL;
				const gchar* _tmp21_;
				const gchar* _tmp22_;
				gchar* _tmp23_;
				const gchar* _tmp24_;
				gchar* _tmp25_;
				const gchar* _tmp26_;
#line 814 "user.vala"
				if (!_tmp3_) {
#line 6093 "user.c"
					gint _tmp4_;
#line 814 "user.vala"
					i = i - 1;
#line 814 "user.vala"
					_tmp4_ = i;
#line 6099 "user.c"
				}
#line 814 "user.vala"
				_tmp3_ = FALSE;
#line 814 "user.vala"
				if (!(i >= 0)) {
#line 814 "user.vala"
					break;
#line 6107 "user.c"
				}
#line 815 "user.vala"
				_tmp6_ = self->priv->_db;
#line 815 "user.vala"
				_tmp7_ = click_db_get (_tmp6_, i, &_inner_error0_);
#line 815 "user.vala"
				_tmp5_ = _tmp7_;
#line 815 "user.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 815 "user.vala"
					if (_inner_error0_->domain == CLICK_USER_ERROR) {
#line 815 "user.vala"
						g_propagate_error (error, _inner_error0_);
#line 815 "user.vala"
						return NULL;
#line 6123 "user.c"
					} else {
#line 815 "user.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 815 "user.vala"
						g_clear_error (&_inner_error0_);
#line 815 "user.vala"
						return NULL;
#line 6131 "user.c"
					}
				}
#line 815 "user.vala"
				_tmp8_ = click_single_db_get_root (_tmp5_);
#line 815 "user.vala"
				_tmp9_ = _tmp8_;
#line 815 "user.vala"
				_tmp10_ = self->priv->_name;
#line 815 "user.vala"
				_tmp11_ = click_db_for_user (_tmp9_, _tmp10_);
#line 815 "user.vala"
				user_db = _tmp11_;
#line 816 "user.vala"
				_tmp12_ = user_db;
#line 816 "user.vala"
				_tmp13_ = g_build_filename (_tmp12_, package, NULL);
#line 816 "user.vala"
				path = _tmp13_;
#line 817 "user.vala"
				_tmp14_ = path;
#line 817 "user.vala"
				if (click_user_is_valid_link (self, _tmp14_)) {
#line 818 "user.vala"
					result = path;
#line 818 "user.vala"
					_g_free0 (user_db);
#line 818 "user.vala"
					_g_object_unref0 (_tmp5_);
#line 818 "user.vala"
					return result;
#line 6162 "user.c"
				} else {
					const gchar* _tmp15_;
#line 819 "user.vala"
					_tmp15_ = path;
#line 819 "user.vala"
					if (click_is_symlink (_tmp15_)) {
#line 6169 "user.c"
						const gchar* _tmp16_;
						GError* _tmp17_;
#line 820 "user.vala"
						_tmp16_ = self->priv->_name;
#line 820 "user.vala"
						_tmp17_ = g_error_new (CLICK_USER_ERROR, CLICK_USER_ERROR_HIDDEN_PACKAGE, "%s is hidden for user %s", package, _tmp16_);
#line 820 "user.vala"
						_inner_error0_ = _tmp17_;
#line 820 "user.vala"
						if (_inner_error0_->domain == CLICK_USER_ERROR) {
#line 820 "user.vala"
							g_propagate_error (error, _inner_error0_);
#line 820 "user.vala"
							_g_free0 (path);
#line 820 "user.vala"
							_g_free0 (user_db);
#line 820 "user.vala"
							_g_object_unref0 (_tmp5_);
#line 820 "user.vala"
							return NULL;
#line 6190 "user.c"
						} else {
#line 820 "user.vala"
							_g_free0 (path);
#line 820 "user.vala"
							_g_free0 (user_db);
#line 820 "user.vala"
							_g_object_unref0 (_tmp5_);
#line 820 "user.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 820 "user.vala"
							g_clear_error (&_inner_error0_);
#line 820 "user.vala"
							return NULL;
#line 6204 "user.c"
						}
					}
				}
#line 824 "user.vala"
				_tmp19_ = self->priv->_db;
#line 824 "user.vala"
				_tmp20_ = click_db_get (_tmp19_, i, &_inner_error0_);
#line 824 "user.vala"
				_tmp18_ = _tmp20_;
#line 824 "user.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 824 "user.vala"
					if (_inner_error0_->domain == CLICK_USER_ERROR) {
#line 824 "user.vala"
						g_propagate_error (error, _inner_error0_);
#line 824 "user.vala"
						_g_free0 (path);
#line 824 "user.vala"
						_g_free0 (user_db);
#line 824 "user.vala"
						_g_object_unref0 (_tmp5_);
#line 824 "user.vala"
						return NULL;
#line 6228 "user.c"
					} else {
#line 824 "user.vala"
						_g_free0 (path);
#line 824 "user.vala"
						_g_free0 (user_db);
#line 824 "user.vala"
						_g_object_unref0 (_tmp5_);
#line 824 "user.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 824 "user.vala"
						g_clear_error (&_inner_error0_);
#line 824 "user.vala"
						return NULL;
#line 6242 "user.c"
					}
				}
#line 824 "user.vala"
				_tmp21_ = click_single_db_get_root (_tmp18_);
#line 824 "user.vala"
				_tmp22_ = _tmp21_;
#line 824 "user.vala"
				_tmp23_ = click_db_for_user (_tmp22_, CLICK_ALL_USERS);
#line 824 "user.vala"
				all_users_db = _tmp23_;
#line 825 "user.vala"
				_tmp24_ = all_users_db;
#line 825 "user.vala"
				_tmp25_ = g_build_filename (_tmp24_, package, NULL);
#line 825 "user.vala"
				_g_free0 (path);
#line 825 "user.vala"
				path = _tmp25_;
#line 826 "user.vala"
				_tmp26_ = path;
#line 826 "user.vala"
				if (click_user_is_valid_link (self, _tmp26_)) {
#line 827 "user.vala"
					result = path;
#line 827 "user.vala"
					_g_free0 (all_users_db);
#line 827 "user.vala"
					_g_object_unref0 (_tmp18_);
#line 827 "user.vala"
					_g_free0 (user_db);
#line 827 "user.vala"
					_g_object_unref0 (_tmp5_);
#line 827 "user.vala"
					return result;
#line 6277 "user.c"
				} else {
					const gchar* _tmp27_;
#line 828 "user.vala"
					_tmp27_ = path;
#line 828 "user.vala"
					if (click_is_symlink (_tmp27_)) {
#line 6284 "user.c"
						GError* _tmp28_;
#line 829 "user.vala"
						_tmp28_ = g_error_new (CLICK_USER_ERROR, CLICK_USER_ERROR_HIDDEN_PACKAGE, "%s is hidden for all users", package);
#line 829 "user.vala"
						_inner_error0_ = _tmp28_;
#line 829 "user.vala"
						if (_inner_error0_->domain == CLICK_USER_ERROR) {
#line 829 "user.vala"
							g_propagate_error (error, _inner_error0_);
#line 829 "user.vala"
							_g_free0 (all_users_db);
#line 829 "user.vala"
							_g_object_unref0 (_tmp18_);
#line 829 "user.vala"
							_g_free0 (path);
#line 829 "user.vala"
							_g_free0 (user_db);
#line 829 "user.vala"
							_g_object_unref0 (_tmp5_);
#line 829 "user.vala"
							return NULL;
#line 6306 "user.c"
						} else {
#line 829 "user.vala"
							_g_free0 (all_users_db);
#line 829 "user.vala"
							_g_object_unref0 (_tmp18_);
#line 829 "user.vala"
							_g_free0 (path);
#line 829 "user.vala"
							_g_free0 (user_db);
#line 829 "user.vala"
							_g_object_unref0 (_tmp5_);
#line 829 "user.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 829 "user.vala"
							g_clear_error (&_inner_error0_);
#line 829 "user.vala"
							return NULL;
#line 6324 "user.c"
						}
					}
				}
#line 814 "user.vala"
				_g_free0 (all_users_db);
#line 814 "user.vala"
				_g_object_unref0 (_tmp18_);
#line 814 "user.vala"
				_g_free0 (path);
#line 814 "user.vala"
				_g_free0 (user_db);
#line 814 "user.vala"
				_g_object_unref0 (_tmp5_);
#line 6338 "user.c"
			}
		}
	}
#line 834 "user.vala"
	_tmp29_ = self->priv->_name;
#line 834 "user.vala"
	_tmp30_ = g_error_new (CLICK_USER_ERROR, CLICK_USER_ERROR_NO_SUCH_PACKAGE, "%s does not exist in any database for user %s", package, _tmp29_);
#line 834 "user.vala"
	_inner_error0_ = _tmp30_;
#line 834 "user.vala"
	if (_inner_error0_->domain == CLICK_USER_ERROR) {
#line 834 "user.vala"
		g_propagate_error (error, _inner_error0_);
#line 834 "user.vala"
		return NULL;
#line 6354 "user.c"
	} else {
#line 834 "user.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 834 "user.vala"
		g_clear_error (&_inner_error0_);
#line 834 "user.vala"
		return NULL;
#line 6362 "user.c"
	}
}

/**
 * get_manifest:
 * @package: A package name.
 *
 * Returns: A #Json.Object containing a package's manifest.
 *
 * Since: 0.4.18
 */
JsonObject*
click_user_get_manifest (ClickUser* self,
                         const gchar* package,
                         GError** error)
{
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	JsonObject* obj = NULL;
	ClickDB* _tmp2_;
	JsonObject* _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	JsonObject* _tmp6_;
	gint _tmp7_ = 0;
	JsonObject* _tmp8_;
	GError* _inner_error0_ = NULL;
	JsonObject* result;
#line 847 "user.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 847 "user.vala"
	g_return_val_if_fail (package != NULL, NULL);
#line 850 "user.vala"
	_tmp1_ = click_user_get_version (self, package, &_inner_error0_);
#line 850 "user.vala"
	_tmp0_ = _tmp1_;
#line 850 "user.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 850 "user.vala"
		g_propagate_error (error, _inner_error0_);
#line 850 "user.vala"
		return NULL;
#line 6405 "user.c"
	}
#line 850 "user.vala"
	_tmp2_ = self->priv->_db;
#line 850 "user.vala"
	_tmp3_ = click_db_get_manifest (_tmp2_, package, _tmp0_, &_inner_error0_);
#line 850 "user.vala"
	obj = _tmp3_;
#line 850 "user.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 850 "user.vala"
		g_propagate_error (error, _inner_error0_);
#line 850 "user.vala"
		_g_free0 (_tmp0_);
#line 850 "user.vala"
		return NULL;
#line 6421 "user.c"
	}
#line 852 "user.vala"
	_tmp5_ = click_user_get_path (self, package, &_inner_error0_);
#line 852 "user.vala"
	_tmp4_ = _tmp5_;
#line 852 "user.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 852 "user.vala"
		g_propagate_error (error, _inner_error0_);
#line 852 "user.vala"
		_json_object_unref0 (obj);
#line 852 "user.vala"
		_g_free0 (_tmp0_);
#line 852 "user.vala"
		return NULL;
#line 6437 "user.c"
	}
#line 852 "user.vala"
	_tmp6_ = obj;
#line 852 "user.vala"
	json_object_set_string_member (_tmp6_, "_directory", _tmp4_);
#line 858 "user.vala"
	if (click_user_is_removable (self, package)) {
#line 858 "user.vala"
		_tmp7_ = 1;
#line 6447 "user.c"
	} else {
#line 858 "user.vala"
		_tmp7_ = 0;
#line 6451 "user.c"
	}
#line 857 "user.vala"
	_tmp8_ = obj;
#line 857 "user.vala"
	json_object_set_int_member (_tmp8_, "_removable", (gint64) _tmp7_);
#line 859 "user.vala"
	result = obj;
#line 859 "user.vala"
	_g_free0 (_tmp4_);
#line 859 "user.vala"
	_g_free0 (_tmp0_);
#line 859 "user.vala"
	return result;
#line 6465 "user.c"
}

/**
 * get_manifest_as_string:
 * @package: A package name.
 *
 * Returns: A JSON string containing a package's serialised
 * manifest.
 * This interface may be useful for clients with their own JSON
 * parsing tools that produce representations more convenient for
 * them.
 *
 * Since: 0.4.21
 */
static void
_vala_JsonNode_free (JsonNode* self)
{
#line 882 "user.vala"
	g_boxed_free (json_node_get_type (), self);
#line 6485 "user.c"
}

gchar*
click_user_get_manifest_as_string (ClickUser* self,
                                   const gchar* package,
                                   GError** error)
{
	JsonObject* manifest = NULL;
	JsonObject* _tmp0_;
	JsonNode* node = NULL;
	JsonNode* _tmp1_;
	JsonNode* _tmp2_;
	JsonGenerator* generator = NULL;
	JsonGenerator* _tmp3_;
	JsonGenerator* _tmp4_;
	JsonNode* _tmp5_;
	JsonGenerator* _tmp6_;
	gchar* _tmp7_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 874 "user.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 874 "user.vala"
	g_return_val_if_fail (package != NULL, NULL);
#line 877 "user.vala"
	_tmp0_ = click_user_get_manifest (self, package, &_inner_error0_);
#line 877 "user.vala"
	manifest = _tmp0_;
#line 877 "user.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 877 "user.vala"
		g_propagate_error (error, _inner_error0_);
#line 877 "user.vala"
		return NULL;
#line 6520 "user.c"
	}
#line 878 "user.vala"
	_tmp1_ = json_node_new (JSON_NODE_OBJECT);
#line 878 "user.vala"
	node = _tmp1_;
#line 879 "user.vala"
	_tmp2_ = node;
#line 879 "user.vala"
	json_node_set_object (_tmp2_, manifest);
#line 880 "user.vala"
	_tmp3_ = json_generator_new ();
#line 880 "user.vala"
	generator = _tmp3_;
#line 881 "user.vala"
	_tmp4_ = generator;
#line 881 "user.vala"
	_tmp5_ = node;
#line 881 "user.vala"
	json_generator_set_root (_tmp4_, _tmp5_);
#line 882 "user.vala"
	_tmp6_ = generator;
#line 882 "user.vala"
	_tmp7_ = json_generator_to_data (_tmp6_, NULL);
#line 882 "user.vala"
	result = _tmp7_;
#line 882 "user.vala"
	_g_object_unref0 (generator);
#line 882 "user.vala"
	__vala_JsonNode_free0 (node);
#line 882 "user.vala"
	_json_object_unref0 (manifest);
#line 882 "user.vala"
	return result;
#line 6554 "user.c"
}

/**
 * get_manifests:
 *
 * Returns: A #Json.Array containing manifests of all packages
 * registered for this user.  The manifest may include additional
 * dynamic keys (starting with an underscore) corresponding to
 * dynamic properties of installed packages.
 *
 * Since: 0.4.18
 */
JsonArray*
click_user_get_manifests (ClickUser* self,
                          GError** error)
{
	JsonArray* ret = NULL;
	JsonArray* _tmp0_;
	GList* _tmp1_ = NULL;
	GList* _tmp2_;
	GError* _inner_error0_ = NULL;
	JsonArray* result;
#line 895 "user.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 898 "user.vala"
	_tmp0_ = json_array_new ();
#line 898 "user.vala"
	ret = _tmp0_;
#line 899 "user.vala"
	_tmp2_ = click_user_get_package_names (self, &_inner_error0_);
#line 899 "user.vala"
	_tmp1_ = _tmp2_;
#line 899 "user.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 899 "user.vala"
		g_propagate_error (error, _inner_error0_);
#line 899 "user.vala"
		_json_array_unref0 (ret);
#line 899 "user.vala"
		return NULL;
#line 6595 "user.c"
	}
	{
		GList* package_collection = NULL;
		GList* package_it = NULL;
#line 899 "user.vala"
		package_collection = _tmp1_;
#line 899 "user.vala"
		for (package_it = package_collection; package_it != NULL; package_it = package_it->next) {
#line 6604 "user.c"
			gchar* _tmp3_;
			gchar* package = NULL;
#line 899 "user.vala"
			_tmp3_ = g_strdup ((const gchar*) package_it->data);
#line 899 "user.vala"
			package = _tmp3_;
#line 6611 "user.c"
			{
				{
					JsonObject* _tmp4_ = NULL;
					const gchar* _tmp5_;
					JsonObject* _tmp6_;
					JsonObject* _tmp7_;
#line 902 "user.vala"
					_tmp5_ = package;
#line 902 "user.vala"
					_tmp6_ = click_user_get_manifest (self, _tmp5_, &_inner_error0_);
#line 902 "user.vala"
					_tmp4_ = _tmp6_;
#line 902 "user.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6626 "user.c"
						goto __catch0_g_error;
					}
#line 901 "user.vala"
					_tmp7_ = _tmp4_;
#line 901 "user.vala"
					_tmp4_ = NULL;
#line 901 "user.vala"
					json_array_add_object_element (ret, _tmp7_);
#line 900 "user.vala"
					_json_object_unref0 (_tmp4_);
#line 6637 "user.c"
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* e = NULL;
					GError* _tmp8_;
					const gchar* _tmp9_;
#line 900 "user.vala"
					e = _inner_error0_;
#line 900 "user.vala"
					_inner_error0_ = NULL;
#line 904 "user.vala"
					_tmp8_ = e;
#line 904 "user.vala"
					_tmp9_ = _tmp8_->message;
#line 904 "user.vala"
					g_warning ("user.vala:904: %s", _tmp9_);
#line 900 "user.vala"
					_g_error_free0 (e);
#line 6657 "user.c"
				}
				__finally0:
#line 900 "user.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 900 "user.vala"
					g_propagate_error (error, _inner_error0_);
#line 900 "user.vala"
					_g_free0 (package);
#line 900 "user.vala"
					(_tmp1_ == NULL) ? NULL : (_tmp1_ = (_g_list_free__g_free0_ (_tmp1_), NULL));
#line 900 "user.vala"
					_json_array_unref0 (ret);
#line 900 "user.vala"
					return NULL;
#line 6672 "user.c"
				}
#line 899 "user.vala"
				_g_free0 (package);
#line 6676 "user.c"
			}
		}
	}
#line 907 "user.vala"
	result = ret;
#line 907 "user.vala"
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (_g_list_free__g_free0_ (_tmp1_), NULL));
#line 907 "user.vala"
	return result;
#line 6686 "user.c"
}

/**
 * get_manifests_as_string:
 *
 * Returns: A JSON string containing a serialised array of manifests
 * of all packages registered for this user.  The manifest may
 * include additional dynamic keys (starting with an underscore)
 * corresponding to dynamic properties of installed packages.
 * This interface may be useful for clients with their own JSON
 * parsing tools that produce representations more convenient for
 * them.
 *
 * Since: 0.4.21
 */
gchar*
click_user_get_manifests_as_string (ClickUser* self,
                                    GError** error)
{
	JsonArray* manifests = NULL;
	JsonArray* _tmp0_;
	JsonNode* node = NULL;
	JsonNode* _tmp1_;
	JsonNode* _tmp2_;
	JsonGenerator* generator = NULL;
	JsonGenerator* _tmp3_;
	JsonGenerator* _tmp4_;
	JsonNode* _tmp5_;
	JsonGenerator* _tmp6_;
	gchar* _tmp7_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 923 "user.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 926 "user.vala"
	_tmp0_ = click_user_get_manifests (self, &_inner_error0_);
#line 926 "user.vala"
	manifests = _tmp0_;
#line 926 "user.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 926 "user.vala"
		g_propagate_error (error, _inner_error0_);
#line 926 "user.vala"
		return NULL;
#line 6731 "user.c"
	}
#line 927 "user.vala"
	_tmp1_ = json_node_new (JSON_NODE_ARRAY);
#line 927 "user.vala"
	node = _tmp1_;
#line 928 "user.vala"
	_tmp2_ = node;
#line 928 "user.vala"
	json_node_set_array (_tmp2_, manifests);
#line 929 "user.vala"
	_tmp3_ = json_generator_new ();
#line 929 "user.vala"
	generator = _tmp3_;
#line 930 "user.vala"
	_tmp4_ = generator;
#line 930 "user.vala"
	_tmp5_ = node;
#line 930 "user.vala"
	json_generator_set_root (_tmp4_, _tmp5_);
#line 931 "user.vala"
	_tmp6_ = generator;
#line 931 "user.vala"
	_tmp7_ = json_generator_to_data (_tmp6_, NULL);
#line 931 "user.vala"
	result = _tmp7_;
#line 931 "user.vala"
	_g_object_unref0 (generator);
#line 931 "user.vala"
	__vala_JsonNode_free0 (node);
#line 931 "user.vala"
	_json_array_unref0 (manifests);
#line 931 "user.vala"
	return result;
#line 6765 "user.c"
}

/**
 * is_removable:
 * @package: A package name.
 *
 * Returns: True if @package is removable for this user, otherwise
 * False.
 */
gboolean
click_user_is_removable (ClickUser* self,
                         const gchar* package)
{
	gchar* user_db = NULL;
	gchar* _tmp0_;
	gchar* path = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* all_users_db = NULL;
	ClickDB* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	gboolean result;
#line 941 "user.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 941 "user.vala"
	g_return_val_if_fail (package != NULL, FALSE);
#line 944 "user.vala"
	_tmp0_ = click_user_get_overlay_db (self);
#line 944 "user.vala"
	user_db = _tmp0_;
#line 945 "user.vala"
	_tmp1_ = user_db;
#line 945 "user.vala"
	_tmp2_ = g_build_filename (_tmp1_, package, NULL);
#line 945 "user.vala"
	path = _tmp2_;
#line 946 "user.vala"
	_tmp3_ = path;
#line 946 "user.vala"
	if (click_exists (_tmp3_)) {
#line 947 "user.vala"
		result = TRUE;
#line 947 "user.vala"
		_g_free0 (path);
#line 947 "user.vala"
		_g_free0 (user_db);
#line 947 "user.vala"
		return result;
#line 6820 "user.c"
	} else {
		const gchar* _tmp4_;
#line 948 "user.vala"
		_tmp4_ = path;
#line 948 "user.vala"
		if (click_is_symlink (_tmp4_)) {
#line 950 "user.vala"
			result = FALSE;
#line 950 "user.vala"
			_g_free0 (path);
#line 950 "user.vala"
			_g_free0 (user_db);
#line 950 "user.vala"
			return result;
#line 6835 "user.c"
		}
	}
#line 951 "user.vala"
	_tmp5_ = self->priv->_db;
#line 951 "user.vala"
	_tmp6_ = click_db_get_overlay (_tmp5_);
#line 951 "user.vala"
	_tmp7_ = _tmp6_;
#line 951 "user.vala"
	_tmp8_ = click_db_for_user (_tmp7_, CLICK_ALL_USERS);
#line 951 "user.vala"
	all_users_db = _tmp8_;
#line 952 "user.vala"
	_tmp9_ = all_users_db;
#line 952 "user.vala"
	_tmp10_ = g_build_filename (_tmp9_, package, NULL);
#line 952 "user.vala"
	_g_free0 (path);
#line 952 "user.vala"
	path = _tmp10_;
#line 953 "user.vala"
	_tmp11_ = path;
#line 953 "user.vala"
	if (click_user_is_valid_link (self, _tmp11_)) {
#line 954 "user.vala"
		result = TRUE;
#line 954 "user.vala"
		_g_free0 (all_users_db);
#line 954 "user.vala"
		_g_free0 (path);
#line 954 "user.vala"
		_g_free0 (user_db);
#line 954 "user.vala"
		return result;
#line 6870 "user.c"
	} else {
		const gchar* _tmp12_;
#line 955 "user.vala"
		_tmp12_ = path;
#line 955 "user.vala"
		if (click_is_symlink (_tmp12_)) {
#line 957 "user.vala"
			result = FALSE;
#line 957 "user.vala"
			_g_free0 (all_users_db);
#line 957 "user.vala"
			_g_free0 (path);
#line 957 "user.vala"
			_g_free0 (user_db);
#line 957 "user.vala"
			return result;
#line 6887 "user.c"
		}
	}
#line 958 "user.vala"
	if (click_user_has_package_name (self, package)) {
#line 960 "user.vala"
		result = TRUE;
#line 960 "user.vala"
		_g_free0 (all_users_db);
#line 960 "user.vala"
		_g_free0 (path);
#line 960 "user.vala"
		_g_free0 (user_db);
#line 960 "user.vala"
		return result;
#line 6902 "user.c"
	} else {
#line 962 "user.vala"
		result = FALSE;
#line 962 "user.vala"
		_g_free0 (all_users_db);
#line 962 "user.vala"
		_g_free0 (path);
#line 962 "user.vala"
		_g_free0 (user_db);
#line 962 "user.vala"
		return result;
#line 6914 "user.c"
	}
}

static ClickDB*
click_user_get_db (ClickUser* self)
{
	ClickDB* result;
	ClickDB* _tmp0_;
#line 255 "user.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 255 "user.vala"
	_tmp0_ = self->priv->_db;
#line 255 "user.vala"
	result = _tmp0_;
#line 255 "user.vala"
	return result;
#line 6931 "user.c"
}

static void
click_user_set_db (ClickUser* self,
                   ClickDB* value)
{
	ClickDB* old_value;
#line 255 "user.vala"
	g_return_if_fail (self != NULL);
#line 255 "user.vala"
	old_value = click_user_get_db (self);
#line 255 "user.vala"
	if (old_value != value) {
#line 6945 "user.c"
		ClickDB* _tmp0_;
#line 255 "user.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 255 "user.vala"
		_g_object_unref0 (self->priv->_db);
#line 255 "user.vala"
		self->priv->_db = _tmp0_;
#line 255 "user.vala"
		g_object_notify_by_pspec ((GObject *) self, click_user_properties[CLICK_USER_DB_PROPERTY]);
#line 6955 "user.c"
	}
}

static const gchar*
click_user_get_name (ClickUser* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 256 "user.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 256 "user.vala"
	_tmp0_ = self->priv->_name;
#line 256 "user.vala"
	result = _tmp0_;
#line 256 "user.vala"
	return result;
#line 6972 "user.c"
}

static void
click_user_set_name (ClickUser* self,
                     const gchar* value)
{
	gchar* old_value;
#line 256 "user.vala"
	g_return_if_fail (self != NULL);
#line 256 "user.vala"
	old_value = click_user_get_name (self);
#line 256 "user.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 6986 "user.c"
		gchar* _tmp0_;
#line 256 "user.vala"
		_tmp0_ = g_strdup (value);
#line 256 "user.vala"
		_g_free0 (self->priv->_name);
#line 256 "user.vala"
		self->priv->_name = _tmp0_;
#line 256 "user.vala"
		g_object_notify_by_pspec ((GObject *) self, click_user_properties[CLICK_USER_NAME_PROPERTY]);
#line 6996 "user.c"
	}
}

gboolean
click_user_get_is_pseudo_user (ClickUser* self)
{
	gboolean result;
	const gchar* _tmp0_;
#line 298 "user.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 298 "user.vala"
	_tmp0_ = self->priv->_name;
#line 298 "user.vala"
	result = g_str_has_prefix (_tmp0_, "@");
#line 298 "user.vala"
	return result;
#line 7013 "user.c"
}

gboolean
click_user_get_is_gc_in_use (ClickUser* self)
{
	gboolean result;
	const gchar* _tmp0_;
#line 304 "user.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 304 "user.vala"
	_tmp0_ = self->priv->_name;
#line 304 "user.vala"
	result = g_strcmp0 (_tmp0_, CLICK_GC_IN_USE_USER) == 0;
#line 304 "user.vala"
	return result;
#line 7029 "user.c"
}

static void
click_user_class_init (ClickUserClass * klass,
                       gpointer klass_data)
{
#line 254 "user.vala"
	click_user_parent_class = g_type_class_peek_parent (klass);
#line 254 "user.vala"
	g_type_class_adjust_private_offset (klass, &ClickUser_private_offset);
#line 254 "user.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_click_user_get_property;
#line 254 "user.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_click_user_set_property;
#line 254 "user.vala"
	G_OBJECT_CLASS (klass)->finalize = click_user_finalize;
#line 254 "user.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLICK_USER_DB_PROPERTY, click_user_properties[CLICK_USER_DB_PROPERTY] = g_param_spec_object ("db", "db", "db", CLICK_TYPE_DB, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 254 "user.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLICK_USER_NAME_PROPERTY, click_user_properties[CLICK_USER_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 7050 "user.c"
	/**
	 * True if and only if this user is a pseudo-user.
	 */
#line 254 "user.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLICK_USER_IS_PSEUDO_USER_PROPERTY, click_user_properties[CLICK_USER_IS_PSEUDO_USER_PROPERTY] = g_param_spec_boolean ("is-pseudo-user", "is-pseudo-user", "is-pseudo-user", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 7056 "user.c"
	/**
	 * True if and only if this user is the pseudo-user indicating that
	 * a registration was in use at the time of package removal.
	 */
#line 254 "user.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLICK_USER_IS_GC_IN_USE_PROPERTY, click_user_properties[CLICK_USER_IS_GC_IN_USE_PROPERTY] = g_param_spec_boolean ("is-gc-in-use", "is-gc-in-use", "is-gc-in-use", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 7063 "user.c"
}

static void
click_user_instance_init (ClickUser * self,
                          gpointer klass)
{
#line 254 "user.vala"
	self->priv = click_user_get_instance_private (self);
#line 7072 "user.c"
}

static void
click_user_finalize (GObject * obj)
{
	ClickUser * self;
#line 254 "user.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CLICK_TYPE_USER, ClickUser);
#line 255 "user.vala"
	_g_object_unref0 (self->priv->_db);
#line 256 "user.vala"
	_g_free0 (self->priv->_name);
#line 258 "user.vala"
	_g_object_unref0 (self->priv->users);
#line 259 "user.vala"
	_g_object_unref0 (self->priv->user_pw);
#line 261 "user.vala"
	_g_free0 (self->priv->old_umask);
#line 254 "user.vala"
	G_OBJECT_CLASS (click_user_parent_class)->finalize (obj);
#line 7093 "user.c"
}

static GType
click_user_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ClickUserClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) click_user_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ClickUser), 0, (GInstanceInitFunc) click_user_instance_init, NULL };
	GType click_user_type_id;
	click_user_type_id = g_type_register_static (G_TYPE_OBJECT, "ClickUser", &g_define_type_info, 0);
	ClickUser_private_offset = g_type_add_instance_private (click_user_type_id, sizeof (ClickUserPrivate));
	return click_user_type_id;
}

GType
click_user_get_type (void)
{
	static volatile gsize click_user_type_id__once = 0;
	if (g_once_init_enter (&click_user_type_id__once)) {
		GType click_user_type_id;
		click_user_type_id = click_user_get_type_once ();
		g_once_init_leave (&click_user_type_id__once, click_user_type_id);
	}
	return click_user_type_id__once;
}

static void
_vala_click_user_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	ClickUser * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CLICK_TYPE_USER, ClickUser);
#line 254 "user.vala"
	switch (property_id) {
#line 254 "user.vala"
		case CLICK_USER_DB_PROPERTY:
#line 254 "user.vala"
		g_value_set_object (value, click_user_get_db (self));
#line 254 "user.vala"
		break;
#line 254 "user.vala"
		case CLICK_USER_NAME_PROPERTY:
#line 254 "user.vala"
		g_value_set_string (value, click_user_get_name (self));
#line 254 "user.vala"
		break;
#line 254 "user.vala"
		case CLICK_USER_IS_PSEUDO_USER_PROPERTY:
#line 254 "user.vala"
		g_value_set_boolean (value, click_user_get_is_pseudo_user (self));
#line 254 "user.vala"
		break;
#line 254 "user.vala"
		case CLICK_USER_IS_GC_IN_USE_PROPERTY:
#line 254 "user.vala"
		g_value_set_boolean (value, click_user_get_is_gc_in_use (self));
#line 254 "user.vala"
		break;
#line 7152 "user.c"
		default:
#line 254 "user.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 254 "user.vala"
		break;
#line 7158 "user.c"
	}
}

static void
_vala_click_user_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec)
{
	ClickUser * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CLICK_TYPE_USER, ClickUser);
#line 254 "user.vala"
	switch (property_id) {
#line 254 "user.vala"
		case CLICK_USER_DB_PROPERTY:
#line 254 "user.vala"
		click_user_set_db (self, g_value_get_object (value));
#line 254 "user.vala"
		break;
#line 254 "user.vala"
		case CLICK_USER_NAME_PROPERTY:
#line 254 "user.vala"
		click_user_set_name (self, g_value_get_string (value));
#line 254 "user.vala"
		break;
#line 7184 "user.c"
		default:
#line 254 "user.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 254 "user.vala"
		break;
#line 7190 "user.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

